#!/usr/bin/env python
# -*- coding: utf-8 -*-

#***************************************************************************
#*   Copyright (C) 2008-2008 by Steve Walter                               *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation; either version 3 of the License, or     *
#*   (at your option) any later version.                                   *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program; if not, write to the                         *
#*   Free Software Foundation, Inc.,                                       *
#*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
#***************************************************************************


import os
import string
import tkMessageBox
import Mittel_T
import shutil
import platform
import commands

from string import *
from tkMessageBox import *
from Mittel_T import *
from shutil import *

class CCalc:
    def __init__(self,  Main):
        self.Main = Main
        self.OutFileName = ''
        self.nEbenen = 0
        
        #Welches Betriebssystem
        self.OS  = platform.system()
        self.CPU = platform.machine()

	#Pfad in dem das Programm ausgeführt wird ermitteln
	self.exePath = os.path.abspath(os.path.dirname(sys.argv[0]))
	self.exePath = os.path.normpath(self.exePath)
        
        self.ResetReadStatus()

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def AllRead(self):
        if self.bStufenCalc and self.bDrawCalc and self.bKanalCalc and self.bVerlaufCalc:
            self.bAllRead = True
    
    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def ResetReadStatus(self):
        self.bStufenCalc = False
        self.bDrawCalc    = False
        self.bKanalCalc   = False
        self.bVerlaufCalc = False
        self.bAllRead         = False
    
    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def ShowFile(self,  Datei):
        print Datei
        #Datei vorhanden?
        if (not os.path.exists(Datei)):
            return

        #Plattform ermitteln
        if self.OS == 'Linux':
		kwriteBool = False
		lessBool = False
		
		if commands.getoutput('which kwrite')[0:5] != "which": kwriteBool = True
		if commands.getoutput('which less')[0:5] != "which": lessBool = True

		#Sinnvoller Linux Texteditor
		if os.getenv("VISUAL") != None:
			os.popen2('$VISUAL ' + '"' + Datei + '"')
		elif kwriteBool == True:
			os.popen2('kwrite ' + '"' + Datei + '"')
		elif os.getenv("PAGER") != None:
			os.popen2('$TERM -e $PAGER ' + '"' + Datei + '"')
		elif lessBool == True:
			os.popen2('$TERM -e less ' + '"' + Datei + '"')
		else:
			os.popen2('$TERM -e ' + "'cat " + '"' + Datei + '"' + " && cd && $SHELL'")
		
        elif self.OS == 'Windows':
		os.popen2('notepad ' + '"' + Datei + '"')
    
    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def DoCalc(self):
	arbeitsVerzeichnis = os.path.dirname(self.Main.IO.FilePath)
	rechnungsName = os.path.splitext(os.path.basename(self.Main.IO.FilePath))[0]
	
	eingabeName = rechnungsName+".tve"
	self.OutFileName = rechnungsName+".tva"
	
	#Windows oder Unix?
	if self.OS == 'Linux':
		if self.CPU == 'i686':
			Cmd = os.path.join(self.exePath,'mittel32')
		else:
			#ich nehme an 64-bit CPU
			Cmd = os.path.join(self.exePath,'mittel64')
			
	elif self.OS == 'Windows':
		Cmd = os.path.join(self.exePath,'mittel32.exe')
	
	os.chdir(arbeitsVerzeichnis)

	Cmd = '"' + Cmd + '"' + ' ' + eingabeName + ' ' + self.OutFileName
	
	#Ausführen
	iResult = os.system(Cmd)
	
	if iResult != 0:
		showerror('Fehler',  'Es ist ein Fehler bei der Verarbeitung aufgetreten')
		return False
	
	#Hinweis: Vielleicht kann man das hier noch ändern @.@
	showinfo('Fertig',  'Die Rechnung ist jetzt beendet und die Ergebnisse können jetzt eingesehen werden')
	
	self.ResetReadStatus()
	return True
    
    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    #Liest die Berechnung aus
    def KanalCalc(self):
        self.bKanalCalc = True
        self.AllRead()
        #Hier steht nix, kann aber noch irgenwann hinzugefügt werden



    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def OpenOutputFile(self):
        Datei = None
        try:
            Datei = open(self.OutFileName,  'r')
        except:
            showerror('Tabelle öffnen', 'Datei der Ergebnistabelle nicht gefunden!')
            return None
        
        return Datei


    
    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def DrawCalc(self):
        #Ausgabedatei öffnen
        pDatei = self.OpenOutputFile()
        
        if pDatei == None:
            return
        
        pVariablen = self.Main.Variablen
        
        #Geschwindigkeiten ausnullen
        for Index in range(10):
            pVariablen.pGeschw[Index].dC = 0.0
            pVariablen.pGeschw[Index].dCax = 0.0
            pVariablen.pGeschw[Index].dCu = 0.0
            pVariablen.pGeschw[Index].dCr = 0.0
            pVariablen.pGeschw[Index].dU = 0.0
            pVariablen.pGeschw[Index].dW = 0.0
            pVariablen.pGeschw[Index].dWax = 0.0
            pVariablen.pGeschw[Index].Wu = 0.0
        
        #Datei in Wörter umwandeln
        Datei = CWordFile(pDatei)
        
        #Ebenenanzahl auslesen
        Datei.FindNext('EBENENZAHL')
        self.nEbenen = int(Datei.Next())
        
        Jump = 0
        #Ebenenwerte überspringen
        while ((not Datei.IsEoF()) and (Jump < self.nEbenen)):
            #self.__Find(Datei,  'EBENE')
            Datei.FindNext('EBENE')
            Jump += 1
        
        #Tempwerte
        nJ = -1
        bWerte = False
        nTafel = 0
        nC = 0
        nCAX = 0
        nCU  = 0
        nCR = 0
        nU   = 0
        nW  = 0
        nWU = 0
        
        #Prüfwerte zusammenstückeln
        #Werte
        NOFLIP = 0
        FLIP = 1
        pVarList = [ 
                    ('C',  'C', NOFLIP) , 
                    ('CU', 'Cu', NOFLIP), 
                    ('CR', 'Cr',  NOFLIP), 
                    ('U',  'U', NOFLIP ), 
                    ('W',  'W',  FLIP), 
                    ('WU',  'Wu',  FLIP), 
                    ]
        
        pstr = ''
        for Name,  Variable,  Flip in pVarList:
            #Müßen die Zuweisungsebenen vertauscht werden?
            strFlip1 = 'nJ-1'
            strFlip2 = 'nJ'
            if Flip == FLIP:
                strFlip1 = 'nJ'
                strFlip2 = 'nJ-1'
            
            #Arbeitspferd
            pstr = '%sif CurWord == "%s":\n'                               % (pstr,  Name)
            pstr = '%s  dValue = float(Datei.Next())\n'                    % (pstr)
            pstr = '%s  if nTafel == 1:\n'                                 % (pstr)
            pstr = '%s      pVariablen.pGeschw[nJ].d%s = dValue\n'         % (pstr, Variable)
            pstr = '%s      bWerte = True\n'                               % (pstr)
            pstr = '%s  else:\n'                                           % (pstr)
            pstr = '%s      if n%s == 0:\n'                                % (pstr,  Name)
            pstr = '%s          pVariablen.pGeschw[%s].d%s = dValue\n'     % (pstr, strFlip1,  Variable)
            pstr = '%s          bWerte = True\n'                           % (pstr)
            pstr = '%s          n%s = 1\n'                                 % (pstr, Name)
            pstr = '%s      else:\n'                                       % (pstr)
            pstr = '%s          pVariablen.pGeschw[%s].d%s = dValue\n'     % (pstr, strFlip2,  Variable)
        
        #Schleife vorbereiten
        CurWord = Datei.Next()
        bEnden = False
        
        #Durch die Zeilen gehen
        while((not bEnden) and (nJ < self.nEbenen)):
            #Durchsatz getroffen
            if CurWord == 'DURCHSATZ':
                #Schleife abbrechen
                bEnden = True
                break
            
            #Neue Ebene angezeigt?
            if CurWord == 'EBENE':
                #Ebenenanzahl anpasssen
                nJ += 1
                #Werte vorhanden? -> reseten
                if bWerte:
                    nTafel = 1
                    bWerte = False
                    nC       = 0
                    nCAX     = 0
                    nCU      = 0
                    nCR      = 0
                    nU       = 0
                    nW       = 0
                    nWU      = 0
                else:
                    nTafel += 1
            
            #Sonderfall
            if CurWord == 'CAX':
                dValue = float(Datei.Next())
                if nTafel == 1:
                   pVariablen.pGeschw[nJ].dCax = dValue
                   pVariablen.pGeschw[nJ].dWax = dValue
                   bWerte = True
                else:
                    if nCAX == 0:
                        pVariablen.pGeschw[nJ-1].dCax = dValue
                        pVariablen.pGeschw[nJ-1].dWax = dValue
                        bWerte = True
                        nCAX = 1
                    else:
                        pVariablen.pGeschw[nJ].dCax = dValue
                        pVariablen.pGeschw[nJ].dWax = dValue
            
            exec pstr
            
            #Weiterschieben
            CurWord = Datei.Next()
            
            if(CurWord == None):
                bEnden = True
        
        bDurchsatzOK = False
        
        #Durchsatz getroffen
        if CurWord == 'DURCHSATZ':
            self.bGeschwOK = False
            bDurchsatzOK = False
        else:
            self.bGeschwOK = True
            bDurchsatzOK = True
        
        #Kein Durchsatz?
        if bDurchsatzOK:
            self.dMaxGeschw = 0.0
            self.dMaxWu = 0.0
            
            #Größten wert suchen
            for Index in range(self.nEbenen):
                self.dMaxGeschw = max(self.dMaxGeschw,  pVariablen.pGeschw[Index].dCax)
                self.dMaxGeschw = max(self.dMaxGeschw,  pVariablen.pGeschw[Index].dCu + pVariablen.pGeschw[Index].dWu)
                self.dMaxWu = max(self.dMaxWu,  pVariablen.pGeschw[Index].dWu)
        else:
            #Fehlermessage
            showerror('Rechenfehler',  'Der Durchsatz ist zu groß!')
        
        #Datei schließen
        pDatei.close()
        
        self.bDrawCalc = True
        self.AllRead()


    
    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def VerlaufCalc(self):
        #Ausgabedatei öffnen
        pDatei = self.OpenOutputFile()
        
        if pDatei == None:
            return
        
        pVariablen = self.Main.Variablen
        
        #Variablen ausnullen
        for Index in range(10):
            pVariablen.pVerlauf[Index].dALP = 0.0
            pVariablen.pVerlauf[Index].dBET = 0.0
            pVariablen.pVerlauf[Index].dKAP = 0.0
            pVariablen.pVerlauf[Index].dMAC = 0.0
            pVariablen.pVerlauf[Index].dMAW = 0.0
            pVariablen.pVerlauf[Index].dP       = 0.0
            pVariablen.pVerlauf[Index].dPT      = 0.0
            pVariablen.pVerlauf[Index].dPTR  = 0.0
            pVariablen.pVerlauf[Index].dT       = 0.0
            pVariablen.pVerlauf[Index].dTT    = 0.0
            pVariablen.pVerlauf[Index].dTTR     = 0.0
            pVariablen.pVerlauf[Index].dL       = 0.0
        
        Datei = CWordFile(pDatei)
        
        #Zeile mit der Ebenenanzahl finden
        Datei.FindNext('EBENENZAHL')
        self.nEbenen = int(Datei.Next())
        
        Jump = 0
        #Ebenenwerte überspringen
        while ((not Datei.IsEoF()) and (Jump < self.nEbenen)):
            Datei.FindNext('EBENE')
            Jump += 1
        
        #Tempwerte
        nJ = -1
        bWerte = False
        bDeltaH = False
        nTafel = 0
        nALPHA = 0
        nBETA = 0
        nKAPPA = 0
        nMAC = 0
        nMAW = 0
        nP = 0
        nPT = 0
        nPTREL = 0
        nT = 0
        nTT = 0
        nTTREL = 0
        nL    = 0
        
        CurWord = Datei.Next()
        bEnden = False
        
        #PrüfungsText zusammenstückeln
        #Werteliste
        dVarList = [
                    ('KAPPA',  'KAP'), 
                    ('MAC',  'MAC'), 
                    ('MAW',  'MAW'), 
                    ('P',  'P'), 
                    ('PT',  'PT'), 
                    ('PTREL',  'PTR'), 
                    ('T',  'T'), 
                    ('TTREL',  'TTR'), 
                    ('L',  'L')
                    ]
        
        pstr = ''
        #Alle Werte aus der Liste überprüfen
        #Das selbe wie die if-Anweisung oben
        for Name,  Variable in dVarList:
            pstr = '%sif CurWord == "%s":\n'                                          % (pstr, Name)
            pstr = '%s  dValue = float(Datei.Next())\n'                               % (pstr)
            pstr = '%s  if nTafel == 1:\n'                                            % (pstr)
            pstr = '%s      pVariablen.pVerlauf[nJ].d%s = dValue\n'                   % (pstr,  Variable)
            pstr = '%s      bWerte = True\n'                                          % (pstr)
            pstr = '%s  else:\n'                                                      % (pstr)
            pstr = '%s      if n%s == 0:\n'                                           % (pstr,  Name)
            pstr = '%s          pVariablen.pVerlauf[nJ-1].d%s = dValue\n'             % (pstr,  Variable)
            pstr = '%s          bWerte = True\n'                                      % (pstr)
            pstr = '%s          n%s = 1\n'                                            % (pstr,  Name)
            pstr = '%s      else:\n'                                                  % (pstr)
            pstr = '%s          pVariablen.pVerlauf[nJ].d%s = dValue\n'               % (pstr,  Variable)

        #Durch die Zeilen gehen
        while((not bEnden) and (nJ < self.nEbenen)):
            #Durchsatz getroffen?
            if CurWord == 'DURCHSATZ':
                bEnden = True
                break
            
            #Rückstellen auf neue Stufe
            if CurWord == 'EBENE':
                nJ += 1
                bDeltaH = False
                if bWerte:
                    #Rücksetzen, da neue Tafel angezeigt wird
                    bWerte = False
                    nTafel = 1
                    nALPHA = 0
                    nBETA = 0
                    nKAPPA = 0
                    nMAC = 0
                    nMAW = 0
                    nP = 0
                    nPT = 0
                    nPTREL = 0
                    nT = 0
                    nTT = 0
                    nTTREL = 0
                    nL    = 0
                else:
                    nTafel += 1
            
            #DetlaH und andere Stufenwerte?
            if CurWord == 'H':
                bDeltaH = True
            
            #Alpha einlesen
            if (CurWord == 'TT') and (bDeltaH == False):
                nI = 0
                dValue = float(Datei.Next())
                #Eintragen der Werte des Dreiecks in die Struktur
                if nTafel == 1:
                    pVariablen.pVerlauf[nJ].dTT = dValue
                    bWerte = True
                else:
                    if nTT == 0:
                        pVariablen.pVerlauf[nJ-1].dTT = dValue
                        bWerte = True
                        nTT = 1
                    else:
                        pVariablen.pVerlauf[nJ].dTT = dValue

	    #Alpha und Beta Sonderfälle
	    if CurWord == "ALPHA":
	      #Nicht "DELTA ALPHA"?
	      if Datei.Prev() == "DELTA":
		      #Prev Rückgänig machen
		      Datei.Next()
	      else:
		      #Prev Rückgängig machen
		      Datei.Next()
		      dValue = float(Datei.Next())
		      if nTafel == 1:
			pVariablen.pVerlauf[nJ].dALP = dValue
			bWerte = True
		      else:
			if nALPHA == 0:
				pVariablen.pVerlauf[nJ-1].dALP = dValue
				bWerte = True
				nALPHA = 1
			else:
				pVariablen.pVerlauf[nJ].dALP = dValue

	    #Alpha und Beta Sonderfälle
	    if CurWord == "BETA":
	      #Nicht "DELTA ALPHA"?
	      if Datei.Prev() == "DELTA":
		      #Prev Rückgänig machen
		      Datei.Next()
	      else:
		      #Prev Rückgängig machen
		      Datei.Next()
		      dValue = float(Datei.Next())
		      if nTafel == 1:
			pVariablen.pVerlauf[nJ].dBET = dValue
			bWerte = True
		      else:
			if nBETA == 0:
				pVariablen.pVerlauf[nJ-1].dBET = dValue
				bWerte = True
				nBETA = 1
			else:
				pVariablen.pVerlauf[nJ].dBET = dValue
            
            #Werte überprüfen
            exec pstr
            
            #Weiterschieben
            CurWord = Datei.Next()
            
            if(CurWord == None):
                bEnden = True
        
        bDurchsatzOK = False
        
        #Durchsatz getroffen?
        if CurWord == 'DURCHSATZ':
            bDurchsatzOK = False
            self.bGeschwOK = False
        else:
            bDurchsatzOK = True
            self.bGeschwOK = True
        
        #Durchsatz okay?
        if not bDurchsatzOK:
            showerror('Rechenfehler',  'Der Durchsatz ist zu groß!')
        
        #Datei wieder schließen
        pDatei.close()
        
        self.bVerlaufCalc = True
        self.AllRead()
    
    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def StufeCalc(self):
        #Datei öffnen
        pDatei = self.OpenOutputFile()
        
        if pDatei == None:
            return
        
        pVariablen = self.Main.Variablen
        
        #Stufenwerte ausnullen
        for Index in range(10):
            pVariablen.pStufenGr[Index].dRgr = 0.0
            pVariablen.pStufenGr[Index].dDH = 0.0
            pVariablen.pStufenGr[Index].dEta = 0.0
            pVariablen.pStufenGr[Index].dDtt = 0.0
            pVariablen.pStufenGr[Index].dPiS = 0.0
        
        Datei = CWordFile(pDatei)
        
        #Stufenzahl einlesen
        Datei.FindNext('STUFENZAHL')
        nStufen = int(Datei.Next())
        
        Jump = 0
        #Ebenenwerte überspringen
        while ((not Datei.IsEoF()) and (Jump < self.nEbenen)):
            Datei.FindNext('EBENE')
            Jump += 1
        
        nS = -1
        nJ  = 0
        
        #Prüfwerte zusammenstückeln
        #Werte
        dVarList = [
                    ('REAKT-GRAD',  'Rgr'), 
                    ('ETAST',  'Eta'), 
                    ('PIST',  'PiS'), 
                    ]
        
        pstr = ''
        #Alle Werte überprüfen
        for Name,  Variable in dVarList:
            #Prüfen
            pstr = '%sif CurWord == "%s":\n'                                                                % (pstr, Name)
            pstr = '%s  nI = 0\n'                                                                                            % (pstr)
            #Extrahieren
            pstr = '%s  dValue = float(Datei.Next())\n'                                         % (pstr)
            #Zuweisen
            pstr = '%s  pVariablen.pStufenGr[nJ+1].d%s = dValue\n'               % (pstr,  Variable)
            pstr = '%s  pVariablen.pStufenGr[nJ].d%s = dValue\n'                    % (pstr,  Variable)
        
        #Schleife vorbereiten
        CurWord = Datei.Next()
        bEnden = False
	bDeltaH = False
        while((not bEnden) and (nS < nStufen)):
            #Durchsatz getroffen?
            if CurWord == 'DURCHSATZ':
                break
            
            #Rückstellen auf Stufe?
            if CurWord == 'STUFE':
                nS += 1
            if CurWord == 'EBENE':
                nJ += 1
            
            #DeltaH prüfen
            if CurWord == 'H':
                bDeltaH = True
                nI = 0
                #Konvertieren
                dValue = float(Datei.Next())
                #Zuweisen
                pVariablen.pStufenGr[nJ+1].dDH = dValue
                pVariablen.pStufenGr[nJ].dDH = dValue
            
            #TT prüfen
            if (CurWord == 'TT') and (bDeltaH == True):
                bDeltaH = False
                nI = 0
                #Konvertieren
                dValue = float(Datei.Next())
                #Zuweisen
                pVariablen.pStufenGr[nJ+1].dDtt = dValue
                pVariablen.pStufenGr[nJ].dDtt = dValue
            
            exec pstr
            
            CurWord = Datei.Next()
           
            if(CurWord == None):
                bEnden = True
        
        bDurchsatzOK = False
        
        #Durchsatz getroffen?
        if CurWord == 'DURCHSATZ':
            bDurchsatzOK = False
            self.bGeschwOK = False
        else:
            bDurchsatzOK = True
            self.bGeschwOK = True
        
        #Durchsatz okay?
        if not bDurchsatzOK:
            showerror('Rechenfehler',  'Der Durchsatz ist zu groß')
        
        #Datei wieder schließen
        pDatei.close()
        
        self.bStufenCalc = True
        self.AllRead()

#-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
# CWordFile - Helferklasse für die Textdatei
#-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
class CWordFile:
    def __init__(self,  Datei):
        #Daten aus der Datei lesen
        if Datei == None:
            return
        
        #Alle Daten einlesen und als Internes Wörterbuch verwalten
        lines = Datei.readlines()
        #Speicher für Wörter
        self._Words = []
        
        #lines in Wörter aufspalten
        for Line in lines:
            #Text beschneiden
            Line.strip()
            #Text anhängen
            self._Words.extend(Line.split())
        
        #StartIndex setzen
        self._iCurIndex = -1
        #Ausdehung speichern
        self._Length = len(self._Words)

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def Next(self):
        #Ende erreicht?
        if self._iCurIndex+1 > self._Length:
            return None

        #Index weiterschieben
        self._iCurIndex += 1

	#Hinter das Ende geschoben?
	if self._iCurIndex == self._Length:
		return None
	
        #Aktuelles Wort zurückgeben
        return self._Words[self._iCurIndex]
    
    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def Prev(self):
        #Anfang erreicht?
        if self._iCurIndex-1 < -1:
            return None
	
        #Index zurückschieben
        self._iCurIndex -= 1

	#Vor den Anfang geschoben?
	if self._iCurIndex == -1:
		return None
	
        #Aktuelles Wort zurückgeben
        return self._Words[self._iCurIndex]
    
    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def GoTo(self,  Index):
        self._iCurIndex = Index
    
    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def IsEoF(self):
        if self._iCurIndex >= self._Length:
            return True
        else:
            return False
    
    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def FindNext(self,  Target):
        CurWord = self.Next()
        #Suchen
        while((CurWord != None) and (CurWord != Target)):
            CurWord = self.Next()
