#!/usr/bin/env python
# -*- coding: utf-8 -*-

#***************************************************************************
#*   Copyright (C) 2008-2008 by Steve Walter                               *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation; either version 3 of the License, or     *
#*   (at your option) any later version.                                   *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program; if not, write to the                         *
#*   Free Software Foundation, Inc.,                                       *
#*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
#***************************************************************************

#import Tkinter
import Pmw
#import Mittel_T
#import tkMessageBox
import string

from Tkinter import *
from Pmw import *
from Mittel_T import *
from tkMessageBox import *


#Frame für Das einlesen der Steuerkennzahlen
class CSteuerkennzahlDlg:
    def __init__(self, master=None, pSteuer=None,  pCallOnClose=None):
        #Master speichern
        self.Master = master
        self.pSteuer = pSteuer
        self.CloseCall = pCallOnClose
        #Design laden
        self.Layout = self.doDesign()
        self.Master.add(self, fill=BOTH, expand=YES)

        #Daten laden
        self.GetSteuer()

    def doDesign(self):
        #Frame in dem sich das alles abspielt
        pFrame = Frame(self.Master)

        #Linker und Rechter Frame
        pLeft        = Frame(pFrame)
        pRight      = Frame(pFrame)

        pLeft.pack(side=LEFT, fill=BOTH,   expand=YES)
        pRight.pack(side=LEFT, fill=BOTH,  padx=5,  expand=YES)

        #Gruppenfelder auf der Rechten Seite
        KennzahlGrp = Pmw.Group(pLeft,  tag_text='Kennzahlen')
        KennzahlGrp.pack(side=TOP, fill=X,   expand=1,  padx=3,  pady=3)

        BerechnungsGrp = Pmw.Group(pLeft,  tag_text='Berechnungskriterien')
        BerechnungsGrp.pack(side=TOP, fill=X,   expand=1,  padx=3,  pady=3)

        ZapfluftGrp = Pmw.Group(pLeft,  tag_pyclass=None)
        ZapfluftGrp.pack(side=TOP, fill=X,  expand=1,  padx=3,  pady=3)

        #Elemente des ersten Gruppenfelds
        self.StufenanzahlE = Pmw.EntryField(KennzahlGrp.interior(),  labelpos=W,  label_text='Stufenanzahl:', value='1')
        self.EbenenanzahlE = Pmw.EntryField(KennzahlGrp.interior(),  labelpos=W,
                                                                                     label_text='Ebenenanzahl, max 10:',  value='3',
                                                                                     validate = {'validator' :  'numeric',  'min' : 0,  'max' : 10 })
        self.StufenanzahlE.pack(side=TOP,  expand=1,  padx=5,  pady=5)
        self.EbenenanzahlE.pack(side=TOP,  expand=1,  padx=5,  pady=5)

        #Temporäre Variabeln für den Dialog
        self.bKein1 = BooleanVar()
        self.bKiter   = BooleanVar()
        self.bKrad   = BooleanVar()
        self.bKdrall = BooleanVar()
        self.bKaus   = BooleanVar()

        #Elemente des zweiten Gruppenfelds
        Checkbutton(BerechnungsGrp.interior(),  text='Geometrievorgabe',  variable=self.bKein1).grid(row=0, column=0,  sticky=W)
        Checkbutton(BerechnungsGrp.interior(),  text='Anpassung der Stufenarbeit',  variable=self.bKiter).grid(row=1,  column=0,  sticky=W)
        Checkbutton(BerechnungsGrp.interior(),  text='Keine reine Zylinderströmung',  variable=self.bKrad ) .grid(row=2, column=0,   sticky=W)
        Checkbutton(BerechnungsGrp.interior(),  text='Abschätzung der Gitterbelastung',  variable=self.bKdrall).grid(row=3, column=0,   sticky=W)
        Checkbutton(BerechnungsGrp.interior(),  text='Ausgabe aller berechneten Werte',  variable=self.bKaus).grid(row=4, column=0,  sticky=W)

        self.strTemp = StringVar()
        self.strTemp.set('10')

        #Elemente des dritten Gruppenfelds
        self.ZapfluftE = Pmw.EntryField(ZapfluftGrp.interior(),  labelpos=W,  label_text='Zapfluftentnahme bei Stufe',  validate = {'validator' :  'numeric',  'min' : 0,  'max' : 10 })
        self.ZapfluftE.pack(expand=1,fill=X,   padx=5,  pady=5)

        #Einzelnes Element am Ende
        self.BerechnungsName = Pmw.EntryField(pLeft,  labelpos=W,  label_text='Name der Berechnung',  value='')
        self.BerechnungsName.pack(expand=1, fill=X,   padx=5,  pady=5)

        Pmw.alignlabels((self.StufenanzahlE,  self.EbenenanzahlE,  self.ZapfluftE,  self.BerechnungsName))

        #Button auf der rechten Seite
        Button(pRight,  text='OK', command=self.Apply).pack(side=TOP, fill=X,   padx=5,  pady=5,  expand=YES)
        Button(pRight,  text='Abbruch',  command=self.Cancel).pack(side=TOP, fill=X,   padx=5,  pady=5,  expand=YES)

        return pFrame

    def validate(self):
        #Gültige Eingaben?
        if (not self.EbenenanzahlE.valid()) or (not self.StufenanzahlE.valid()) or (not self.ZapfluftE.valid()):
            return False

        #Werte prüfen
        if int(self.StufenanzahlE.get()) >= int(self.EbenenanzahlE.get()):
            #Fehlermeldung
            showerror('Falsche Eingabe',  'Stufenzahl muß kleiner der Ebenenzahl sein')
            return False

        return True

    def Apply(self):
        #Alle Daten gültig?
        if self.validate():
            #Übernehmen
            self.SetSteuer()
            #Dialog schließen
            self.Cancel()


    def Cancel(self):
        self.Layout.destroy()
        self.Master.remove(self)
        self.CloseCall()

    def destroy(self):
        self.Cancel()

    def pack(self, **kw):
        self.Layout.pack(kw)

    def GetSteuer(self):
        #Werte aus der Struktur laden
        self.bKein1.set(self.pSteuer.bKein1)
        self.bKiter.set(self.pSteuer.bKiter)
        self.bKrad.set(self.pSteuer.bKrad)
        self.bKdrall.set(self.pSteuer.bKdrall)
        self.bKaus.set(self.pSteuer.bKaus)

        #Textfelder füllen
        self.ZapfluftE.setentry(self.pSteuer.nKabbl)
        self.EbenenanzahlE.setentry(self.pSteuer.nEbene)
        self.StufenanzahlE.setentry(self.pSteuer.nStufen)
        self.BerechnungsName.setentry(self.pSteuer.szText)

    def SetSteuer(self):
        #Werte in die Struktur laden
        self.pSteuer.bKein1 = self.bKein1.get()
        self.pSteuer.bKiter = self.bKiter.get()
        self.pSteuer.bKrad = self.bKrad.get()
        self.pSteuer.bKdrall = self.bKdrall.get()
        self.pSteuer.bKaus = self.bKaus.get()

        #Texte umwandeln
        self.pSteuer.nEbene = int(self.EbenenanzahlE.get())
        self.pSteuer.nKabbl = int(self.ZapfluftE.get())
        self.pSteuer.nStufen = int(self.StufenanzahlE.get())
        self.pSteuer.szText = self.BerechnungsName.get()


#-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
# CVerdichterDlg
#-------------------------------------------------------------------------------------------------------------------------------------------------------------------------


#Frame zum Einstellen des Gesamtverdichters
class CVerdichterDlg:
    def __init__(self,  master=None,  pVariablen=None,  pCallOnClose=None):
        self.Master = master
        self.GesDat = pVariablen.pGesDat
        self.Variablen = pVariablen
        self.CloseCall = pCallOnClose
        #Layout erstellen
        self.Layout = self.doLayout()

        #Werte einstellen
        self.GetWerte()

        #Dialog registrieren
        self.Master.add(self,  fill=BOTH,  expand=YES)

    def doLayout(self):
        #Hauptframe des Layouts
        pFrame = Frame(self.Master)

        #Teilframes
        pUpper = Frame(pFrame)
        pLower = Frame(pFrame)

        #Gruppenfelder
        EintrittsgrosenGrp = Pmw.Group(pUpper, tag_text='Eintrittsgrößen')
        EintrittsgrosenGrp.pack(side=LEFT,  fill=BOTH, expand=YES,  padx=3,  pady=3)

        AustrittsgrosenGrp = Pmw.Group(pUpper, tag_text='Austrittsgrößen')
        AustrittsgrosenGrp.pack(side=LEFT,  fill=BOTH,  expand=YES,  padx=3, pady=3)

        WeitereGrp = Pmw.Group(pLower,  tag_text='Weitere Größen')
        WeitereGrp.pack(side=LEFT,  fill=BOTH,  expand=YES,  padx=3,  pady=3)

        #Elemente der Gruppenbox hinzufügen
        dataDict = [
                    #Eintragname            Master                                      Text                                value       validator       min
                    ('ETotalTemp',  'EintrittsgrosenGrp',  'Totaltemperatur im Absolutsystem [K]',  '0.0',  'real', 0.0),
                    ('ETotalDruck', 'EintrittsgrosenGrp', 'Totaldruck im Absolutsystem [Pa]', '0.0', 'real',  0.0  ),
                    ('EZWinkelEin',  'EintrittsgrosenGrp', 'Absoluter Winkel zur φ-Richtung [°]',  '0.0',  'real',  -360.0),
                    ('EMassestromEin',  'EintrittsgrosenGrp',  'Massenstrom [kg/s]',  '0.0',  'real',  0.0),
                    ('ENabFakEin',  'EintrittsgrosenGrp',  'Blockage-Faktor Nabe [-]',  '0.0',  'real',  -10000.0),
                    ('EGehFakEin',  'EintrittsgrosenGrp',  'Blockage-Faktor Gehäuse [-]',  '0.0',  'real',  -10000.0),

                    ('EZWinkelAus',  'AustrittsgrosenGrp',  'Absoluter Winkel zur φ-Richtung [°]',  '0.0','real',  -360.0),
                    ('EMassestromAus', 'AustrittsgrosenGrp',  'Massenstrom [kg/s]',  '0.0',  'real',  0.0),
                    ('ENabFakAus',  'AustrittsgrosenGrp',  'Blockage-Faktor Nabe [-]',  '0.0',  'real',  -10000.0),
                    ('EGehFakAus',  'AustrittsgrosenGrp',  'Blockage-Faktor Gehäuse [-]',  '0.0', 'real',  -10000.0) ,

                    ('EDrehzahl',  'WeitereGrp',  'Drehzahl [1/min]', '0.0',  'real', 0.0),
                    ('EVerhaltnis',  'WeitereGrp',  'Angestrebtes Gesamttotaldruckverhältnis [-]',  '0.0',  'real', 0.0),
                    ]

        #Daten generieren
        for Entry,  Parent,  Text,  StartV,  ValType,  Min in dataDict:
            pstr='self.%s = Pmw.EntryField(%s.interior(), labelpos=W, label_text="%s", value="%s", validate= { "validator":"%s", "min": %i })\n' % (Entry,  Parent,  Text,  StartV,  ValType,  Min)
            pstr='%sself.%s.pack(side=TOP, fill=X, expand=YES, padx=3, pady=5)\n' % (pstr,  Entry)
            exec pstr

        #Labels ausrichten
        Pmw.alignlabels((self.ETotalTemp,  self.ETotalDruck,  self.EZWinkelEin,  self.EMassestromEin,  self.ENabFakEin,  self.EGehFakEin))
        Pmw.alignlabels((self.EZWinkelAus,  self.EMassestromAus,  self.ENabFakAus,  self.EGehFakAus))
        Pmw.alignlabels((self.EDrehzahl,  self.EVerhaltnis))

        #Eingabebutton
        Buttons = Frame(pLower)
        Buttons.pack(side=LEFT,  expand=YES,  fill=BOTH,  padx=0,  pady=0)

        Button(Buttons,  text='Ok',  command=self.Apply).pack(side=TOP,  expand=YES,  fill=X,  padx=5,  pady=5)
        Button(Buttons,  text='Abbruch',  command=self.Cancel).pack(side=TOP,  expan=YES,  fill=X,  padx=5,  pady=5)

        pUpper.pack(side=TOP,  expand=YES,  fill=BOTH,  pady=5,  padx=5)
        pLower.pack(side=TOP,  expand=YES,  fill=BOTH,  pady=5, padx=5)

        return pFrame

    def _GetListe(self):
                            #Eintrag                Variablenname
        return [ ('ETotalTemp', 'dTt_ein'),
                            ('ETotalDruck',  'dPt_ein'),
                            ('EZWinkelEin',  'dAlfz_ein'),
                            ('EZWinkelAus',  'dAlfz_aus'),
                            ('EMassestromEin',  'dM_ein'),
                            ('EMassestromAus',  'dM_aus'),
                            ('EDrehzahl',  'dN'),
                            ('ENabFakEin',  'dBln_ein'),
                            ('ENabFakAus',  'dBln_aus'),
                            ('EGehFakEin',  'dBlg_ein'),
                            ('EGehFakAus',  'dBlg_aus'),
                            ('EVerhaltnis',  'dPig_soll'),
                        ]

    def GetWerte(self):
        pstr = ''
        for Entry,  VarName in self._GetListe():
            pstr = '%sself.%s.setentry(self.GesDat.%s)\n' % (pstr,  Entry,  VarName)

        exec pstr

        #Kiter aktiviert?
        if self.Variablen.pSteuer.bKiter:
            self.EVerhaltnis.component('entry').configure(state=NORMAL)
        else:
            self.EVerhaltnis.component('entry').configure(state=DISABLED)

    def SetWerte(self):
        pstr =''
        for Entry,  VarName in self._GetListe():
            pstr = '%sself.GesDat.%s = float(self.%s.get())\n' % (pstr,  VarName,  Entry)

        exec pstr

    def validate(self):
        bValidate = True
        #'ToDo: Validierungsstring
        pstr=''

        for Entry,  VarName in self._GetListe():
            pstr='if not self.%s.valid():\n\tbValidate=False\n' % (Entry)
            exec pstr

        return bValidate

    def Apply(self):
        #Dialog schließen
        if self.validate():
            self.SetWerte()
            self.Cancel()

        return True

    def Cancel(self):
        #Dialog schließen
        self.Layout.destroy()
        self.Master.remove(self)
        self.CloseCall()

    def destroy(self):
        #Werte übernehmen und schließen
        self.Cancel()

    def pack(self, **kw):
        self.Layout.pack(kw)



#-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
# CEbenenDlg
#-------------------------------------------------------------------------------------------------------------------------------------------------------------------------


class CEbenenDlg:
    def __init__(self,  master=None,  pTarget = None,  pEbenen=None,  iEbene=0,  pSteuer=None):
        #Master übernehmen
        self.Master = master
        self.Target = pTarget
        self.pEbenen = pEbenen
        self.iEbene = iEbene
        self.pSteuer = pSteuer

        #Layout erstellen
        self.Layout = self.doLayout()
        #Daten laden
        self.GetWerte()
        #self.Init()

    def doLayout(self):
        #Hauptframe
        pFrame = Frame(self.Target)
        pFrame.pack(fill=BOTH,  expand=YES)

        #Gruppen
        ArtGrp = Pmw.Group(pFrame,  tag_text='dieser Ebene folgt ein')
        ArtGrp.pack(side=TOP,  fill=BOTH,  expand=YES,  padx=3,  pady=3)

        ZahlenGrp = Pmw.Group(pFrame,  tag_text='Zahleneingaben')
        ZahlenGrp.pack(side=TOP,  fill=BOTH,  expand=YES,  padx=3,  pady=3)

        #Checkbutton
        self.iFolge = IntVar()

        for text,  val in [('Laufrad',  1),  ('Leitrad',  2),  ('Schaufelfreier Kanal',  3)]:
            Radiobutton(ArtGrp.interior(),  text=text,  value=val,  variable=self.iFolge, command=self._Folgenwechsel).pack(side=LEFT,  fill=BOTH,  expand=YES,  padx=3,  pady=3)

        #Elemente der Gruppenbox hinzufügen
        dataDict = [
                    #Eintragname              Text                                value       validator       min row col
                    ('ENabenRadius',  'Nabenradius [m]',  '0.0',  'real', 0.0,  0,  0),
                    ('EGehauseRadius',  'Gehäuseradius [m]', '0.0', 'real',  0.0,   1, 0) ,
                    ('EAxialGeschw',  'Axialgeschwindigkeit [m/s]',  '0.0',  'real',  0.0,  2,  0),
                    ('EMSRadius', 'Mittelschnittsradius [m]',  '0.0',  'real',  0.0,  3,  0),
                    ('EDL',  'd/s [-]',  '0.0',  'real',  0.0,  4,  0),
                    ('ETL', 't/s [-]',  '0.0',  'real',  0.0,  5,  0),
                    ('EAxialBreite', 'Rechenebenen Abstand folgendes Gitter [m]',  '0.0','real',  0.0,  6,  0),
                    ('ESpalthohe',   'Spalthöhe [mm]',  '0.0',  'real',  0.0,  7,   0) ,
                    ('EReaktGrad',  'Kinematischer Reaktionsgrad [-]',  '0.0',  'real',  0.0,  8,  0),
                    ('EDeltaT',  'Δ T_t [K]',  '0.0', 'real',  -10000.0,  9,  0) ,

                    ('EXL',  'XL [-]', '0.0',  'real', 0.0,  1,  1),
                    ('EKSEC',  'KSEC [-]',  '0.0',  'real', 0.0, 2, 1),
                   ('EKSPA',  'KSPA [-]',  '0.0', 'real',  0.0,  3,  1) ,
                   ('EEPSEB',  'EPSEB [-]',  '0.0',  'real',  0.0,  4,  1),
                   ('EEPSRA',  'EPSRA [-]',  '0.0',  'real',  0.0,  5,  1),
                   ('EEPSWA',  'EPSWA [-]',  '0.0',  'real',  0.0,  6,  1),
                   ('ERauh',  'Rauhigkeit [μm]',  '0.0',  'real',  0.0,  7,  1),
                   ('ELAMWA',  'LAMWA [-]',  '0.0',  'real',  0.0,  8,  1),
                   ('EWinkel',  'Axialer Winkel zw. 2 Statoren',  '0.0',  'real',  0.0,  9,  1)
                    ]

        #Daten generieren
        strAlign = 'Pmw.alignlabels(('

        for Entry, Text,  StartV,  ValType,  Min,  row,  col in dataDict:
            pstr ='self.%s = Pmw.EntryField(ZahlenGrp.interior(), labelpos=W, label_text="%s", value="%s", validate= { "validator":"%s", "min": %i })\n' % (Entry,  Text,  StartV,  ValType,  Min)
            pstr ='%sself.%s.grid(row=%i, column=%i, sticky=W, padx=3, pady=3)\n' % (pstr,  Entry,  row,  col)

            strAlign ='%sself.%s,' % (strAlign,  Entry)

            exec pstr

        strAlign ='%s))\n' % (strAlign)
        exec strAlign

        #Checkbutton
        self.bEinlesen = BooleanVar()
        Checkbutton(ZahlenGrp.interior(),  text='Einlesen von XL, KSEC,...',  variable=self.bEinlesen,  command=self._Einlesen).grid(row=0,  column=1,  sticky=W,  padx=3,  pady=3)

        #Buttonframe
        pButtons = Frame(pFrame)

        Button(pButtons,  text='OK',  command=self.BApply).pack(side=LEFT,  fill=X,  expand=YES,  padx=3,  pady=3)
        Button(pButtons,  text='Abbruch',  command=self.Cancel).pack(side=LEFT,  fill=X,  expand=YES,  padx=3,  pady=3)

        pButtons.pack(side=TOP,  fill=BOTH, expand=YES)

        #Startwert festlegen
        self.iFolge.set(1)
        self._Folgenwechsel()

        self.bEinlesen.set(False)
        self._Einlesen()

        return pFrame

    def _Einlesen(self):
        #Als letzte Ebene geht dieser Eintrag nicht zuenden
        if self.iEbene == self.pSteuer.nEbene-1:
            self.bEinlesen.set(False)
            return

        for EField in  [self.EXL,  self.EKSEC,  self.EKSPA,  self.EEPSEB,  self.EEPSRA,  self.EEPSWA,  self.ERauh,  self.ELAMWA]:
            if self.bEinlesen.get():
                self.__setState(EField,  NORMAL)
            else:
                self.__setState(EField,  DISABLED)

    def __setState(self,  EField,  state):
        EField.component('entry').configure(state=state)

    def setState(self,  EField,  state):
        self.__setState(EField,  state)

    def _Folgenwechsel(self):
        #Variable Elemente abstellen
        self.__setState(self.EReaktGrad,  DISABLED)
        self.__setState(self.EDeltaT, DISABLED)
        self.__setState(self.EWinkel,  DISABLED)

        #Was wurde gewählt?
        if self.iFolge.get() == 1:
            self.__setState(self.EReaktGrad,  NORMAL)
            self.__setState(self.EDeltaT,  NORMAL)
            return

            #Kontrolle ob 2 Rotoren hintereinander sind
            if self.iEbene > 0:
                if self.pEbenen[self.iEbene-1].nKgit == 1:
                    showwarning('Achtung!',  'Vor der Ebene ist ebenfalls ein  Rotor!\nEs können jedoch keine zwei Rotoren hintereinander berechnet werden\n\nBitte ändern Sie dies vor der Berechnung')

            return

        if self.iFolge.get() == 2:
            if  (self.iEbene > 0) and (self.iEbene < self.pSteuer.nEbene-1) and (self.pEbenen[self.iEbene-1].nKgit == 2):
                self.__setState(self.EWinkel,  NORMAL)
            return

        if self.iFolge.get() == 3:
            showerror('Falsche Eingabe!', 'Der schaufelfreie Kanal wird nicht unterstützt!' )
            return


    def _GetListe(self):
        return [
                ('EDL',  'dDzl'),
                ('ETL',  'dTzl'),
                ('EAxialBreite',  'dBax'),
                ('ESpalthohe',  'dSsp'),
                ('EReaktGrad',  'dRGrad'),
                ('EDeltaT',  'dDeltaTt'),
                ('EXL',  'dXl'),
                ('EKSEC',  'dKsec'),
                ('EKSPA',  'dKspa'),
                ('EEPSEB',  'dEpseb'),
                ('EEPSRA', 'dEpsra'),
                ('EEPSWA',  'dEpswa'),
                ('ERauh',  'dKrauh'),
                ('ELAMWA',  'dLamwa'),
                ('EWinkel',  'dAlfz')
                ]

    def GetWerte(self):
        if self.pEbenen[self.iEbene].nKgit == 1:
            self.__setState(self.EReaktGrad,  NORMAL)
            self.__setState(self.EDeltaT,  NORMAL)
            self.__setState(self.EWinkel,  DISABLED)
        else:
            self.__setState(self.EReaktGrad, DISABLED)
            self.__setState(self.EDeltaT, DISABLED)

            if (self.iEbene > 0)  and (self.pEbenen[self.iEbene-1].nKgit == 2) and (self.iEbene < self.pSteuer.nEbene-1):
                self.EWinkel.setentry(self.pEbenen[self.iEbene].dAlfz)
                self.__setState(self.EWinkel,  NORMAL)
            else:
                self.__setState(self.EWinkel,  DISABLED)

        #Zusatzwerte laden
        if self.pSteuer.bKein1 == True:
            self.ENabenRadius.setentry(self.pEbenen[self.iEbene].dRngeo)
            self.EGehauseRadius.setentry(self.pEbenen[self.iEbene].dRggeo)

            self.__setState(self.EAxialGeschw,  DISABLED)
            self.__setState(self.EMSRadius,  DISABLED)
        else:
            self.EAxialGeschw.setentry(self.pEbenen[self.iEbene].dCax)
            self.EMSRadius.setentry(self.pEbenen[self.iEbene].dRmittel)

            self.__setState(self.ENabenRadius,  DISABLED)
            self.__setState(self.EGehauseRadius,  DISABLED)

        #Nicht die letzte Ebene?
        if self.iEbene < self.pSteuer.nEbene-1:
            #Einträge normal füllen
            pstr =''
            for Entry,  Var in self._GetListe():
                pstr = '%sself.%s.setentry(self.pEbenen[self.iEbene].%s)\n' % (pstr,  Entry,  Var)

            exec pstr
        else:
            self.__setState(self.EDL,  DISABLED)
            self.__setState(self.ETL,  DISABLED)
            self.__setState(self.EAxialBreite,  DISABLED)
            self.__setState(self.ESpalthohe,  DISABLED)
            self.__setState(self.EReaktGrad,  DISABLED)
            self.__setState(self.EDeltaT,  DISABLED)
            self.__setState(self.EDL,  DISABLED)

        #bKein aktiv?
        if self.pEbenen[self.iEbene].bKein2 == TRUE:
            Tag = 'NORMAL'
        else:
            Tag = 'DISABLED'

        pstr =''
        for Zahl in range(8):
            pstr = '%sself.setState(self.%s, %s)\n' % (pstr,  self._GetListe()[Zahl+6][0],  Tag)
        exec pstr

        #Checkboxen setzen
        self.iFolge.set(self.pEbenen[self.iEbene].nKgit)
        self.bEinlesen.set(self.pEbenen[self.iEbene].bKein2)

        #Werte aktualisiern
        self._Einlesen()
        self._Folgenwechsel()


    """"def GetWerte(self):

        #AxialWinkel ausschalten
        self.__setState(self.EWinkel,  DISABLED)

        #Gültiger Planenindex?
        if self.iEbene < self.pSteuer.nEbene-1:
            bValid = True
        else:
            bValid = False

        pstr = ''
        #Durch alle Werte gehen und zuweisen
        for Entry,  Var in self._GetListe():
            if bValid:
                pstr = '%sself.%s.setentry(self.pEbenen[self.iEbene].%s)\n' % (pstr,  Entry,  Var)
            else:
                pstr = '%sself.setState(self.%s, DISABLED)\n' % (pstr,  Entry)

        exec pstr

        #Kein gültiger Planenindex?
        if not bValid:
            #hier abbrechen
            return

        #Checkwerte laden
        self.iFolge.set(self.pEbenen[self.iEbene].nKgit)
        self.bEinlesen.set(self.pEbenen[self.iEbene].bKein2)

        self._Einlesen()
        self._Folgenwechsel()"""

    def SetWerte(self):
        pstr = ''
        #Durch alle Werte gehen und zuweisen
        for Entry,  Var in self._GetListe():
            pstr = '%sself.pEbenen[self.iEbene].%s = float(self.%s.get())\n' % (pstr,  Var,  Entry)

        exec pstr

        #Checkwerte setzen
        self.pEbenen[self.iEbene].nKgit = self.iFolge.get()
        self.pEbenen[self.iEbene].bKein2 = self.bEinlesen.get()

        #Zusatzwerte schreiben
        if self.pSteuer.bKein1:
            self.pEbenen[self.iEbene].dRngeo = float(self.ENabenRadius.get())
            self.pEbenen[self.iEbene].dRggeo = float(self.EGehauseRadius.get())
        else:
            self.pEbenen[self.iEbene].dCax = float(self.EAxialGeschw.get())
            self.pEbenen[self.iEbene].dRmittel = float(self.EMSRadius.get())

    def Apply(self):
        if self.validate():
            self.SetWerte()
        #ToDo: Titel ggf ändern

    def BApply(self):
        self.Apply()
        self.Master.Apply()

    def validate(self):
        return True

    def Cancel(self):
        self.Master.Cancel()


    def destroy(self):
        self.Apply()

    def pack(self,  **kw):
        self.Layout.pack(kw)




#-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
# CEbenenBook
#-------------------------------------------------------------------------------------------------------------------------------------------------------------------------

class CEbenenBook:
    def __init__(self,  master=None,  Variablen=None,  iActiveTab = 0,  pCallOnClose=None):
        #Werte übernehmen
        self.Master =master
        self.Variablen = Variablen
        self.CallClose = pCallOnClose

        self.Temp = [SEBWerte()]*10

        for iZahl in range(10):
            self.Temp[iZahl] = Variablen.pEBWerte[iZahl].copy()

        #Keine Werte vorhanden?
        if self.Variablen.pSteuer.nEbene == 0:
            return

        self.Layout = self.doLayout()

        #beim Workspace registrieren
        self.Master.add(self,  fill=BOTH,  expand=YES, side="top")

        self.Notebook.selectpage(iActiveTab)
        exec 'self.Current = self.Ebene%i\n' % iActiveTab
	self.Notebook.setnaturalsize(pageNames=None)

    def doLayout(self):
        #Hauptframe
        pFrame = Frame(self.Master)
        pFrame.pack(fill=BOTH,  expand=YES, side="top")

        #Notebook
        self.Notebook = Pmw.NoteBook(pFrame,  raisecommand=self.PageChanged)
        self.Notebook.pack(fill=BOTH,  expand=YES,  padx=3,  pady=3, side="top")

        self.Current = None

        pstr = ''
        for iZahl in range(self.Variablen.pSteuer.nEbene):
            pstr = '%sPage%i = self.Notebook.add("Ebene %i")\n' % (pstr,  iZahl,  iZahl+1)
            pstr = '%sself.Ebene%i = CEbenenDlg(self, Page%i, self.Temp, %i, self.Variablen.pSteuer)\n' % (pstr, iZahl, iZahl,  iZahl)

        exec pstr

        return pFrame

    def destroy(self):
        self.Apply()

    def PageChanged(self,  Name):
        #Gültiger Eintrag vorhanden
        if self.Current == None:
            return

        #Aktuelle Einträge speichern
        self.Current.Apply()
        #Neuen Index herausfiltern
        Strings = string.split(Name,  ' ')
        iIndex = int(Strings[1])-1
        #Neuen Index setzen
        exec 'self.Current = self.Ebene%i' % (iIndex)

    def Cancel(self):
        self.Layout.destroy()
        self.Master.remove(self)
        self.CallClose()

    def Apply(self):
        #Werte übernehmen
        for iZahl in range(10):
            self.Variablen.pEBWerte[iZahl] = self.Temp[iZahl].copy()

        self.Cancel()

    def pack(self,  **kw):
        self.Layout.pack(kw)

#-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
# CDruckDlg
#-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
class CDruckerDlg:
    def __init__(self, master=None,  pVariablen=None,  CallOnClose=None):
        self.Master = master
        self.bDruckFarbe = pVariablen.pCheck.bDruckFarbe
        self.bPrintToFile = pVariablen.pCheck.bPrintToFile
        self.OnCloseCall = CallOnClose

        self.iOption = IntVar()

        if self.bDruckFarbe.get():
            self.iOption.set(1)
        else:
            self.iOption.set(2)

        self.Layout = self.doLayout()
        self.Master.add(self,  fill=BOTH,  expand=YES)

    def doLayout(self):
        pFrame = Frame(self.Master)
        pFrame.pack(fill=BOTH,  expand=YES)

        Label(pFrame,  text='Achtung\nBei Schwarz/Weiß-Druckern ergibt eine Auswahl von farbigem Druck unkontrollierte Ergebnisse!!!').pack(side=TOP, padx=5, pady=5, expand=YES,   fill=BOTH)
        Radiobutton(pFrame,  text='Farbiger Ausdruck', value=1,  variable=self.iOption).pack(side=TOP,  expand=YES, fill=BOTH)
        Radiobutton(pFrame,  text='Schwarz/Weiß Ausdruck',  value=2,  variable=self.iOption).pack(side=TOP, expand=YES, fill=BOTH)
        Checkbutton(pFrame,  text='Ausdruck in Datei speichern',  variable=self.bPrintToFile).pack(side=TOP,  expand=YES,  fill=BOTH)

        pLower = Frame(pFrame)
        Button(pLower,  text='Abbruch',  command=self.Cancel).pack(side=LEFT,  expand=YES,  fill=BOTH)
        Button(pLower,  text='OK', command=self.Apply).pack(side=LEFT,  expand=YES,  fill=BOTH)

        pLower.pack(side=TOP,   expand=YES, fill=BOTH)

        return pFrame

    def destroy(self):
        self.Cancel()

    def Cancel(self):
        self.Layout.destroy()
        self.Master.remove(self)
        self.OnCloseCall()

    def Apply(self):
        #Werte übernehmen
        if self.iOption.get() == 1:
            self.bDruckFarbe.set(True)
        else:
            self.bDruckFarbe.set(False)

        self.Cancel()

    def pack(self,  **kw):
        self.Layout.pack(kw)

