#!/usr/bin/env python
# -*- coding: utf-8 -*-

#***************************************************************************
#*   Copyright (C) 2008-2008 by Steve Walter                               *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation; either version 3 of the License, or     *
#*   (at your option) any later version.                                   *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program; if not, write to the                         *
#*   Free Software Foundation, Inc.,                                       *
#*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
#***************************************************************************

import Tkinter
import math
import datetime
import string
import tkMessageBox
import tkFileDialog
import os

from Tkinter import *
from math import *
from tkMessageBox import *
from tkFileDialog import *

#MAKROs
M = 0   #MoveTo             -  XPos, YPos
L = 1    #LineTo              - XPos, YPos
T = 2    #TextOut           - XPos, YPos, Text
ST = 3 #SetTextColor  - Color
SP = 4 #SetPen             - Pattern, Width, Color
C    = 5 # Clear
A     = 6 #Arc                   - XPos1, YPos1, XPos2, YPos2, StartDegree, Degree2Draw

#Was zeichnen
CLEARSCREEN  = 0
KONKANAL         = 1
SCHAUFEL          = 2
TSDIAGRAMM     = 3
DREIECKE            = 4
KANAL                   = 5
KONVB                  = 6
AUSVERL             = 7
VARIATION           = 8
HILFE                    = 9


class CZeichnen:
    def __init__(self,  master=None,  pMain=None):
        #Master speichern
        self.Master = master
        self.Vars = pMain.Variablen
        self.Main = pMain
        self.show = True
        self.nWasZeichnen = CLEARSCREEN
        
        #Klassenvariablen
        self.dFaktorGesch = 0.0
        self.dFaktorMeter = 0.0
        
        #Halbkanal
        self.bHalbKanal = False
        
        #Layout erstellen
        self.Layout = self.doDesign()
        self.Master.add(self, fill=BOTH,  expand=YES)
        
        #Viewport erstellen
        self.pViewport = CViewport(self.pCanvas,  1420,  1000)
        
        #self.Draw()
    
    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def doDesign(self):
        #Frame holen, in dem sich alles abspielt
        pFrame = Frame(self.Master)
        
        #Canvas objekt erstellen
        self.pCanvas = Canvas(pFrame)
        self.pCanvas.bind('<Configure>', self.Resize)
        self.pCanvas.pack(expand=YES,  fill=BOTH)
        
        return pFrame
    
    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def Resize(self,  event):
        #Größe anpassen
        self.pCanvas['width'] = event.width
        self.pCanvas['height'] = event.height
        
        #Neuzeichnen
        self.Draw(0)
    
    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def MittelPaint(self,  nKanal):
        Check = self.Vars.pCheck
        
        #Bildschrim löschen
        if self.nWasZeichnen == CLEARSCREEN:
            Check.szRahmenText = ' '
            return
        
        #Kontroller Verdichterschnitt
        if self.nWasZeichnen == KONKANAL:
            Check.szRahmenText = 'Kontrolle: Verdichterquerschnitt'
            self.bHalbKanal = False #gesamter Verdichterschnitt
            
            bHilf = [False]*10
            
            for nI in range(9):
                bHilf[nI] = Check.bKanal[nI].get()
            
            # Belegen der Standardwerte für Kontrolle-Kanal 
            Check.bKanal[1].set(True)                  #  Ebenenbezeichnung
            Check.bKanal[2].set(True)                  #  Ebenenabstände
            Check.bKanal[3].set(True)                  #  Anfangs- und Enddurchmesser
            Check.bKanal[4].set(True)                  #  Mittelschnittsradius
            Check.bKanal[5].set(False)                 #  sonst. Bezeichnung
            Check.bKanal[6].set(False)                 #  Strömung
            Check.bKanal[7].set(True)                  #  Maßstab
            Check.bKanal[8].set(False)                 #  Farbe
            
            #Kanal zeichenen
            self.ZeicheneKanal(0)
            #Werte wieder herstellen
            for nI in range(9):
                Check.bKanal[nI].set(bHilf[nI])
        
        #Ausgabe des Schaufelprofils
        if self.nWasZeichnen == SCHAUFEL:
            Check.szRahmenText = 'Schaufelprofile'
            self.ZeicheneSchaufel(nKanal)
        
        #Ausgabe des T-s-Diagramm
        if self.nWasZeichnen == TSDIAGRAMM:
            Check.szRahmenText = 'h-s-Diagramm'
            self.ZeicheneTSDiagramm(nKanal)
        
        #Ausgabe der Dreiecke
        if self.nWasZeichnen == DREIECKE:
            Check.szRahmenText = 'Geschwindigkeitsdreiecke'
            self.ZeicheneDreiecke(nKanal)
        
        #Ausgabe Kanal
        if self.nWasZeichnen == KANAL:
            Check.szRahmenText = 'Verdichterquerschnitt'
            self.bHalbKanal = False
            self.ZeicheneKanal(nKanal)
        
        #Kontrolle Verlauf
        if self.nWasZeichnen == KONVB:
            Check.szRahmenText = 'Verläufe von Eingabegrößen'
            self.bHalbKanal = True
            self.ZeicheneVerlauf(nKanal)
        
        #Ausgabe Verläufe
        if self.nWasZeichnen == AUSVERL:
            Check.szRahmenText = 'Verläufe von Verdichtergrößen'
            bHalbKanal = True
            self.ZeicheneAusVerlauf(nKanal)
        
        #Ausgabe Variation
        #Derzeit nicht integriert
        if self.nWasZeichnen == VARIATION:
            Check.szRahmenText = 'Variation'
            showerror('Menü', 'Ausgabe: Variation angewählt') 
        
        #Ausgabe Hilfe
        if self.nWasZeichnen == HILFE:
            Check.szRahmenText = 'Hilfe'
            
            if Check.nHilfe == 1:
                Check.szRahmenText = '%s - Stufe -' % Check.szRahmenText
                self.HilfeStufe(nKanal)
            
            if Check.nHilfe == 2:
                Check.szRahmenText = '%s - Geschwindigkeitsdreiecke -'
                self.HilfeDreiecke(nKanal)
            
            if Check.nHilfe == 3:
                Check.szRahmenText = '%s - Schaufel -' % Check.szRahmenText
                self.HilfeSchaufel(nKanal)
        
        #Rahmen zeichenen?
        if Check.bRahmen.get():
            self.ZeicheneRahmen()
    
    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def Draw(self,  nKanal):
        self.pViewport.Clear()
        self.MittelPaint(nKanal)

    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def Drucken(self):
        strDatei = None
        #In eine Datei drucken?
        if self.Vars.pCheck.bPrintToFile.get():
            #Dialog zum speichern des Ausdrucks aufrufen
            strDatei = asksaveasfilename(filetypes=[('Postscript',  '*.ps'),  ('Alle Dateien',  '*.*')],  initialdir='.', title="Mittel - Ausdruck speichern")
        
        #Keine Datei ausgewählt?
        if strDatei == '':
            #Abbrechen
            return
        
        #In Farbe drucken?
        if self.Vars.pCheck.bDruckFarbe.get():
            colormode = 'color'
        else:
            colormode = 'mono'
        
        self.pViewport.Drucken(strDatei,  colormode)
        
        #ToDo:ResizeBug
    
    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    #Farbe wählen
    def Color(self,  nFarbe,  bFarbig):
        #ValueStruktur:
        # PenPattern, PenColor/TextColor
        lValues = None
        if bFarbig == True:
            #Python switch
            lValues =  {
                        0 : ( 'PS_SOLID', makecol(255,  0,  0)),        #rot
                        1 :  ('PS_SOLID',  makecol(0,  0,  255)),       #blau
                        2 : ( 'PS_SOLID', makecol(0,  127,  0)),        #grün
                        3 : ( 'PS_SOLID', makecol(0,  255,  255)),    #türkis
                        4 : ( 'PS_SOLID', makecol(127,  127,  0)),    #oliv 
                        5 : ( 'PS_SOLID', makecol(255,  0,  255)),    #lila 
                        6 : ( 'PS_SOLID', makecol(255,  127,  0)),    #orange
                        7 : ( 'PS_SOLID', makecol(255,  0,  127)),    #pink
                        8 : ( 'PS_SOLID', makecol(127,  0,  0)),         #braun
                        9 : ( 'PS_SOLID', makecol(127,  127,  127)),#grau 
                        10 : ( 'PS_SOLID', makecol(0,  127,  127)),   #türkis
                        11 : ( 'PS_SOLID', makecol(0,  255,  0)),        #hellgrün
                        }[nFarbe]
        else:
            #Pythonswitch
            lValues =  {
                       0 : ('PS_SOLID',  makecol(0,  0,  0)), 
                       5 : ('PS_SOLID',  makecol(0,  0,  0)), 
                       10 : ('PS_SOLID',  makecol(0,  0,  0)), 
                       
                       1 : ('PS_DASH',  makecol(0,  0,  0)), 
                       6 : ('PS_DASH',  makecol(0,  0,  0)), 
                       11 : ('PS_DASH',  makecol(0,  0,  0)), 
                       
                       2 : ('PS_DOT',  makecol(0,  0,  0)), 
                       7 : ('PS_DOT',  makecol(0,  0,  0)), 
                       12 : ('PS_DOT',  makecol(0,  0,  0)), 
                       
                       3 : ('PS_DASHDOT',  makecol(0,  0,  0)), 
                       8 : ('PS_DASHDOT',  makecol(0,  0,  0)), 
                       
                       4 : ('PS_DASHDOTDOT',  makecol(0,  0,  0)), 
                       9 : ('PS_DASHDOTDOT',  makecol(0,  0,  0)), 
                       }[nFarbe]
        
        #Werte setzen
        self.pViewport.SetPen(lValues[0],  1,  lValues[1])
        self.pViewport.SetTextColor(lValues[1])
    
    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    #Zeichnet einen Pfeil
    def Pfeil(self,  iFromX,  iFromY, iToX,  iToY):
        f1 = 0.0
        f2 = 0.0
        dAlpha = 0.0
        
        if iFromX < iToX:
            f1 = 1.0
        else:
            f1 = -1.0
        
        if iFromY < iToY:
            f2 = 1.0
        else:
            f2 = -1.0
        
        if (iToX - iFromX) == 0:
            dAlpha = 3.1415926/2.0
        else:
            dAlpha = atan((f2*float(iToY-iFromY))/f1/float(iToX-iFromX))
        
        #Alpha negativ?
        if dAlpha < 0:
            dAlpha = -1.0*dAlpha
        
        iTempX1 = int(float(iToX)-f1*20.0*cos(dAlpha))
        iTempY1 = int(float(iToY)-f2*20.0*sin(dAlpha))
        
        iTempX2 = int(f1*f2*5.0*sin(dAlpha))
        iTempY2 = int(5.0*cos(dAlpha))
        
        #Startposition einnehmen
        self.pViewport.MoveTo(iFromX,  iFromY)
        #Pfeilrumpf
        self.pViewport.LineTo(iTempX1,  iTempY1)
        #Pfeilspitze
        self.pViewport.LineTo(iTempX1-iTempX2,  iTempY1+iTempY2)
        self.pViewport.LineTo(iToX,  iToY)
        self.pViewport.LineTo(iTempX1+iTempX2,  iTempY1-iTempY2)
        self.pViewport.LineTo(iTempX1,  iTempY1)
    
    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    #Zeichnet den Rahmen
    def ZeicheneRahmen(self):
        #Farbe setzen
        self.Color(0,  False)
        
        strDate = datetime.date.today().strftime('%Y-%m-%d')
        
        #DatenTabelle: Operation, XPos, YPos
        pOps = [
                #Rahmen zeichnen
                (M,  30, 900),
                (L,  1390, 900),
                (M, 300, 900),
                (L,  300, 980),
                (M, 1120, 900),
                (L,  1120, 980),
                #LFA zeichnen
                (M, 100, 970),
                (L, 100+ int(9*4)     , 970-int(0*4)),
                (L, 100+ int(9.75*4.0)  , 970-int(2.5*4.0)),
                (L, 100+ int(5.5*4.0)   , 970-int(2.5*4.0)),
                (L, 100+ int(10.5*4.0)  , 970-int(14*4)),
                (L, 100+ int(8.75*4.0)  , 970-int(14*4)),
                (L, 100+ int(0*4)     , 970-int(0*4)),
             
                (M, 100+ int(9.75*4.0)  , 970-int(0*4)),
                (L, 100+ int(13*4)    , 970-int(0*4)),
                (L, 100+ int(13.25*4.0) , 970-int(7*4)),
                (L, 100+ int(17*4)    , 970-int(7*4)),
                (L, 100+ int(16.5*4.0)  , 970-int(9.25*4.0)),
                (L, 100+ int(13.25*4.0) , 970-int(9.25*4.0)),
                (L, 100+ int(13.5*4.0)  , 970-int(12.75*4.0)),
                (L, 100+ int(16*4)    , 970-int(12.75*4.0)),
                (L, 100+ int(15.5*4.0)  , 970-int(14*4)),
                (L, 100+ int(12.5*4.0)  , 970-int(14*4)),
                (L, 100+ int(9.75*4.0)  , 970-int(0*4)),
             
                (M, 100+ int(19.5*4.0)  , 970-int(0*4)),
                (L, 100+ int(22.75*4.0) , 970-int(0*4)),
                (L, 100+ int(19.75*4.0) , 970-int(7*4)),
                (L, 100+ int(21.5*4.0)  , 970-int(7*4)),
                (L, 100+ int(25.5*4.0)  , 970-int(0*4)),
                (L, 100+ int(28.5*4.0)  , 970-int(0*4)),
                (L, 100+ int(19.25*4.0) , 970-int(14*4)),
                (L, 100+ int(16*4)    , 970-int(14*4)),
                (L, 100+ int(19.5*4.0)  , 970-int(0*4)),
             
                (M, 100+ int(19*4)    , 970-int(9.25*4.0)),
                (L, 100+ int(20.75*4.0) , 970-int(9.25*4.0)),
                (L, 100+ int(19*4)    , 970-int(12.75*4.0)),
                (L, 100+ int(17.5*4.0)  , 970-int(12.75*4.0)),
                (L, 100+ int(19*4)    , 970-int(9.25*4.0)),
                #Text
                (T,  350,  910,  '%s   %s' % (self.Vars.pCheck.szRahmenText,  self.Vars.pSteuer.szText)), 
                (T,  350,  950,  'Datei: %s' % (self.Main.Calc.OutFileName)), 
                (T,  1170,  910,  strDate), 
                (T,  1170,  950,  'TU München')
                ]
        
        #Zeichnen
        self.AutoDraw(pOps)
    
    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def AutoDraw(self,  Ops):
        #Zeichen
        for Entry in Ops:
            #Move To?
            if Entry[0] == M:
                self.pViewport.MoveTo(Entry[1],  Entry[2])
            #LineTo?
            if Entry[0] == L:
                self.pViewport.LineTo(Entry[1],  Entry[2])
            #TextOut
            if Entry[0] == T:
                self.pViewport.TextOut(Entry[1],  Entry[2],  Entry[3])
            if Entry[0] == A:
                self.pViewport.Arc(Entry[1],  Entry[2],  Entry[3], Entry[4],  Entry[5],  Entry[6])
    
    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    #Zeichnet die Dreiecke
    def ZeicheneDreiecke(self,  nKanal):
        #Daten einlesen
        if not self.Main.Calc.bDrawCalc:
            self.Main.Calc.DrawCalc()
        
        #Zeilen berechnen
        nZeilen = int(250/self.Main.Calc.nEbenen)
        dMaxGeschw = self.Main.Calc.dMaxGeschw
        dMaxWu = self.Main.Calc.dMaxWu
        
        #Kanal == 0 -> Ausgabe auf Bildschirm oder Farbdrucker
        #Kanal == 1 -> Ausgabe auf dem SW-Drucker
        if(nKanal == 1) or (self.Vars.pCheck.bDreieck[11].get() == False):
            bFarbe = False
        else:
            bFarbe = self.Vars.pCheck.bDreieck[11].get()
        
        #Dreiecke nicht okay?
        if not self.Main.Calc.bGeschwOK:
            return
        
        #Farbe setzen
        self.Color(0,  False)
        
        #Legende zeichnen?
        if self.Vars.pCheck.bDreieck[12].get():
            pLegende =  [
                         (M,  60,  635), 
                         (L,  1380,  635), 
                         (T,  100,  605,  'Ebene'), 
                         (T,  250,  605,  'c'), 
                         (T,  400,  605,  'c_ax'), 
                         (T,  550,  605,  'c_u'), 
                         (T,  700,  605,  'r_rad'), 
                         (T,  850,  605,  'w'), 
                         (T,  1000,  605,  'w_u'),
                         (T,  1150,  605,  'u'),  
                         ]
            
            #Zeichnen
            self.AutoDraw(pLegende)
        
        #Maßstab zeichnen?
        if self.Vars.pCheck.bDreieck[14].get():
            #Bißchen rumrechnen
            nHilf = 0
            dHilf2 = pow(10,  int(log(dMaxGeschw)/log(10.0)))
            #Prüfen
            if dMaxGeschw/dHilf2 < 6.0:
                if dMaxGeschw/dHilf2 < 4.0:
                    nHilf = 4
                else:
                    nHilf = 2
            else:
                nHilf = 1
            
            nJ = 0
            #Zeichnen
            while(nJ <= int(3.0/4.0*dMaxGeschw/dHilf2)):
                for nK in range(nHilf):
                    dHilf1 = dHilf2*(float(nJ)+float(nK)/float(nHilf))
                    Summand = int(500.0/dMaxGeschw*dHilf1)
                    
                    pOps = [
                            (M,  1000,  100+Summand), 
                            (L,  1010, 100+Summand), 
                            (T, 1015,  85+Summand,  '%i' % dHilf1)
                            ]
                    
                    #Zeichnen
                    self.AutoDraw(pOps)
                nJ += 1
            
            #Pfeile zeichnen
            self.Pfeil(1000,  100,  1000,  500)
            
            pOps = [
                    (T,  1150,  300,  'Einheit:'), 
                    (T,  1150,  340,  ' [m/s]')
                    ]
            
            #Zeichnen
            self.AutoDraw(pOps)
        
        #Ebenenweise Darstellung
        for Ebene in range(self.Main.Calc.nEbenen):
            #Farbe setzen
            self.Color(Ebene,  bFarbe)
            #Dreieck gewünscht?
            if self.Vars.pCheck.bDreieck[Ebene+1].get():
                #Zeichnen der Dreiecke
                fSkalar = 500.0/dMaxGeschw
                iMaxGeschwWu = int(fSkalar*dMaxWu)
                
                pGeschw = self.Vars.pGeschw[Ebene]
                
                if Ebene == self.Main.Calc.nEbenen-1:
                    if (Ebene == 0) and (self.Vars.pEBWerte[Ebene].nKgit == 2):
                        self.Pfeil(100+iMaxGeschwWu,  100,  100+iMaxGeschwWu+int(fSkalar*pGeschw.dCu), 100+int(fSkalar*pGeschw.dCax) )
                    else:
                        pass
                        self.Pfeil(100+iMaxGeschwWu,  100,  100+iMaxGeschwWu+int(fSkalar*pGeschw.dCu), 100+int(fSkalar*pGeschw.dCax) )
                else:
                    self.Pfeil(100+iMaxGeschwWu,  100,  100+iMaxGeschwWu+int(fSkalar*pGeschw.dCu), 100+int(fSkalar*pGeschw.dCax) )
                    self.Pfeil(100+int((fSkalar*dMaxWu)- (fSkalar*pGeschw.dWu)),  100+int(fSkalar*pGeschw.dCax),  100+int((fSkalar*dMaxWu)+(fSkalar*pGeschw.dCu)),100+int(fSkalar*pGeschw.dCax))
                    self.Pfeil(100+int(fSkalar*dMaxWu),  100,  100+int((fSkalar*dMaxWu)-(fSkalar*pGeschw.dWu)),  100+int(fSkalar*pGeschw.dCax))
                #Legende zeichen
                if self.Vars.pCheck.bDreieck[12].get():
                    #Farbig?
                    if bFarbe:
                        self.pViewport.MoveTo(70,  650+Ebene*nZeilen)
                        self.pViewport.LineTo(90,  650+Ebene*nZeilen)
                        self.pViewport.TextOut(120,  640+Ebene*nZeilen,  '%i. Eb.' % (Ebene+1))
                    else:
                        self.pViewport.TextOut(100,  640+Ebene*nZeilen,  '%i. Eb.' % (Ebene+1))
                    
                    #Text erstellen
                    pOps = [
                            (T, 250,  640+Ebene*nZeilen,  ('%.5f' % (pGeschw.dC)).rstrip('0')), 
                            (T, 400,  640+Ebene*nZeilen,  ('%.5f' % (pGeschw.dCax)).rstrip('0')), 
                            (T, 550,  640+Ebene*nZeilen,  ('%.5f' % (pGeschw.dCu)).rstrip('0')), 
                            (T, 700,  640+Ebene*nZeilen,  ('%.5f' % (pGeschw.dCr)).rstrip('0')), 
                            (T, 850,  640+Ebene*nZeilen,  ('%.5f' % (pGeschw.dW)).rstrip('0')),
                            (T, 1000,  640+Ebene*nZeilen,  ('%.5f' % (pGeschw.dWu)).rstrip('0')), 
                            (T, 1150,  640+Ebene*nZeilen,  ('%.5f' % (pGeschw.dU)).rstrip('0')),  
                            ]
                    
                    #Zeichnen
                    self.AutoDraw(pOps)
                
                #Zeichen eintragen
                if self.Vars.pCheck.bDreieck[13].get():
                    strC = 'c'
                    strU = 'u'
                    strW = 'w'
                    #Farbig?
                    if not bFarbe:
                        #Zahlen anhängen
                        strC = '%s%i' % (strC,  Ebene+1)
                        strU = '%s%i' %(strU,  Ebene+1)
                        strW = '%s%i' %(strW,  Ebene+1)
                    
                    #Dreieck beschriften
                    self.pViewport.TextOut(int(200.0+2.0*(fSkalar*dMaxWu)+(fSkalar*pGeschw.dCu))/2, int(200.0+(fSkalar*pGeschw.dCax)),  strC)
                    #Nicht letzte Ebene
                    if Ebene < self.Main.Calc.nEbenen:
                        self.pViewport.TextOut(int(200.0+2.0*(fSkalar*dMaxWu)+(fSkalar*pGeschw.dCu)-(fSkalar*pGeschw.dWu))/2,  int(200.0+2.0*(fSkalar*pGeschw.dCax))/2,  strU)
                        self.pViewport.TextOut(int(200.0+2.0*(fSkalar*dMaxWu)+(fSkalar*pGeschw.dWu))/2,  int(200.0+(fSkalar*pGeschw.dCax))/2,  strW)

    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def ZeicheneKanal(self,  nKanal):
        
        #Bei Halbkanal
        nX0 = 60
        nY0 = 400
        nXmax = 900
        nYmax = 300
        
        #Halbkanal oder nicht?
        if not self.bHalbKanal:
            nX0 = 50
            nY0 = 400
            nXmax = 1000
            nYmax = 300
        
        nEbenen = self.Vars.pSteuer.nEbene
        
        self.Vars.pEBWerte[nEbenen-1].dBax = 0.0
        
        dMaxKanalx = 0.0
        dMaxKanaly = 0.0
        
        bFarbe = self.Vars.pCheck.bKanal[8].get()
        
        #Farbe?
        if (nKanal == 1) or (not self.Vars.pCheck.bKanal[8].get()):
            bFarbe = False
        
        #Aus dem Original Quelltext:
        #Laden der Werte aus der Datei
        #derzeit nicht vorhanden
        
        #Berechnung
        #Bestimmung der Max-Werte als Streckungsfaktoren
        for Ebene in range(nEbenen-1):
            dMaxKanaly = max(dMaxKanaly,  self.Vars.pEBWerte[Ebene].dRggeo)
            dMaxKanalx += self.Vars.pEBWerte[Ebene].dBax
        
        if self.Vars.pCheck.bKanal[7].get() and (not self.bHalbKanal):
            if dMaxKanaly > dMaxKanalx:
                dMaxKanalx = dMaxKanalx
            else:
                dMaxKanaly = dMaxKanalx
            
            if 2*nYmax > nXmax:
                nYmax = nXmax/2
            else:
                nXmax = 2*nYmax
        
        dGehRel = [0.0]*10
        dNabRel = [0.0]*10
        dBaxRel = [0.0]*10
        
        #Redefinition der Gehäusedurchmesser mit der Einheit [1/1000 Bildschirmlängen]
        for Ebene in range(nEbenen):
            dGehRel[Ebene] = self.Vars.pEBWerte[Ebene].dRggeo*nYmax/dMaxKanaly
            dNabRel[Ebene] = self.Vars.pEBWerte[Ebene].dRngeo*nYmax/dMaxKanaly
            dBaxRel[Ebene] = self.Vars.pEBWerte[Ebene].dBax*nXmax/dMaxKanalx
        
        dBaxRelGes = [0.0]*10
        for Ebene in range(nEbenen-1):
            dBaxRelGes[Ebene+1] = dBaxRelGes[Ebene]+dBaxRel[Ebene]
        
        dSteigungN = [0.0]*10
        dSteigungG = [0.0]*10
        
        #Bestimmung der Wand-Steigung
        for Ebene in range(nEbenen-1):
            dSteigungN[Ebene] =(dNabRel[Ebene+1]-dNabRel[Ebene])/dBaxRel[Ebene]  # Steigung an der Nabe
            dSteigungG[Ebene] =(dGehRel[Ebene+1]-dGehRel[Ebene])/dBaxRel[Ebene]  # Steigung am Gehäuse
        
        dSteigungN[nEbenen-1] = (dNabRel[nEbenen-1]-dNabRel[nEbenen-2])/dBaxRel[nEbenen-2]
        dSteigungG[nEbenen-1] = (dGehRel[nEbenen-1]-dGehRel[nEbenen-2])/dBaxRel[nEbenen-2]
        
        #Zeichnen der Strichlinen, des Umlaufbogens, der Strömungsrichtung
        self.Color(0,  FALSE)
        
        pOps = []
        
        for Counter in range(61):
            pOps.append((M,  nX0+42+int(float(nXmax)/50.0*float(Counter)),  nY0))
            pOps.append((L,  nX0+42+int(float(nXmax)/50.0*(float(Counter)+0.5)),  nY0))
        
        self.AutoDraw(pOps)
        
        pOps = [
                (A,  nX0+50, nY0-30, nX0+80, nY0+30,  20.0,  320.0), 
                (M, nX0+83, nY0-20),
                (L, nX0+80, nY0-7),
                (L, nX0+70, nY0-20),
                ]
        
        #Halbkanal?
        if not self.bHalbKanal:
            pOps.extend([
            (M, nX0+  1, nY0+(dGehRel[0]+dNabRel[0])/2.0),
            (L, nX0+ 60, nY0+(dGehRel[0]+dNabRel[0])/2.0),
            (L, nX0+ 40, nY0+(dGehRel[0]+dNabRel[0])/2.0+10),
            (M, nX0+ 60, nY0+(dGehRel[0]+dNabRel[0])/2.0),
            (L, nX0+ 40, nY0+(dGehRel[0]+dNabRel[0])/2.0-10)
            ])
        
        pOps.extend([
        (M, nX0+  1, nY0-int((dGehRel[0]+dNabRel[0])/2.0)),
        (L, nX0+ 60, nY0-int((dGehRel[0]+dNabRel[0])/2.0)),
        (L, nX0+ 40, nY0-int((dGehRel[0]+dNabRel[0])/2.0)+10),
        (M, nX0+ 60, nY0-int((dGehRel[0]+dNabRel[0])/2.0)),
        (L, nX0+ 40, nY0-int((dGehRel[0]+dNabRel[0])/2.0)-10),
        
        (M, nX0+  80, nY0-nYmax-10),
        (L, nX0+  80, nY0-nYmax),
        (L, nX0+ 100, nY0-nYmax),
        (L, nX0+ 100, nY0-int(dGehRel[0])),
        (M, nX0+ 100, nY0),
        (L, nX0+ 100, nY0-int(dNabRel[0])),
        ])

        if not self.bHalbKanal:
            pOps.extend([
            (M, nX0+  80, nY0+nYmax+10),
            (L, nX0+  80, nY0+nYmax),
            (L, nX0+ 100, nY0+nYmax),
            (L, nX0+ 100, nY0+int(dGehRel[0])),
            (M, nX0+ 100, nY0),
            (L, nX0+ 100, nY0+int(dNabRel[0]))
            ])
        
        #Zeichnen
        self.AutoDraw(pOps)
        pOps = []
        
        #Ebenen zeichnen
        for nI in range(nEbenen-1):
            #Leitrad und Laufrad unterscheiden
            if self.Vars.pEBWerte[nI].nKgit == 2:   #Leitrad
                pOps.extend([
                    (M, nX0+ 100+int(dBaxRelGes[nI]), nY0-int(dGehRel[nI])),
                    (L, nX0+ 100+int(dBaxRelGes[nI]+0.03*dBaxRel[nI]), nY0-int(-dSteigungG[nI]*0.03*dBaxRel[nI]+dGehRel[nI])),
                    (L, nX0+ 100+int(dBaxRelGes[nI]+0.03*dBaxRel[nI]), nY0-int(-dSteigungN[nI]*0.03*dBaxRel[nI]+1.07*dNabRel[nI])),
                    (L, nX0+ 100+int(dBaxRelGes[nI]+0.97*dBaxRel[nI]), nY0-int(+dSteigungN[nI]*0.97*dBaxRel[nI]+1.07*dNabRel[nI])),
                    (L, nX0+ 100+int(dBaxRelGes[nI]+0.97*dBaxRel[nI]), nY0-int(+dSteigungG[nI]*0.97*dBaxRel[nI]+dGehRel[nI])),
                    (L, nX0+ 100+int(dBaxRelGes[nI]+dBaxRel[nI]), nY0-int(dGehRel[nI+1])),
                    (L, nX0+ 100+int(dBaxRelGes[nI]), nY0-int(dGehRel[nI])),
                    (M, nX0+ 100+int(dBaxRelGes[nI]), nY0-int(dNabRel[nI])),
                    (L, nX0+ 100+int(dBaxRelGes[nI]+dBaxRel[nI]), nY0-int(dNabRel[nI+1])), 
                ])
                
                #HalbKanal?
                if not self.bHalbKanal:
                    pOps.extend([
                        (M, nX0+ 100+int(dBaxRelGes[nI]), nY0+int(dGehRel[nI])),
                        (L, nX0+ 100+int(dBaxRelGes[nI]+0.03*dBaxRel[nI]), nY0+int(-dSteigungG[nI]*0.03*dBaxRel[nI]+dGehRel[nI])),
                        (L, nX0+ 100+int(dBaxRelGes[nI]+0.03*dBaxRel[nI]), nY0+int(-dSteigungN[nI]*0.03*dBaxRel[nI]+1.07*dNabRel[nI])),
                        (L, nX0+ 100+int(dBaxRelGes[nI]+0.97*dBaxRel[nI]), nY0+int(+dSteigungN[nI]*0.97*dBaxRel[nI]+1.07*dNabRel[nI])),
                        (L, nX0+ 100+int(dBaxRelGes[nI]+0.97*dBaxRel[nI]), nY0+int(+dSteigungG[nI]*0.97*dBaxRel[nI]+dGehRel[nI])),
                        (L, nX0+ 100+int(dBaxRelGes[nI+1]), nY0+int(dGehRel[nI+1])),
                        (L, nX0+ 100+int(dBaxRelGes[nI]), nY0+int(dGehRel[nI])),
                        (M, nX0+ 100+int(dBaxRelGes[nI]), nY0+int(dNabRel[nI])),
                        (L, nX0+ 100+int(dBaxRelGes[nI+1]), nY0+int(dNabRel[nI+1]))
                    ])
                    
                    #Farbe?
                    if self.Vars.pCheck.bKanal[8].get() and (nKanal == 0):
                        pass
                        #ToDo: Routine für FloodFill >.<
                        #Farbe einstellen
                        #Flood fill O.o
            else:   #Laufrad
                pOps.extend([
                    (M, nX0+ 100+int(dBaxRelGes[nI]), nY0-int(dNabRel[nI])),
                    (L, nX0+ 100+int(dBaxRelGes[nI]+0.03*dBaxRel[nI]), nY0-int(-dSteigungN[nI]*0.03*dBaxRel[nI]+dNabRel[nI])),
                    (L, nX0+ 100+int(dBaxRelGes[nI]+0.03*dBaxRel[nI]), nY0-int(-dSteigungG[nI]*0.03*dBaxRel[nI]+0.97*dGehRel[nI])),
                    (L, nX0+ 100+int(dBaxRelGes[nI]+0.97*dBaxRel[nI]), nY0-int(+dSteigungG[nI]*0.97*dBaxRel[nI]+0.97*dGehRel[nI])),
                    (L, nX0+ 100+int(dBaxRelGes[nI]+0.97*dBaxRel[nI]), nY0-int(+dSteigungN[nI]*0.97*dBaxRel[nI]+dNabRel[nI])),
                    (L, nX0+ 100+int(dBaxRelGes[nI+1]), nY0-int(dNabRel[nI+1])),
                    (L, nX0+ 100+int(dBaxRelGes[nI]), nY0-int(dNabRel[nI])),
                    (M, nX0+ 100+int(dBaxRelGes[nI]), nY0-int(dGehRel[nI])),
                    (L, nX0+ 100+int(dBaxRelGes[nI+1]), nY0-int((dGehRel[nI+1]))),
                ])
                
                #Halbkanal?
                if not self.bHalbKanal:
                    pOps.extend([
                        (M, nX0+ 100+int(dBaxRelGes[nI]), nY0+int(dNabRel[nI])),
                        (L, nX0+ 100+int(dBaxRelGes[nI]+0.03*dBaxRel[nI]), nY0+int((-dSteigungN[nI]*0.03*dBaxRel[nI]+dNabRel[nI]))),
                        (L, nX0+ 100+int(dBaxRelGes[nI]+0.03*dBaxRel[nI]), nY0+int((-dSteigungG[nI]*0.03*dBaxRel[nI]+0.97*dGehRel[nI]))),
                        (L, nX0+ 100+int(dBaxRelGes[nI]+0.97*dBaxRel[nI]), nY0+int((+dSteigungG[nI]*0.97*dBaxRel[nI]+0.97*dGehRel[nI]))),
                        (L, nX0+ 100+int(dBaxRelGes[nI]+0.97*dBaxRel[nI]), nY0+int((+dSteigungN[nI]*0.97*dBaxRel[nI]+dNabRel[nI]))),
                        (L, nX0+ 100+int(dBaxRelGes[nI+1]), nY0+int((dNabRel[nI+1]))),
                        (L, nX0+ 100+int(dBaxRelGes[nI]), nY0+int(dNabRel[nI])),
                        (M, nX0+ 100+int(dBaxRelGes[nI]), nY0+int(dGehRel[nI])),
                        (L, nX0+ 100+int(dBaxRelGes[nI+1]), nY0+int(dGehRel[nI+1])),
                    ])
                    
                    #Farbe?
                    if self.Vars.pCheck.bKanal[8].get() and (nKanal == 0):
                        pass
                        #ToDo: Routine für FloodFill >.<
                        #Farbe einstellen
                        #Flood fill O.o
        
        #Zeichnen
        self.AutoDraw(pOps)
        
        #Und weiter gehts
        pOps = [
            (M,  nX0+100+int(dBaxRelGes[nEbenen-1]), nY0-int(dGehRel[nEbenen-1])),
            (L,  nX0+100+int(dBaxRelGes[nEbenen-1]), nY0-nYmax),
        ]
        
        #HalbKanal?
        if self.bHalbKanal:
            pOps.extend([
                (L,  nX0+100+nXmax+20, nY0-nYmax),
                (L,  nX0+100+nXmax+20, nY0-nYmax-10),
            ])
        else:
            pOps.extend([
                (L,  nX0+100+nXmax+20, nY0-nYmax),
                (L,  nX0+100+nXmax+20, nY0-nYmax-10),
            ])
        
        pOps.extend([
            (L,  nX0+ 80, nY0-nYmax-10),
            (M,  nX0+99+int(dBaxRelGes[nEbenen-1]), nY0-int(dNabRel[nEbenen-1])),
            (L, nX0+100+int(dBaxRelGes[nEbenen-1]), nY0-int(dNabRel[nEbenen-1])),
            (L,  nX0+100+int(dBaxRelGes[nEbenen-1]), nY0),
        ])
        
        #Halbkanal?
        if not self.bHalbKanal:
            pOps.extend([
                (L,  nX0+100+int(dBaxRelGes[nEbenen-1]), nY0+int(dNabRel[nEbenen-1])),
                (M,  nX0+100+int(dBaxRelGes[nEbenen-1]), nY0+int(dGehRel[nEbenen-1])),
                (L,  nX0+100+int(dBaxRelGes[nEbenen-1]), nY0+nYmax),
                (L,  nX0+100+nXmax+20, nY0+nYmax),
                (L,  nX0+100+nXmax+20, nY0+nYmax+10),
                (L,  nX0+ 80, nY0+nYmax+10),
            ])
        
        if self.Vars.pCheck.bKanal[8].get() and (nKanal == 0) and (not self.bHalbKanal):   # Farbe zeichnen
            pass
            """
            ToDo: Flood Fill
            Schonwieder Flood Fill >.<
            hOldObj = SelectObject(hDC, CreateSolidBrush(RGB(127, 127, 127))),  #grau
            DeleteObject(hOldObj),
            FloodFill(hDC, nX0+ 100, nY0-nYmax-5, RGB(0, 0, 0)),
            FloodFill(hDC, nX0+ 100, nY0+nYmax+5, RGB(0, 0, 0)),
            hOldObj = SelectObject(hDC, CreateSolidBrush(RGB(127, 0, 0))),  #braun
            DeleteObject(hOldObj),
            FloodFill(hDC, int(nX0+100+nXmax/5.0), nY0-5, RGB(0, 0, 0)),"""
        
        #Zeichnen
        self.AutoDraw(pOps)
        
        pOps = []
        #Kanal beschriften
        if not self.bHalbKanal:
            #Ebenenbezeichnung
            if self.Vars.pCheck.bKanal[1].get() or self.Vars.pCheck.bKanal[2].get():
                #Ebenenbezeichnung
                for nI in range(nEbenen):
                    nJ = nI % 2
                    
                    if self.Vars.pCheck.bKanal[1].get():
                        pOps.extend([
                            (M,  nX0+ 100+int(dBaxRelGes[nI]), nY0), 
                            (L,  nX0+ 100+int(dBaxRelGes[nI]), nY0+nYmax+130 + nJ*30), 
                            (T,  nX0+50+(int)(dBaxRelGes[nI]), nY0+nYmax+130+nJ*30,  '%i. Ebene' % (nI+1))
                        ])
                    else:
                        pOps.extend([
                            (M, nX0+ 100+int(dBaxRelGes[nI]), nY0 ), 
                            (L,  nX0+ 100+int(dBaxRelGes[nI]), nY0+nYmax+130)
                        ])
        else:
            for nI in range(nEbenen):
                pOps.extend([
                    (M,  nX0+100+(int)(dBaxRelGes[nI]), nY0), 
                    (L,  nX0+100+(int)(dBaxRelGes[nI]), nY0+10), 
                    (T,  nX0+int(dBaxRelGes[nI]+90), nY0+20,  '%i. Eb.' % (nI+1))
                ])
        
        #Axiale Abstände/Ebenenabstände
        if self.Vars.pCheck.bKanal[2].get() and (not self.bHalbKanal):
            for nI in range(nEbenen-1):
                nJ = nI % 2
                
                pOps.extend([
                    (M, nX0+120+int(dBaxRelGes[nI]), nY0+nYmax+115),
                    (L, nX0+120+int(dBaxRelGes[nI]), nY0+nYmax+120),
                    (L, nX0+100+int(dBaxRelGes[nI]), nY0+nYmax+115),
                    (L, nX0+120+int(dBaxRelGes[nI]), nY0+nYmax+110),
                    (L, nX0+120+int(dBaxRelGes[nI]), nY0+nYmax+115),
                    (L, nX0+ 80+int(dBaxRelGes[nI]+dBaxRel[nI]), nY0+nYmax+115),
                    (L, nX0+ 80+int(dBaxRelGes[nI]+dBaxRel[nI]), nY0+nYmax+110),
                    (L, nX0+100+int(dBaxRelGes[nI]+dBaxRel[nI]), nY0+nYmax+115),
                    (L, nX0+ 80+int(dBaxRelGes[nI]+dBaxRel[nI]), nY0+nYmax+120),
                    (L, nX0+ 80+int(dBaxRelGes[nI]+dBaxRel[nI]), nY0+nYmax+115), 
                    (T,  nX0+100+int(dBaxRelGes[nI]+dBaxRel[nI]/10.0), nY0+nYmax+55+nJ*25,  '%s m' % ('%.5f' % self.Vars.pEBWerte[nI].dBax).rstrip('0'))
                ])
        
        #Allgemeine Bezeichnungen
        if self.Vars.pCheck.bKanal[5].get() and (not self.bHalbKanal):
            for nI in range(nEbenen):
                if self.Vars.pEBWerte[nI].nKgit == 1:
                    pOps.extend([(T,  nX0+100+int(dBaxRelGes[nI]+dBaxRel[nI]/10.0), nY0+nYmax+20,  'Laufrad')])
                if self.Vars.pEBWerte[nI].nKgit == 2:
                    pOps.extend([(T,  nX0+100+int(dBaxRelGes[nI]+dBaxRel[nI]/10.0), nY0+nYmax+20,  'Leitrad')])
        
        #Bemaßung der Durchmesser
        if self.Vars.pCheck.bKanal[3].get() and (not self.bHalbKanal):
            pOps.extend([
                (M, nX0+nXmax+200-50, nY0-int(dGehRel[0])),
                (L, nX0+nXmax+200-20, nY0-int(dGehRel[0])),
                (L, nX0+nXmax+200-25, nY0-int(dGehRel[0])),
                (L, nX0+nXmax+200-20, nY0-int(dGehRel[0]-20.0)),
                (L, nX0+nXmax+200-30, nY0-int(dGehRel[0]-20.0)),
                (L, nX0+nXmax+200-25, nY0-int(dGehRel[0])),
                (M, nX0+nXmax+200-25, nY0-int(dGehRel[0]-20.0)),
                (L, nX0+nXmax+200-25, nY0-int(dGehRel[0]/2.0-10.0)),
                (M, nX0+nXmax+200-50, nY0+int(dNabRel[0])),
                (L, nX0+nXmax+200-40, nY0+int(dNabRel[0])),
                (L, nX0+nXmax+200-45, nY0+int(dNabRel[0])),
                (L, nX0+nXmax+200-40, nY0+int(dNabRel[0]-20.0)),
                (L, nX0+nXmax+200-50, nY0+int(dNabRel[0]-20.0)),
                (L, nX0+nXmax+200-45, nY0+int(dNabRel[0])),
                (M, nX0+nXmax+200-45, nY0+int(dNabRel[0]-20.0)),
                (L, nX0+nXmax+200-45, nY0+int(dNabRel[0]/2.0-10.0)),
                (M, nX0+nXmax+200-50, nY0-int(dGehRel[nEbenen-1])),
                (L, nX0+nXmax+200-40, nY0-int(dGehRel[nEbenen-1])),
                (L, nX0+nXmax+200-45, nY0-int(dGehRel[nEbenen-1])),
                (L, nX0+nXmax+200-40, nY0-int(dGehRel[nEbenen-1]-20.0)),
                (L, nX0+nXmax+200-50, nY0-int(dGehRel[nEbenen-1]-20.0)),
                (L, nX0+nXmax+200-45, nY0-int(dGehRel[nEbenen-1])),
                (M, nX0+nXmax+200-45, nY0-int(dGehRel[nEbenen-1]-20.0)),
                (L, nX0+nXmax+200-45, nY0-int(dGehRel[nEbenen-1]/2.0-10.0)),
                (M, nX0+nXmax+200-50, nY0+int(dNabRel[nEbenen-1])),
                (L, nX0+nXmax+200-20, nY0+int(dNabRel[nEbenen-1])),
                (L, nX0+nXmax+200-25, nY0+int(dNabRel[nEbenen-1])),
                (L, nX0+nXmax+200-20, nY0+int(dNabRel[nEbenen-1]-20.0)),
                (L, nX0+nXmax+200-30, nY0+int(dNabRel[nEbenen-1]-20.0)),
                (L, nX0+nXmax+200-25, nY0+int(dNabRel[nEbenen-1])),
                (M, nX0+nXmax+200-25, nY0+int(dNabRel[nEbenen-1]-20.0)),
                (L, nX0+nXmax+175, nY0+int(dNabRel[nEbenen-1]/2.0-10.0))
            ])
            
            dHilf = min(dGehRel[0],  dGehRel[nEbenen-1])/2.0
            
            #Beschriftung
            pOps.extend([
                (T,  nX0+nXmax+155,  nY0-int(dHilf-40.0),  '%s m' % ('%.5f' % self.Vars.pEBWerte[0].dRggeo).rstrip('0')), 
                (T,  nX0+nXmax+175,  nY0-int(dHilf),  '%s m' % ('%.5f' % self.Vars.pEBWerte[nEbenen-1].dRggeo).rstrip('0'))
            ])
            
            dHilf = min(dNabRel[0],  dNabRel[nEbenen-1])/2.0
            
            #Beschriftung
            pOps.extend([
                (T,  nX0+nXmax+155,  nY0+int(dHilf-40.0),  '%s m' % ('%.5f' % self.Vars.pEBWerte[0].dRngeo).rstrip('0')), 
                (T,  nX0+nXmax+175,  nY0+int(dHilf), '%s m' %  ('%.5f' % self.Vars.pEBWerte[nEbenen-1].dRngeo).rstrip('0'))
            ])
        
        #Zeichnen
        self.AutoDraw(pOps)
        pOps = []
        
        #Bezeichnung der Skizze
        
        #Strömung aus
        if self.Vars.pCheck.bKanal[6].get() and (not self.bHalbKanal):
            self.Color(11,  bFarbe)
            
            for nJ in range(4):
                dHilf = (float(nJ)+1.0)*(dGehRel[0]-dNabRel[0])/5.0
                pOps.append((M,  nX0+100+int(dBaxRelGes[0]-0.3*dBaxRel[0]), nY0-int((dNabRel[0]+dHilf))))
                
                #Durch die Ebenen gehen
                for nI in range(nEbenen-1):
                    dHilf=(float(nJ)+1.0)*(dGehRel[nI]-dNabRel[nI])/5.0
                    dHilf2=(float(nJ)+1.0)*((4-nJ)*dSteigungN[nI]/4.0+(float(nJ)+1)*dSteigungG[nI]/4.0)/5.0
                    pOps.append((L,  nX0+100+int(dBaxRelGes[nI]+0.5*dBaxRel[nI]), nY0-int((+dHilf2*0.5*dBaxRel[nI]+dNabRel[nI]+dHilf))))
                
                pOps.append((L, nX0+100+int(dBaxRelGes[nEbenen-1]+0.3*dBaxRel[nEbenen-2]), nY0-int((dHilf2*0.5*dBaxRel[nEbenen-2]+dNabRel[nEbenen-1]+dHilf))))
            self.AutoDraw(pOps)
            pOps = []
            self.Color(0,  False)
        
        #Mittelschnittsradius
        if self.Vars.pCheck.bKanal[4].get() and (not self.bHalbKanal):
            self.Color(1,  bFarbe)
            dDMittel = pow(0.5*(dNabRel[0]*dNabRel[0]+dGehRel[0]*dGehRel[0]), 0.5)
            pOps.append((M,  nX0+100+int(dBaxRelGes[0]), nY0+int(dDMittel)))
            
            for nI in range(nEbenen-1):
                dDMittel = pow(0.5*(dNabRel[nI+1]*dNabRel[nI+1]+dGehRel[nI+1]*dGehRel[nI+1]), 0.5)
                pOps.append((L, nX0+100+int(dBaxRelGes[nI]+dBaxRel[nI]), nY0+int(dDMittel)))
            
            pOps.extend([
                (T,  nX0+nXmax+150, nY0-15+int(dDMittel),  'Mittelschnitts-'), 
                (T,  nX0+nXmax+150, nY0+15+int(dDMittel),  'radius')
            ])
            
            self.AutoDraw(pOps)
            pOps = []
            self.Color(0,  False)
        
        #Zeichnen
        self.AutoDraw(pOps)

    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def ZeicheneVerlauf(self,  nKanal):
        nEbenen = self.Vars.pSteuer.nEbene
        
        #Benötigte FloatVariablen erstellen
        pstr = ''
        for Entry in ('dBaxRel',  'dBax_XK', 'dCax',  'dCaxRel', 'dDttRel','dDzlRel', 'dGeh', 'dGehRel',  'dFla',  'dFlaRel', 'dMit',   'dMitRel','dNab', 'dNabRel', 'dRgrRel',  'dSspRel',  'dTzlRel'):
            pstr = '%s%s = [0.0]*10\n' % (pstr,  Entry)
        
        exec pstr
        
        #Verlauf über die axiale Breite oder die Ebenenzahl?
        bBreite = self.Vars.pCheck.bKVB[13].get()
        
        #Werte füllen
        bKV = [False]*13
        for Index in range(13):
            bKV[Index] = self.Vars.pCheck.bKVB[Index].get()
        
        bFarbe = bKV[11]
        if (not bKV[11]) or (nKanal == 1):
            bFarbe = False
        
        nX0 = 30
        nY0 = 420
        nXMax = 900
        
        #Verlauf mit Daten oder Verdichterquerschnitt
        if bKV[12]:
            nX0 = 0
            nY0 = 0
        else:
            self.ZeicheneKanal(0)
        
        #Durch Ebenen gehen
        for nI in range(self.Vars.pSteuer.nEbene):
            if self.Vars.pSteuer.bKein1:
                dGeh[nI] = self.Vars.pEBWerte[nI].dRggeo
                dNab[nI] = self.Vars.pEBWerte[nI].dRngeo
                dMit[nI] = pow(0.5*(dNab[nI]*dNab[nI]+dGeh[nI]*dGeh[nI]),0.5)
                dFla[nI] = (dGeh[nI]*dGeh[nI]-dNab[nI]*dNab[nI])*3.142
                dCax[nI] = 0.0
            else:
                dGeh[nI] = 0.0
                dNab[nI] = 0.0
                dMit[nI] = self.Vars.pEBWerte[nI].dRmitte
                dCax[nI] = self.Vars.pEBWerte[nI].dCax
                dFla[nI] = 0.0
        
        dMaxMeterx = 0.0
        for nI in range(nEbenen-1):
            dMaxMeterx += self.Vars.pEBWerte[nI].dBax
        
        if dMaxMeterx == 0.0:
            dMaxMeterx = 1.0
        
        dMaxMetery = 0.0
        self.Vars.pEBWerte[nEbenen-1].dBax = 0.0
        for nI in range(nEbenen):
            if self.Vars.pEBWerte[nI].nKgit == 2:
                self.Vars.pEBWerte[nI].dRGrad = 0.0
                self.Vars.pEBWerte[nI].dDeltaTt = 0.0
        
        for nI in range(nEbenen):
            if (dGeh[nI] > dMaxMetery) and bKV[2]:
                dMaxMetery = dGeh[nI]
            if (dNab[nI] > dMaxMetery)  and bKV[1]:
                dMaxMetery = dNab[nI]
            if (dMit[nI] > dMaxMetery) and bKV[3]:
                dMaxMetery = dMit[nI]
            if (self.Vars.pEBWerte[nI].dBax > dMaxMetery) and bKV[10]:
                dMaxMetery = self.Vars.pEBWerte[nI].dBax
        
        if dMaxMetery == 0.0:
            dMaxMetery = 1.0
        
        if (dMaxMetery == 0):
            dMaxMetery = 1;
        
        dMaxMilli = 0.0                   
        for nI in range(nEbenen-1):
            if (self.Vars.pEBWerte[nI].dSsp > dMaxMilli):
                dMaxMilli = self.Vars.pEBWerte[nI].dSsp
        
        if (dMaxMilli == 0):
            dMaxMilli = 1
     
        # Einheit Kelvin [K] für Dtt 
        dMaxKelvin = 0.0                   
        for nI in range(nEbenen):
            if (self.Vars.pEBWerte[nI].dDeltaTt > dMaxKelvin):
                dMaxKelvin = self.Vars.pEBWerte[nI].dDeltaTt
     
        if (dMaxKelvin == 0):
            dMaxKelvin = 1
     
        # Dimensionslos [-] für Dzl, Tzl, Rgr 
        dMaxDimlos = 0.0                   
        for nI in range(nEbenen-1):
            if (self.Vars.pEBWerte[nI].dDzl > dMaxDimlos) and bKV[5]:
                dMaxDimlos = self.Vars.pEBWerte[nI].dDzl
        
        if (dMaxMilli == 0):
            dMaxMilli = 1
     
        # Einheit Kelvin [K] für Dtt 
        dMaxKelvin = 0.0                   
        for nI in range(nEbenen):
            if (self.Vars.pEBWerte[nI].dDeltaTt > dMaxKelvin):
                dMaxKelvin = self.Vars.pEBWerte[nI].dDeltaTt
     
        if (dMaxKelvin == 0):
            dMaxKelvin = 1
     
        # Dimensionslos [-] für Dzl, Tzl, Rgr 
        dMaxDimlos = 0.0                   
        for nI in range(nEbenen-1):
            if (self.Vars.pEBWerte[nI].dDzl > dMaxDimlos) and bKV[5]:
                dMaxDimlos = self.Vars.pEBWerte[nI].dDzl
        
        if (dMaxMilli == 0):
            dMaxMilli = 1
     
        # Einheit Kelvin [K] für Dtt 
        dMaxKelvin = 0.0                   
        for nI in range(nEbenen):
            if (self.Vars.pEBWerte[nI].dDeltaTt > dMaxKelvin):
                dMaxKelvin = self.Vars.pEBWerte[nI].dDeltaTt
     
        if (dMaxKelvin == 0):
            dMaxKelvin = 1
     
        # Dimensionslos [-] für Dzl, Tzl, Rgr 
        dMaxDimlos = 0.0                   
        for nI in range(nEbenen-1):
            if (self.Vars.pEBWerte[nI].dDzl > dMaxDimlos) and bKV[5]:
                dMaxDimlos = self.Vars.pEBWerte[nI].dDzl
            if (self.Vars.pEBWerte[nI].dTzl > dMaxDimlos) and bKV[6]:
                dMaxDimlos = self.Vars.pEBWerte[nI].dTzl
            if (self.Vars.pEBWerte[nI].dRGrad > dMaxDimlos) and bKV[8]:
                dMaxDimlos = self.Vars.pEBWerte[nI].dRGrad
     
        
        if (dMaxDimlos == 0):
            dMaxDimlos = 1
     
        # Einheit Quadratmeter [m²] für Fläche 
        dMaxFlach = 0.0                   
        for nI in range(nEbenen-1):
            if (dFla[nI] > dMaxFlach):                 
                dMaxFlach = dFla[nI]
        
        if (dMaxFlach == 0):
            dMaxFlach = 1
        
        # Definition der axialen Breiten mit der Einheit [1/1000 Bildschirmlänge] 
        dBax_XK[0] = 130.0
        for nI in range(nEbenen-1):
            dBax_XK[nI+1] = dBax_XK[nI] + self.Vars.pEBWerte[nI].dBax*nXMax/dMaxMeterx
     
        # Redefinition der [m]-Grössen mit der Einheit [1/1000 Bildschirmlänge] 
        for nI in range(nEbenen):
            dGehRel[nI] = dGeh[nI]*300.0/dMaxMetery
            dNabRel[nI] = dNab[nI]*300.0/dMaxMetery
            dBaxRel[nI] = self.Vars.pEBWerte[nI].dBax*300.0/dMaxMetery
            dMitRel[nI] = dMit[nI]*300.0/dMaxMetery
        
        # Redefinition der [mm]-Grössen mit der Einheit [1/1000 Bildschirmlänge] 
        for nI in range(nEbenen-1):
            dSspRel[nI] = self.Vars.pEBWerte[nI].dSsp*300.0/dMaxMilli
     
        # Redefinition der [K]-Grössen mit der Einheit [1/1000 Bildschirmlänge] 
        for nI in range(nEbenen-1):
            dDttRel[nI] = self.Vars.pEBWerte[nI].dDeltaTt*300.0/dMaxKelvin
     
        # Redefinition der dimensionslosen Grössen mit der Einheit [1/1000 Bildschirmlänge] 
        for nI in range(nEbenen-1):
            dDzlRel[nI] = self.Vars.pEBWerte[nI].dDzl*300.0/dMaxDimlos
            dTzlRel[nI] = self.Vars.pEBWerte[nI].dTzl*300.0/dMaxDimlos
            dRgrRel[nI] = self.Vars.pEBWerte[nI].dRGrad*300.0/dMaxDimlos
     
        # Redefinition der [m²]-Grössen mit der Einheit [1/1000 Bildschirmlänge] 
        for nI in range(nEbenen):
            dFlaRel[nI] = dFla[nI]*300.0/dMaxFlach
        
        #Koordinatensystem zeichnen
        self._ZeicheneKoordinatensystem(dBax_XK,  nX0,  nY0,  nXMax,  bBreite)
        
        nJ = 1
        #Variabenliste:
        #(VarName, KV-Nr, Bezeichner, Einheit, Ebenengrenz, Zero-OutPut,n+1-Output 
        pVarList = (
            ('dNab',  1, 'Geom. Nabenradius',  'm', 1 ,  'dNab[0]',  'dNab[nI+1]'), 
            ('dGeh',  2,  'Geom. Gehäuseradius',  'm',  1,  'dGeh[0]',  'dGeh[nI+1]'), 
            ('dMit',  3,  'Mittelschnittsradius',  'm',  1,  'dMit[0]',  'dMit[nI+1]'), 
            ('dFla',  4,  'Querschnittsfläche',  'm²',  1,    'dFla[0]', 'dFla[nI+1]'), 
            ('dBax',  10,  'Axiale Länge',  'm',  2,  'self.Vars.pEBWerte%s].dBax'), 
            ('dSsp',  7,  'Spalthöhe',  'mm', 2,  'self.Vars.pEBWerte[%s].dSsp') ,
            ('dDtt',  9,  'Δ T_t',  'K',  2, 'self.Vars.pEBWerte[%s].dDeltaTt') , 
            ('dDzl',  5,  'Maxim. Dicken Verhältnis d/l',  '-',  2,  'self.Vars.pEBWerte[%s].dDzl'), 
            ('dTzl',  6,  'Teilungsverhältnis t/l',  '-',  2,  'self.Vars.pEBWerte[%s].dTzl'), 
            ('dRgr',  8,  'Kin. Reaktionsgrad',  '-',  2,  'self.Vars.pEBWerte[%s].dRGrad')
        )
        
        pstr = ''
        
        #ToDo: ggf Kontrollieren!
        for VarName,  KVNr,  Text,  Einheit,  EbenenGrenze,  Out in pVarList:
            pstr = '%sif bKV[%i]:\n' % (pstr,  KVNr)
            pstr = '%s  self.Color(nJ, bFarbe)\n' % (pstr)
            pstr = '%s  pOps.append((M,  nX0+ 130,nY0 + 400-int(%sRel[0])))\n' % (pstr,  VarName)
            pstr = '%s  for nI in range(nEbenen-%i):\n' % (pstr,  EbenenGrenze)
            pstr = '%s      if bBreite:\n' % (pstr)
            pstr = '%s          pOps.append((L,  nX0+int(dBax_XK[nI+1]),nY0 +400-int(%sRel[nI+1])))\n' % (pstr,  VarName)
            pstr = '%s      else:\n' % (pstr)
            pstr = '%s          pOps.append((L,  nX0+int(130.0+(float(nI)+1.0)*float(nXMax)/float((nEbenen-1))),nY0 +400-int(%sRel[nI+1])))\n' % (pstr,  VarName)
            pstr = '%s  pOps.extend([\n' % (pstr)
            pstr = '%s      (M,nX0+160+nXMax,nY0 + 400-int(%sRel[nEbenen-1])),\n' % (pstr,  VarName)
            pstr = '%s      (L,nX0+170+nXMax,nY0 + 400-int(%sRel[nEbenen-1])),\n' % (pstr,  VarName)
            pstr = '%s      (L,nX0+220+nXMax,nY0 + 55+nJ*35),\n' % (pstr)
            pstr = '%s      (T,nX0+nXMax+230,nY0+45+nJ*35,  "%s")\n' % (pstr,  Text)
            pstr = '%s  ])\n' % (pstr)
            pstr = '%s  if bKV[12]:\n' % (pstr)
            pstr = '%s      pOps.append((T,  130,500+nJ*35,  ("%%f" %% (%s)).rstrip("0")))\n' % (pstr,  Out % '0')
            pstr = '%s      for nI in range(nEbenen-%i):\n' % (pstr,  EbenenGrenze)
            pstr = '%s          pOps.append((T,  nX0+int(130.0+(float(nI)+1.0)*float(nXMax)/float((nEbenen-1))),500+nJ*35, ("%%f" %% (%s)).rstrip("0")))\n' % (pstr,  Out % 'nI+1')
            pstr = '%s      pOps.extend([\n' % (pstr)
            pstr = '%s          (T,  nX0+nXMax+230,500+nJ*35, "%s"), \n' % (pstr,  Text)
            pstr = '%s          (T,  55,500+nJ*35,  "[%%s]" %% ("%s"))\n' % (pstr,  Einheit)
            pstr = '%s      ])\n' % (pstr)
            pstr = '%s  nJ += 1\n' % (pstr)
            pstr = '%s  self.AutoDraw(pOps)\n' % (pstr)
            pstr = '%s  pOps = []\n' % (pstr)
        
        exec pstr

    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def ZeicheneAusVerlauf(self,  nKanal):
        #Voreinstellungen
        Check       = self.Vars.pCheck
        Steuer      = self.Vars.pSteuer
        EbWerte    = self.Vars.pEBWerte
        Verlauf      = self.Vars.pVerlauf
        Stufengr   = self.Vars.pStufenGr
        Geschw     = self.Vars.pGeschw
        
        bBreite = False
        if Check.bAusVerl[33].get():
            bBreite = True
        
        bFarbe = Check.bAusVerl[32].get()
        if (nKanal == 1)  and  (not Check.bAusVerl[32].get()):
            bFarbe = False
        
        nX0 = 0
        nY0 = 0
        nXmax = 900
        
        if not Check.bAusVerl[34].get():
            nX0 = 30
            nY0 = 420
            nXmax = 900
            self.ZeicheneKanal(nKanal)
        
        #Daten einlesen
        if not self.Main.Calc.bAllRead:
            self.Main.Calc.KanalCalc()
            self.Main.Calc.DrawCalc()
            self.Main.Calc.VerlaufCalc()
            self.Main.Calc.StufeCalc()
        
        #dFla ausnullen
        dFla  = [0.0]*10
        dCax = [0.0]*10
        dMit  = [0.0]*10
        
        nEbenen = Steuer.nEbene
        
        for nI in range(nEbenen):
            if Steuer.bKein1:
                #Mittelschnittsradius
                dMit[nI] = pow(0.5*(EbWerte[nI].dRngeo*EbWerte[nI].dRngeo+EbWerte[nI].dRggeo*EbWerte[nI].dRggeo),0.5)
                EbWerte[nI].dRmittel = dMit[nI]
                #Querschnittsfläche
                dFla[nI] = (EbWerte[nI].dRggeo*EbWerte[nI].dRggeo-EbWerte[nI].dRngeo*EbWerte[nI].dRngeo)*3.142;
                dCax[nI] = 0.0
            else:
                EbWerte[nI].dRggeo = 0.0                # Gehäuse-Radius
                EbWerte[nI].dRngeo = 0.0                # Naben-Radius
                dMit[nI] = EbWerte[nI].dRmittel       # Mittelschnittsradius
                dCax[nI] = EbWerte[nI].dCax            # CAX
                dFla[nI] = 0.0
        
        EbWerte[nEbenen-1].dBax = 0.0
        
        # Bestimmung der grössten Werte als Streckungsfaktoren    
       # Einheit Meter [m] 
        
        dMaxMeterx = 0.0
        dMaxMetery = 0.0
        
        for nI in range(nEbenen-1):
            dMaxMeterx=dMaxMeterx+EbWerte[nI].dBax
        
        if (dMaxMeterx == 0.0):
            dMaxMeterx = 1.0
     
        dMaxMetery = 0.0
        
        for nI in range(nEbenen-1):
            if (EbWerte[nI].dRggeo > dMaxMetery) and Check.bAusVerl[1].get():
                dMaxMetery = EbWerte[nI].dRggeo
            if (EbWerte[nI].dRngeo > dMaxMetery) and Check.bAusVerl[2].get():
                dMaxMetery = EbWerte[nI].dRngeo
            if (EbWerte[nI].dRmittel > dMaxMetery) and Check.bAusVerl[3].get():
                dMaxMetery = EbWerte[nI].dRmittel
            if (EbWerte[nI].dBax     > dMaxMetery) and Check.bAusVerl[5].get():
                dMaxMetery = EbWerte[nI].dBax
            if (Verlauf[nI].dL > dMaxMetery) and Check.bAusVerl[8].get():
                dMaxMetery = Verlauf[nI].dL
        
        if (dMaxMetery == 0.0):
            dMaxMetery = 1.0
        
        # Einheit Millimeter [mm] 
        dMaxMilli = 0.0
        for nI in range(nEbenen-1):
            if (EbWerte[nI].dSsp > dMaxMilli):
                dMaxMilli = EbWerte[nI].dSsp
        
        if (dMaxMilli == 0.0):
            dMaxMilli = 1.0
     
        # Einheit Kelvin [K] 
        dMaxKelvin = 0.0                   
        for nI in range(nEbenen):
            if (Verlauf[nI].dT > dMaxKelvin) and Check.bAusVerl[10].get():
                dMaxKelvin = Verlauf[nI].dT
            if (Verlauf[nI].dTT > dMaxKelvin) and Check.bAusVerl[11].get():
                dMaxKelvin = Verlauf[nI].dTT
            if (Verlauf[nI].dTTR > dMaxKelvin) and Check.bAusVerl[12].get():
                dMaxKelvin = Verlauf[nI].dTTR
            if (Stufengr[nI].dDtt > dMaxKelvin) and Check.bAusVerl[21].get():
                dMaxKelvin = Stufengr[nI].dDtt
        
        if (dMaxKelvin == 0.0):
            dMaxKelvin = 1.0
        
        # Dimensionslos [-] 
        dMaxDimlos = 0.0                   
        for nI in range(nEbenen):
            if (EbWerte[nI].dDzl   > dMaxDimlos) and Check.bAusVerl[6] .get():
                dMaxDimlos = EbWerte[nI].dDzl
            if (EbWerte[nI].dTzl   > dMaxDimlos) and Check.bAusVerl[7] .get():
                dMaxDimlos = EbWerte[nI].dTzl
            if (Stufengr[nI].dRgr  > dMaxDimlos) and Check.bAusVerl[18].get():
                dMaxDimlos = Stufengr[nI].dRgr
            if (Stufengr[nI].dEta  > dMaxDimlos) and Check.bAusVerl[20].get():
                dMaxDimlos = Stufengr[nI].dEta
            if (Stufengr[nI].dPiS  > dMaxDimlos) and Check.bAusVerl[22].get():
                dMaxDimlos = Stufengr[nI].dPiS
            if (Verlauf[nI].dKAP   > dMaxDimlos) and Check.bAusVerl[29].get():
                dMaxDimlos = Verlauf[nI].dKAP
            if (Verlauf[nI].dMAC   > dMaxDimlos) and Check.bAusVerl[30].get():
                dMaxDimlos = Verlauf[nI].dMAC
            if (Verlauf[nI].dMAW   > dMaxDimlos) and Check.bAusVerl[31].get():
                dMaxDimlos = Verlauf[nI].dMAW
        
        if (dMaxDimlos == 0.0):
            dMaxDimlos = 1.0
    
        # Einheit Quadratmeter [m²] 
        dMaxFlach = 0.0
        for nI in range(nEbenen):
           if (dFla[nI] > dMaxFlach):                          
                dMaxFlach = dFla[nI]
        
        if (dMaxFlach == 0.0):
            dMaxFlach = 1.0
     
        # Einheit Grad [Grad] 
        dMaxGrad = 0.0
        for nI in range(nEbenen):
            if (Verlauf[nI].dALP > dMaxGrad) and Check.bAusVerl[16].get():
                dMaxGrad = Verlauf[nI].dALP
            if (Verlauf[nI].dBET > dMaxGrad) and Check.bAusVerl[17].get():
                dMaxGrad = Verlauf[nI].dBET
        
        if (dMaxGrad == 0.0):
            dMaxGrad = 1.0
    
        # Einheit [Pa] 
        dMaxPa = 0.0
        for nI in range(nEbenen):
            if (Verlauf[nI].dP   > dMaxPa) and Check.bAusVerl[13].get():
                dMaxPa = Verlauf[nI].dP
            if (Verlauf[nI].dPT  > dMaxPa) and Check.bAusVerl[14].get():
                dMaxPa = Verlauf[nI].dPT
            if (Verlauf[nI].dPTR > dMaxPa) and Check.bAusVerl[15].get():
                dMaxPa = Verlauf[nI].dPTR
        
        if (dMaxPa == 0.0):
            dMaxPa = 1.0
     
        # Einheit [kJ/kg] 
        dMaxH = 0.0
        for nI in range(nEbenen):
            if (Stufengr[nI].dDH > dMaxH) and Check.bAusVerl[19].get():
                dMaxH = Stufengr[nI].dDH
         # end of for
        if (dMaxH == 0.0):
            dMaxH = 1.0
     
        # Einheit [m/s] 
        dMaxGesch = 0.0
        for nI in range(nEbenen):
            if (Geschw[nI].dC   > dMaxGesch) and Check.bAusVerl[23].get():
                dMaxGesch = Geschw[nI].dC
            if (Geschw[nI].dCu  > dMaxGesch) and Check.bAusVerl[24].get():
                dMaxGesch = Geschw[nI].dCu
            if (Geschw[nI].dCax > dMaxGesch) and Check.bAusVerl[25].get():
                dMaxGesch = Geschw[nI].dCax
            if (Geschw[nI].dW   > dMaxGesch) and Check.bAusVerl[26].get():
                dMaxGesch = Geschw[nI].dW
            if (Geschw[nI].dWu  > dMaxGesch) and Check.bAusVerl[27].get():
                dMaxGesch = Geschw[nI].dWu
            if (Geschw[nI].dWax > dMaxGesch) and Check.bAusVerl[28].get():
                dMaxGesch = Geschw[nI].dWax
        
        if (dMaxGesch == 0.0):
            dMaxGesch = 1.0
        
        dBax_XK = [0.0]*10
        dBax_XK[0] = 130.0
        for nI in range(nEbenen-1):
            dBax_XK[nI+1] = dBax_XK[nI] + EbWerte[nI].dBax*float(nXmax)/dMaxMeterx
        
        #Koordinatensystem zeichnen
        self._ZeicheneKoordinatensystem(dBax_XK,  nX0,  nY0,  nXmax,  bBreite)
        
        dBezogene = [0.0]*10
        #Ausgabe
        nJ = 1

        
        #Variablenliste
        #Aufbau:
        #(VarName, ItemNr, Bezeichner, EinheitVar, Einheit, EbenenDifferent 
        pVarList = (
            ('EbWerte[%s].dRggeo',  1,  'Geom. Gehäuseradius',  'dMaxMetery',  'm',  1,), 
            ('EbWerte[%s].dRmittel',  3,  'Mittelschnittsradius',  'dMaxMetery',  'm',  1,),
            ('EbWerte[%s].dRngeo',  2,  'Geom. Nabenradius',  'dMaxMetery',  'm',  1), 
            ('dFla[%s]',  4,  'Querschnittsfläche',  '(dMaxFlach*300.0)*300.0', 'm',1 ),  #dMaxFlach*300 weil dFla[nI]*300 und wir es ins Verhältnis setzen wollen
            ('EbWerte[%s].dBax',  5,  'Axiale Länge',  'dMaxMetery',  'm',  2), 
            ('EbWerte[%s].dDzl',  6,  'd/s',  'dMaxDimlos',  '-',  2), 
            ('EbWerte[%s].dTzl',  7,  't/s',  'dMaxDimlos', '-',  2), 
            ('Verlauf[%s].dL',  8,  'Schaufellänge',  'dMaxMetery',  'm',  2),  
            ('EbWerte[%s].dSsp',  9,  'Spalthöhe',  'dMaxMilli',   'mm',   2), 
            ('Verlauf[%s].dT',  10,  'Temperatur',  'dMaxKelvin',  'K',  1), 
            ('Verlauf[%s].dTT',  11,  'Totaltemp.',  'dMaxKelvin',  'K',  1), 
            ('Verlauf[%s].dTTR',  12,  'Rel. Totalt.',  'dMaxKelvin',  'K',  1), 
            ('Verlauf[%s].dP',  13,  'Druck',  'dMaxPa',  'Pa',  1), 
            ('Verlauf[%s].dPT',  14,  'Totaldruck',  'dMaxPa',  'Pa',  1), 
            ('Verlauf[%s].dPTR',  15,  'Rel. Totaldruck',  'dMaxPa',  'Pa',  1), 
            ('Verlauf[%s].dALP',  16,  'Alpha',  'dMaxGrad',  '°',  1) ,
            ('Verlauf[%s].dBET',  17,  'Beta',  'dMaxGrad',  '°',  1),  
            ('Stufengr[%s].dRgr',  18,  'Kin. Reaktionsgrad',  'dMaxDimlos',  '-',  1), 
            ('Stufengr[%s].dDH',  19,  'Δ H',  'dMaxH',  'kJ/kg',  1), 
            ('Stufengr[%s].dEta',  20,  'Isentroper Wirkungsgrad',  'dMaxDimlos',  '-',  1), 
            ('Stufengr[%s].dDtt',  21,  'Δ T_t',  'dMaxKelvin',  'K',  1), 
            ('Stufengr[%s].dPiS',  22,  'Π_t Stufe',  'dMaxDimlos',  '-',  1), 
            ('Verlauf[%s].dKAP',  29,  'κ',  'dMaxDimlos',  '-',  1), 
            ('Verlauf[%s].dMAC',  30,  'Ma_c',  'dMaxDimlos',  '-',  1), 
            ('Verlauf[%s].dMAW',  31,  'Ma_w',  'dMaxDimlos',  '-',  1), 
            ('Geschw[%s].dC',  23,  'c',  'dMaxGesch',  'm/s',  1), 
            ('Geschw[%s].dCu',  24,  'c_u',  'dMaxGesch',  'm/s',  1), 
            ('Geschw[%s].dCax',  25,  'c_ax',  'dMaxGesch',  'm/s',  1), 
            ('Geschw[%s].dW',  26,  'w',  'dMaxGesch',  'm/s',  1), 
            ('Geschw[%s].dWu',  27,  'w_u',  'dMaxGesch',  'm/s',   1), 
            ('Geschw[%s].dWax',  28,  'w_ax',  'dMaxGesch',  'm/s',  1)
            )
        
        pstr = ''
        pOps = []
        
        for VarName,  ItemNr,  Text,  Unit,  strUnit,  EbDiff in pVarList:
            pstr = '%sif Check.bAusVerl[%i].get():\n' % (pstr, ItemNr)
            pstr = '%s  for nI in range(10):\n' % (pstr,  )
            pstr = '%s      dBezogene[nI] = %s*300.0/%s\n' % (pstr, VarName % 'nI',  Unit)
            pstr = '%s  self.Color(nJ, bFarbe)\n' % (pstr)
            pstr = '%s  pOps.append((M,  nX0+ 130,nY0 + 400-int(dBezogene[0])))\n' % (pstr)
            pstr = '%s  for nI in range(nEbenen-%i):\n' % (pstr,  EbDiff)
            pstr = '%s      if bBreite:\n' % (pstr)
            pstr = '%s          pOps.append((L,  nX0+int(dBax_XK[nI+1]),nY0 + 400-int(dBezogene[nI+1])))\n' % (pstr,  )
            pstr = '%s      else:\n' % (pstr)
            pstr = '%s          pOps.append((L,  nX0+int(130.0+float(nI+1)*float(nXmax)/float(nEbenen-1)),nY0 +400-int(dBezogene[nI+1])))\n' % (pstr)
            pstr = '%s  pOps.extend([\n' % (pstr)
            pstr = '%s      (M,  nX0+160+nXmax,nY0+400-int(dBezogene[nEbenen-1])),\n' % (pstr)
            pstr = '%s      (L,  nX0+170+nXmax,nY0+400-int(dBezogene[nEbenen-1])),\n' % (pstr)
            pstr = '%s      (L,  nX0+220+nXmax,nY0+55+nJ*35),\n' % (pstr,  )
            pstr = '%s      (T,  nX0+nXmax+230,nY0+45+nJ*35,  "%s")\n' % (pstr, Text)
            pstr = '%s  ])\n' % (pstr,  )
            pstr = '%s  if Check.bAusVerl[34].get():\n' % (pstr)
            pstr = '%s      pOps.append((T,  130, 500+nJ*35,  ("%%f" %%  %s).rstrip("0")))\n' % (pstr, VarName % '0')
            pstr = '%s      for nI in range(nEbenen-%i):\n' % (pstr, EbDiff)
            pstr = '%s          pOps.append((T,  int(130.0+float(nI+1)*float(nXmax)/float(nEbenen-1)),500+nJ*35,  ("%%f" %% %s).rstrip("0")))\n' % (pstr, VarName % 'nI+1')
            pstr = '%s      pOps.append((T,  nX0+nXmax+230,500+nJ*35, "%s"))\n' % (pstr, Text)
            pstr = '%s      pOps.append((T, 55, 500+nJ*35,  "[%%s]" %% ("%s")))\n' % (pstr, strUnit)
            pstr = '%s  nJ += 1\n' % (pstr)
            pstr = '%s  self.AutoDraw(pOps)\n' % (pstr,  )
            pstr = '%s  pOps = []\n' % (pstr,  )
        
        exec pstr
    
    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def _ZeicheneKoordinatensystem(self,  dBax_XK,  nX0, nY0,  nXMax,  bBreite):
        #Ebenenbezeichnung
        pOps = []
        nEbenen = self.Vars.pSteuer.nEbene
        
        self.Color(0,  False)
        for nI in range(nEbenen):
            if nEbenen > 6:
                pOps.append((T,  nX0+int(dBax_XK[nI]), nY0 + 420,  '%i. Eb.' % (nI+1)))
            else:
                pOps.append((T, nX0+int(130.0+float(nI*nXMax)/(nEbenen-1)), nY0 + 420,  '%i. Ebenen' % (nI+1)))
        
        for nI in range(nEbenen-1):
            if self.Vars.pEBWerte[nI].nKgit == 1:
                strText = 'Laufrad'
                if nEbenen > 6:
                    strText = 'La'
                    
                if bBreite:
                    pOps.append((T,  nX0+int(dBax_XK[nI]),nY0 + 450,  strText))
                else:
                    pOps.append((T,  nX0+int(130.0+(float(nI)+0.1)*float(nXMax)/float((nEbenen-1))), nY0 + 450,  strText))
            
            if self.Vars.pEBWerte[nI].nKgit == 2:
                strText = 'Leitrad'
                if nEbenen > 6:
                    strText = 'Le'
                    
                if bBreite:
                    pOps.append((T,  nX0+int(dBax_XK[nI]),nY0 + 450,  strText))
                else:
                    pOps.append((T,  nX0+int(130.0+(float(nI)+0.1)*float(nXMax)/float((nEbenen-1))), nY0 + 450,  strText))
        
        # Zeichnen des Koordinatensystems 
        pOps.extend([
            (M,nX0+130,nY0+ 90),
            (L,nX0+135,nY0+ 90),
            (L,nX0+130,nY0+ 70),
            (L,nX0+125,nY0+ 90),
            (L,nX0+130,nY0+ 90),
            (L,nX0+130,nY0+400),
            (L,nX0+nXMax+140,nY0+400),
            (L,nX0+nXMax+140,nY0+405),
            (L,nX0+nXMax+160,nY0+400),
            (L,nX0+nXMax+140,nY0+395),
            (L,nX0+nXMax+140,nY0+400)
        ])
        
        nI = 0
        while(nI <= 100):
            pOps.append((T, nX0+50,nY0 + 390-nI*3,  '%i%%' % nI))
            nI += 10
        
        for nI in range(nEbenen):
            if bBreite:
                pOps.extend([
                    (M,nX0+int(dBax_XK[nI]),nY0 + 400),
                    (L,nX0+int(dBax_XK[nI]),nY0 + 410)
                ])
            else:
                pOps.extend([
                    (M,nX0+int(130.0+float(nI)*float(nXMax)/float((nEbenen-1))),nY0 + 400),
                    (L,nX0+int(130.0+float(nI)*float(nXMax)/float((nEbenen-1))),nY0 + 410)
                ])
        
     
        # Skala, Massstab 
        pOps.extend([
            (M,nX0+130,nY0+100),
            (L,nX0+120,nY0+100),
            (M,nX0+130,nY0+130),
            (L,nX0+120,nY0+130),
            (M,nX0+130,nY0+160),
            (L,nX0+120,nY0+160),
            (M,nX0+130,nY0+190),
            (L,nX0+120,nY0+190),
            (M,nX0+130,nY0+220),
            (L,nX0+120,nY0+220),
            (M,nX0+130,nY0+250),
            (L,nX0+120,nY0+250),
            (M,nX0+130,nY0+280),
            (L,nX0+120,nY0+280),
            (M,nX0+130,nY0+310),
            (L,nX0+120,nY0+310),
            (M,nX0+130,nY0+340),
            (L,nX0+120,nY0+340),
            (M,nX0+130,nY0+370),
            (L,nX0+120,nY0+370),
            (M,nX0+130,nY0+400),
            (L,nX0+ 120,nY0 + 400)
        ])
        
        #Zeichnen
        self.AutoDraw(pOps)

    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def Entropie(self,  dT,  dT0,  dP,  dP0):
        dCp = 1004.5    #Druckbeiwert
        dR   = 287.0        #Gaskonstante
        return dCp*log(dT/dT0)-dR*log(dP/dP0)
    
    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def SchaufelDreieck(self,  nI,  nX,  nY,  nMax):
        #Datein einlesen
        if not self.Main.Calc.bDrawCalc:
            self.Main.Calc.DrawCalc()
        
        dMaxGeschw = self.Main.Calc.dMaxGeschw
        dMaxWu = self.Main.Calc.dMaxWu
        fMax = float(nMax)
        Geschw = self.Vars.pGeschw
        
        if nI == self.Main.Calc.nEbenen-1:
            self.Pfeil(nX+int(fMax/dMaxGeschw*dMaxWu), nY , nX+int(fMax/dMaxGeschw*dMaxWu)+int(fMax/dMaxGeschw*Geschw[nI].dCu) , nY+int(fMax/dMaxGeschw*Geschw[nI].dCax))
        else:
            self.Pfeil(nX+int(fMax/dMaxGeschw*dMaxWu), nY, nX+int(fMax/dMaxGeschw*dMaxWu)+int(fMax/dMaxGeschw*Geschw[nI].dCu) , nY+int(fMax/dMaxGeschw*Geschw[nI].dCax))
            self.Pfeil(nX+int(fMax/dMaxGeschw*dMaxWu)-int(fMax/dMaxGeschw*Geschw[nI].dWu), nY+int(fMax/dMaxGeschw*Geschw[nI].dCax), nX+int(fMax/dMaxGeschw*dMaxWu)+int(fMax/dMaxGeschw*Geschw[nI].dCu), nY+int(fMax/dMaxGeschw*Geschw[nI].dCax))
            self.Pfeil(nX+int(fMax/dMaxGeschw*dMaxWu), nY, nX+int(fMax/dMaxGeschw*dMaxWu)-int(fMax/dMaxGeschw*Geschw[nI].dWu),nY+int(fMax/dMaxGeschw*Geschw[nI].dCax))

    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def SchaufelStreck(self,  dUx,  dUy,  dVx,  dVy,  dLx,  dLy):
        #Finde den Streckungsfaktor für die Geschwindigkeit
        if dUx < 0.0:
            nU = -1.0
        else:
            nU = 1.0
        
        if dVx < 0.0:
            nV = -1.0
        else:
            nV = 1.0
        
        if (dUx+dVx) < 0.0:
            nUV = -1.0
        else:
            nUV = 1.0
        
        dFakGe = 0.0
        
        for Value in (4*dUy,  4*dVy,  2*nU*dUx,  2*nV*dVx,  2*nUV*(dUx+dVx)):
            dFakGe = max(dFakGe,  Value)
        
        if dFakGe == 0.0:
            return
        
        dFakGe = 1.0/dFakGe
        
        if self.dFaktorGesch == 0.0:
            self.dFaktorGesch = dFakGe
        
        self.dFaktorGesch = min(self.dFaktorGesch,  dFakGe)
        
        #Meter
        if dLx   < 0.0:
            nL = -1.0
        else:
            nL = 1.0
        
        if dLy == 0.0:
            return
        
        dFakMe = nL/(dLx*2.0)
        
        if dLy > (nL*dLx):
            dFakMe = 1.0/(dLy*2.0)
        
        if (self.dFaktorMeter == 0.0):
            self.dFaktorMeter = dFakMe
            
        self.dFaktorMeter = min(self.dFaktorMeter, dFakMe)

    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def HilfeDreiecke(self,  nKanal):
        if nKanal == 1:
            self.Color(0,  False)
        else:
            self.Color(1,  True)
        
        self.Pfeil ( 750,100,450,700)
        self.Pfeil ( 750,100,1000,700)
        self.Pfeil ( 450,700,1000,700)
        
        self.Pfeil ( 400,100,100,700)
        self.Pfeil ( 400,700,100,700)
        self.Pfeil ( 400,100,400,700)
        
        self.Pfeil ( 1050,100,1050,700)
        self.Pfeil ( 1050,100,1300,700)
        self.Pfeil ( 1050,700,1300,700)
        
        pOps = []
        pOps.extend([
            (T,  210,400,  'c'), 
            (T,  560,400,  'c'), 
            (T, 730,670, 'u' ), 
            (T,890,400, 'w'),
            (T,1205,400, 'w'),
            (T,410,400, 'c_ax'),
            (T,270,670, 'c_u'),
            (T,1000,400,'w_ax'),
            (T,1150,670,'w_u')
        ])
        
        self.AutoDraw(pOps)
        pOps = []
        
        if nKanal == 1:
            self.Color(0,  False)
        else:
            self.Color(2,  True)
        
        self.Pfeil ( 500,195,405,300)
        self.Pfeil ( 950,195,1050,300)
        
        self.Pfeil ( 1120,825,1160,700)
        self.Pfeil ( 220,825,260,700)
        
        self.Pfeil ( 200,175,300,300)
        
        self.Pfeil ( 1250,175,1132,300)
        
        self.Pfeil ( 770,825, 810,700)
        
        pOps.extend([
            (T, 420,170,'Anteil in axialer Richtung'), 
            (T,800,170,'Anteil in axialer Richtung'), 
            
            (T, 150,830,'Anteil in Umfangsrichtung'), 
            (T, 1060,830,'Anteil in Umfangsrichtung'), 
        
            (T, 100,140,'Absolutgeschwindigkeit c'), 
            
            (T, 1100,140,'Relativgeschwindigkeit w'), 
            
            (T,670,830,'Umfangsgeschwindigkeit u'),
        ])
        
        self.AutoDraw(pOps)

   #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def HilfeStufe(self,  nKanal):
        if nKanal == 1:
            self.Color(0,  False)
        else:
            self.Color(1,  True)
        
        pOps = []
        for nJ in range(60):
            pOps.extend([
                (M,  int(250+42+650/50.0*nJ ),750), 
                (L,  int(250+42+650/50.0*(0.5+nJ)),750)
            ])
        
        pOps.extend([
            (A, 300,750-30,250+80,750+30,  20.0,  320.0), 
            (M, 250+83,750-20),
            (L, 250+80,750-7),
            (L, 250+70,750-20),
            (M, 250+  1,750-300),
            (L, 250+ 60,750-300),
            (L, 250+ 40,750-300+10),
            (M, 250+ 60,750-300),
            (L, 250+ 40,750-300-10),
            
            (M, 350,750),
            (L, 350,650),
            (L, 900,650),
            (L, 900,750),
            (M, 400,650),
            (L, 400,250),
            (L, 600,250),
            (L, 600,650),
            (M, 350,100),
            (L, 350,200),
            (L, 900,200),
            (L, 900,100),
            (L, 350,100),
            (M, 650,200),
            (L, 650,600),
            (L, 850,600),
            (L, 850,200),
        ])
        
        self.AutoDraw(pOps)
        pOps = []
        
        if nKanal == 1:
            self.Color(0,  False)
        else:
            self.Color(2,  True)
        
        self.Pfeil(310,150,310,200)
        self.Pfeil(310,300,310,250)
        self.Pfeil (200,380,270,450)
        self.Pfeil (1120,830,1060,750)
        self.Pfeil (950,750, 950,650)
        self.Pfeil (980,680,980,200)
        
        pOps.extend([
            (T,  120,350,'Strömungsrichtung'), 
            (T,  1040,830,'Rotationsachse'),
            (T,  720,440,'Leitrad'),
            (T,  470,440,'Laufrad'),
            (M, 900,650),
            (L, 960,650), 
            (T, 970,685,'Nabenradius'),
            (M, 900,200),
            (L, 990,200),
            (M, 980,750),
            (L, 980,715),
            (T,  1000,370,'Gehäuse(-Innen-)radius'),
            (M, 375,800),
            (L, 375,430),
            (L, 365,440),
            (L, 385,420),
            (M, 365,420),
            (L, 385,440),
            (M, 250+375,800),
            (L, 250+375,430),
            (L, 250+365,440),
            (L, 250+385,420),
            (M, 250+365,420),
            (L, 250+385,440),
            (M, 500+375,800),
            (L, 500+375,430),
            (L, 500+365,440),
            (L, 500+385,420),
            (M, 500+365,420),
            (L, 500+385,440),
            (T, 350,805,'1. Ebene'),
            (T, 600,805,'2. Ebene'),
            (T, 850,805,'3. Ebene'),
            (T,  1100,540,'Austritt'),
            (T,  100,540,'Eintritt'),
            (M, 300,200),
            (L, 350,200),
            (M, 300,250),
            (L, 400,250),
            (T,  180,215,'Spalthöhe')
        ])
        
        self.AutoDraw(pOps)
    
    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def HilfeSchaufel(self,  nKanal):
        self.dFaktorGesch = 0.0
        self.dFaktorMeter = 0.0
        self.SchaufelStreck(-10.0,5.0,-5.0,5.0,-7.0,5.0)
        
        bHilfe = self.Vars.pCheck.bAusSch[8].get()
        self.Vars.pCheck.bAusSch[8].set(True)
        
        if nKanal == 1:
            self.Color(0,  False)
        else:
            self.Color(1,  True)
        
        self.Schaufel(-10.0,6.0,-2.0,6.0,0.7,0.05,-6.0,6.0,350,150,700)
        self.Vars.pCheck.bAusSch[8].set(bHilfe)
        
        
        pOps = [(T,  350,  150,  'x. Ebene - Laufrad / Leitrad -')]
        
        self.AutoDraw(pOps)
        pOps = []
        
        if nKanal == 1:
            self.Color(0,  False)
        else:
            self.Color(2,  True)
        
        self.Pfeil( 300,500,300,625)
        self.Pfeil( 300,600,300,325)
        self.Pfeil( 910,565,809,473)
        self.Pfeil( 710,385,792,460)
        self.Pfeil( 930,260,819,250)
        self.Pfeil( 200,730,373,680)
        self.Pfeil( 600,700,394,700)
        self.Pfeil( 600,700,692,700)
        
        pOps.extend([
            (M, 290,625),
            (L,  350,625),
            (M, 290,325),
            (L,  350,325),
            (T, 70,450,'Axiale Schaufellänge'),
            (T, 70,480,'B_ax'),
            (M, 809,473),
            (L, 792,460),
            (T, 890,465,'max. Dicke der Schaufel d'),
            (T, 945,240,'Geschwindigkeitsvektor'),
            (T, 945,270,'Eintrittsebene (w_ax, w_u)'),
            (T, 70,750,'Geschwindikeitsvektor'),
            (T, 70,780,'Austrittsebene (w_ax, w_u)'),
            (M, 692,710),
            (L, 692,625),
            (M, 394,710),
            (L, 394,625),
            (T, 507,660,'Teilung t'),
        ])
        
        self.AutoDraw(pOps)

    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def Schaufel(self,  dUx,  dUy,  dVx,  dVy, dTzl,  dDzl,  dLx,  dLy,  nOx,  nOy,  nMax):
        dFakGe = self.dFaktorGesch*float(nMax)
        dFakMe = self.dFaktorMeter*float(nMax)
        
        nWert = int(dFakGe*dUx)
        nAnfang = min(0.0,  nWert)
        
        nWert += int(dFakMe*dLx)
        nAnfang = min(nAnfang,  nWert)
        
        nWert += int(dFakGe*dVx)
        nAnfang = min(nAnfang,  nWert)
        
        nAnfang *= -1
        
        # Strich oben und unten 
        pOps = [
            (M,  int(nOx),int(nOy+nMax/4.0) ),
            (L,  int(nOx+nMax),int(nOy+nMax/4.0)),
            (M,  int(nOx),int(nOy+nMax/4.0+dFakMe*dLy)),
            (L,  int(nOx+nMax),int(nOy+nMax/4.0+dFakMe*dLy))
        ]
     
        # Oberer Geschw.Vektor 
        self.Pfeil (int(nOx+nAnfang),int(nOy+nMax/4.0-dFakGe*dUy), int(nOx+nAnfang+0.9*dFakGe*dUx), int(nOy+nMax/4.0-0.1*dFakGe*dUy))
    
        # Schaufel (Kreisbogenprofil durch 3 Punkte) 
     
        # Schnittpunkt der Vektoren 
        dB  = (dFakMe*dLy - dFakMe*dLx*(dUy/dUx))/(dFakGe*dVy-dFakGe*dVx*(dUy/dUx))
        dX2 = dFakMe*dLx-dB*dVx*dFakGe                # x-Koordinate des Schnittpunktes 
        dY2 = dFakMe*dLy-dB*dVy*dFakGe                # y-Koordinate des Schnittpunktes
     
        # Zwischenpunkt 
        pOps.append((M,  int(nOx+nAnfang+dFakGe*dUx),int(nOy+nMax/4.0)))
        nX  = int(nOx+nAnfang+dFakGe*dUx)
        nY  = int(nOy+nMax/4.0)
        dX2 = (dY2*dLx/dLy+dX2)/2                     # neue x-Koordinate zwischen Sehne und Skante
    
        # Bestimmung des Mittelpunktes 
        dA12 = -dX2/dY2
        dB12 = dY2/2-dA12*dX2/2
        dX23 = (dX2+dFakMe*dLx)/2 
        dY23 = (dY2+dFakMe*dLy)/2
        dA23 = (dFakMe*dLx-dX2)/(dY2-dFakMe*dLy)
        dB23 = dY23-dA23*dX23
        dXm  = (dB23-dB12)/(dA12-dA23)
        dYm  = dA12*dXm+dB12
        
        dLSch = pow(dLx*dLx+dLy*dLy,0.5)
        
        if not self.Vars.pCheck.bAusSch[8].get():
            dR = pow(dXm*dXm + dYm*dYm ,0.5)
            nJ = -20
            while(nJ < 20):
                if (((nJ+1)*dFakMe*dLSch*dTzl+nX)>nOx) and (((nJ-1)*dFakMe*dLSch*dTzl+nX)< (nOx+nMax)):
                    pOps.append((M,  int(nJ*dFakMe*dLSch*dTzl+nX),nY))
                    bMove = True
                else:
                    bMove = False
                
                dX = 0.0
                dY = 0.0
                
                if dXm > 0.0:
                    for nI in range(51):
                        if  (not bMove) and (nJ*dFakMe*dLSch*dTzl+nX+dX > nOx) and (nJ*dFakMe*dLSch*dTzl+nX+dX < nOx+nMax):
                            bMove = True
                            pOps.append((M,  int(nJ*dFakMe*dLSch*dTzl+nX+dX),int(nY+dY)))
                        
                        dY = 0.0 + dFakMe*dLy*nI/50.0
                        dX = -pow(dR*dR-(dY-dYm)*(dY-dYm),0.5)+dXm 
                        
                        if bMove and (nJ*dFakMe*dLSch*dTzl+nX+dX > nOx) and (nJ*dFakMe*dLSch*dTzl+nX+dX < nOx+nMax):
                            pOps.append((L,  int(nJ*dFakMe*dLSch*dTzl+nX+dX),int(nY+dY)))
                else:
                    for nI in range(51):
                        if (not bMove) and (nJ*dFakMe*dLSch*dTzl+nX+dX > nOx) and (nJ*dFakMe*dLSch*dTzl+nX+dX < nOx+nMax):
                            bMove = True
                            pOps.append((M,  int(nJ*dFakMe*dLSch*dTzl+nX+dX),int(nY+dY)))
                        
                        dY = 0.0 + dFakMe*dLy*nI/50.0
                        dX = +pow(dR*dR-(dY-dYm)*(dY-dYm),0.5)+dXm
                        
                        if bMove and (nJ*dFakMe*dLSch*dTzl+nX+dX > nOx) and (nJ*dFakMe*dLSch*dTzl+nX+dX < nOx+nMax):
                            pOps.append((L,  int(nJ*dFakMe*dLSch*dTzl+nX+dX),int(nY+dY)))
                
                #Schleifenzähler
                nJ += 1
        else:
            # Bestimmung des Radius 
            dXhilf=(dYm+dLx/dLy*dXm)/(dLx/dLy+dLy/dLx) # Lotpunkt von Kreismittelpunkt auf Schaufelsekante
            dYhilf =dLy/dLx*dXhilf
           
            dR = pow(dXm*dXm + dYm*dYm ,0.5)           # Radius
            dLot = pow((dXm-dXhilf)*(dXm-dXhilf)+(dYm-dYhilf)*(dYm-dYhilf),0.5)  # Lotl�nge
            
            dD = dFakMe*dLSch*dDzl                     # Schaufeldicke
            
            # Bestimmung des Mittelpunktes aus drei Punkten (dX2,dY2), Ein-/Austrittspunkt
            if (dR-dLot < dD):                           # Abstand Sekante zu Sehne
                dAbst1 = dR-(dR-dLot)/2.0-dLot          # Abstand Sekante zu neuem (n�heren) Punkt
            else:
                dAbst1 = dR-dD/2-dLot
            
            dAbst2 = dAbst1+dD                         # Abstand Sekante zu neuem (fernerem Punkt)
            
            if (dXm > 0.0):
                dAbst1=-dAbst1
                dAbst2=-dAbst2
            
            dXAbst1 = dXhilf+dAbst1*cos(atan(-dLx/dLy))
            dXAbst2 = dXhilf+dAbst2*cos(atan(-dLx/dLy))
            dYAbst1 = -dLx/dLy*dXAbst1+(dYm+dLx/dLy*dXm)
            dYAbst2 = -dLx/dLy*dXAbst2+(dYm+dLx/dLy*dXm)
            
            dA12 = -dXAbst1/dYAbst1
            dB12 = dYAbst1/2-dA12*dXAbst1/2
            dX23 = (dXAbst1+dFakMe*dLx)/2 
            dY23 = (dYAbst1+dFakMe*dLy)/2
            dA23 = (dFakMe*dLx-dXAbst1)/(dYAbst1-dFakMe*dLy)
            dB23 = dY23-dA23*dX23
            dXm1 = (dB23-dB12)/(dA12-dA23)
            dYm1 = dA12*dXm1+dB12
            
            dA12 = -dXAbst2/dYAbst2
            dB12 = dYAbst2/2-dA12*dXAbst2/2
            dX23 = (dXAbst2+dFakMe*dLx)/2 
            dY23 = (dYAbst2+dFakMe*dLy)/2
            dA23 = (dFakMe*dLx-dXAbst2)/(dYAbst2-dFakMe*dLy)
            dB23 = dY23-dA23*dX23
            dXm2 = (dB23-dB12)/(dA12-dA23)
            dYm2 = dA12*dXm2+dB12
            
            dR1 = pow(dXm1*dXm1 + dYm1*dYm1 ,0.5)      # Radius
            dR2 = pow(dXm2*dXm2 + dYm2*dYm2 ,0.5)      # Radius
            
            nJ = -20
            while(nJ < 20):
                if (((nJ+1)*dFakMe*dLSch*dTzl+nX)>nOx) and (((nJ-1)*dFakMe*dLSch*dTzl+nX)< (nOx+nMax)):
                    #Zeichnen des Bogens
                    if (((nJ)*dFakMe*dLSch*dTzl+nX)>nOx) and (((nJ)*dFakMe*dLSch*dTzl+nX)< (nOx+nMax)):
                        pOps.append((M,  int(nJ*dFakMe*dLSch*dTzl+nX),nY))
                        bMove = True
                    else:
                        bMove = False
                    
                    dX = 0.0
                    dY = 0.0
                    if dXm1 > 0.0:
                        for nI in range(51):
                            if (not bMove) and (nJ*dFakMe*dLSch*dTzl+nX+dX > nOx) and (nJ*dFakMe*dLSch*dTzl+nX+dX < nOx+nMax):
                                bMove = True
                                pOps.append((M,  int(nJ*dFakMe*dLSch*dTzl+nX+dX),int(nY+dY)))
                            
                            dY = 0.0 + dFakMe*dLy*nI/50.0
                            dX = -pow(dR1*dR1-(dY-dYm1)*(dY-dYm1),0.5)+dXm1
                            
                            if bMove and (nJ*dFakMe*dLSch*dTzl+nX+dX > nOx) and (nJ*dFakMe*dLSch*dTzl+nX+dX < nOx+nMax):
                                pOps.append((L,  int(nJ*dFakMe*dLSch*dTzl+nX+dX),int(nY+dY)))
                    else:
                        for nI in range(51):
                            if (not bMove) and (nJ*dFakMe*dLSch*dTzl+nX+dX > nOx) and (nJ*dFakMe*dLSch*dTzl+nX+dX < nOx+nMax):
                                bMove = True
                                pOps.append((M,  int(nJ*dFakMe*dLSch*dTzl+nX+dX),int(nY+dY)))
                            else:
                                dY = 0.0 + dFakMe*dLy*nI/50.0
                                dX = +pow(dR1*dR1-(dY-dYm1)*(dY-dYm1),0.5)+dXm1 
                            
                            if bMove and (nJ*dFakMe*dLSch*dTzl+nX+dX > nOx) and (nJ*dFakMe*dLSch*dTzl+nX+dX < nOx+nMax):
                                pOps.append((L,  int(nJ*dFakMe*dLSch*dTzl+nX+dX),int(nY+dY)))
                    
                    #Zeichnen des Bogens
                    if (((nJ)*dFakMe*dLSch*dTzl+nX)>nOx) and (((nJ)*dFakMe*dLSch*dTzl+nX)< (nOx+nMax)):
                        pOps.append((M,  int(nJ*dFakMe*dLSch*dTzl+nX),nY))
                        bMove = True
                    else:
                        bMove = False
                    
                    dX = 0.0
                    dY = 0.0
                    if dXm2 > 0.0:
                        for nI in range(51):
                            if (not bMove) and (nJ*dFakMe*dLSch*dTzl+nX+dX > nOx) and (nJ*dFakMe*dLSch*dTzl+nX+dX < nOx+nMax):
                                bMove = True
                                pOps.append((M,  int(nJ*dFakMe*dLSch*dTzl+nX+dX),int(nY+dY)))
                            
                            dY = 0.0 + dFakMe*dLy*nI/50.0
                            dX = -pow(dR2*dR2-(dY-dYm2)*(dY-dYm2),0.5)+dXm2
                            
                            if bMove and (nJ*dFakMe*dLSch*dTzl+nX+dX > nOx) and (nJ*dFakMe*dLSch*dTzl+nX+dX < nOx+nMax):
                                pOps.append((L,  int(nJ*dFakMe*dLSch*dTzl+nX+dX),int(nY+dY)))
                    else:
                        for nI in range(51):
                            if (not bMove) and (nJ*dFakMe*dLSch*dTzl+nX+dX > nOx) and (nJ*dFakMe*dLSch*dTzl+nX+dX < nOx+nMax):
                                bMove = True
                                pOps.append((M,  int(nJ*dFakMe*dLSch*dTzl+nX+dX),int(nY+dY)))
                            else:
                                dY = 0.0 + dFakMe*dLy*nI/50.0
                                dX = +pow(dR2*dR2-(dY-dYm2)*(dY-dYm2),0.5)+dXm2
                            
                            if bMove and (nJ*dFakMe*dLSch*dTzl+nX+dX > nOx) and (nJ*dFakMe*dLSch*dTzl+nX+dX < nOx+nMax):
                                pOps.append((L,  int(nJ*dFakMe*dLSch*dTzl+nX+dX),int(nY+dY)))
                
                
                nJ += 1
        
        self.AutoDraw(pOps)
        
        # Unterer Geschw.Vektor 
        self.Pfeil (int(nOx+nAnfang+dFakGe*dUx+dFakMe*dLx+0.1*dFakGe*dVx), int(nOy+nMax/4.0+dFakMe*dLy+0.1*dFakGe*dVy), int(nOx+nAnfang+dFakGe*dUx+dFakMe*dLx+dFakGe*dVx), int(nOy+nMax/4.0+dFakMe*dLy+dFakGe*dVy))
        

    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def ZeicheneSchaufel(self,  nKanal):
        nS = [0]*10
        nX = [0]*10
        nY = [0]*10
        
        Check     = self.Vars.pCheck
        EbWerte = self.Vars.pEBWerte
        Geschw  = self.Vars.pGeschw
        Verlauf    = self.Vars.pVerlauf
        
        nEbenen = self.Vars.pSteuer.nEbene
        
        bFarbe = Check.bAusSch[9].get()
        
        if (nKanal == 1) or (not Check.bAusSch[9].get()):
            bFarbe = False
        
        #Daten einlesen
        if not self.Main.Calc.bAllRead:
            self.Main.Calc.KanalCalc()
            self.Main.Calc.DrawCalc()
            self.Main.Calc.VerlaufCalc()
            self.Main.Calc.StufeCalc()
        
        # Bestimmung der Position und Größe der Schaufeln 
        if Check.bAusSch[1].get():
        # Vorleitrad  
            nS[0] =   1
            nS[1] =   1
            nX[1] = 110
            nY[1] = 150
            nMax  = 550
        
    
       # Stufe 
        if Check.bAusSch[2].get or Check.bAusSch[3].get() or Check.bAusSch[4].get() or Check.bAusSch[5].get() or Check.bAusSch[6].get():
            nS[0] =   2
            nX[1] = 110
            nX[2] = 760
            nY[1] = 150
            nY[2] = 150
            nMax  = 550
            
            if Check.bAusSch[2].get():              # 1. Stufe
                nS[1] = 1
            if Check.bAusSch[3].get():               # 2. Stufe
                nS[1] = 3
            if Check.bAusSch[4].get():               # 3. Stufe
                nS[1] = 5
            if Check.bAusSch[5].get():               # 4. Stufe
                nS[1] = 7
            if Check.bAusSch[6].get():               # 5. Stufe
                nS[1] = 9
            if EbWerte[0].nKgit == 2:                  # Vorleitrad vorhanden
                nS[1] = nS[1]+1
            
            nS[2] = nS[1] + 1
            
            if (nS[2] == nEbenen):
                nS[0] = 1
    
       #Übersicht
        if Check.bAusSch[0].get():
            nS[0] = nEbenen-1
            if (nEbenen <= 3):
                nS[1] =   1
                nS[2] =   2
                nX[1] = 110
                nX[2] = 760
                nY[1] = 150
                nY[2] = 150
                nMax  = 550
            
            elif (nEbenen <=7):                # max 6 Bilder auf Bildschirm
                for nI in range(nEbenen):
                    nS[nI+1] = nI+1
                
                nX[1] = 110
                nX[2] = 110
                nX[3] = 535
                nX[4] = 535
                nX[5] = 960
                nX[6] = 960
                nY[1] = 75
                nY[2] = 500
                nY[3] = 75
                nY[4] = 500
                nY[5] = 75
                nY[6] = 500
                nMax  = 350
            else:                                        #Über 6 Bilder auf Bildschirm
                for nI in range(nEbenen):
                    nS[nI+1] = nI+1
                
                nX[1] = 110
                nX[2] = 110
                nX[3] = 110
                nX[4] = 535
                nX[5] = 535
                nX[6] = 535
                nX[7] = 960
                nX[8] = 960
                nX[9] = 960
                nY[1] =  75
                nY[2] = 350
                nY[3] = 625
                nY[4] =  75
                nY[5] = 350
                nY[6] = 625
                nY[7] =  75
                nY[8] = 350
                nY[9] = 625
                nMax  = 200
        
        self.Color(0,  False)
        
        self.dFaktorGesch = 0.0
        self.dFaktorMeter = 0.0
        
        if EbWerte[0].dXl == 0:
            EbWerte[0].dXl = 1
        
        for nI in range(nEbenen-1):
            if (EbWerte[nI].dXl == 0):
                EbWerte[nI].dXl = EbWerte[nI-1].dXl
            
            dLx = EbWerte[nI].dXl*EbWerte[nI].dBax
            dLu = EbWerte[nI].dXl*EbWerte[nI].dBax*tan(acos(EbWerte[nI].dXl*EbWerte[nI].dBax/Verlauf[nI].dL))
            
            if (EbWerte[nI].nKgit == 2):                 # Stator
                if (Geschw[nI].dCu+Geschw[nI+1].dCu<0):
                    dLu = -dLu
                
                self.SchaufelStreck(Geschw[nI].dCu   ,Geschw[nI].dCax, Geschw[nI+1].dCu ,Geschw[nI+1].dCax, dLu ,dLx)
            else:                                        # Rotor
                if (-Geschw[nI].dWu-Geschw[nI+1].dWu<0):
                    dLu = -dLu
                
                self.SchaufelStreck(-Geschw[nI].dWu   ,Geschw[nI].dWax, -Geschw[nI+1].dWu ,Geschw[nI+1].dWax,dLu,dLx)
        
        pOps=[]
        
        #Ausgabe der Schaufeln
        nI = 1
        while(nI <= nS[0]):
            dLx = EbWerte[nS[nI]-1].dXl*EbWerte[nS[nI]-1].dBax
            dLu = EbWerte[nS[nI]-1].dXl*EbWerte[nS[nI]-1].dBax*tan(acos(EbWerte[nS[nI]-1].dXl*EbWerte[nS[nI]-1].dBax/Verlauf[nS[nI]-1].dL))
	    
            if (EbWerte[nS[nI]-1].nKgit == 2):           # Stator
                if (-Geschw[nS[nI]-1].dWu-Geschw[nS[nI]].dWu>0):
                    dLu = -dLu
            else:                                        # Rotor
                if (Geschw[nS[nI]].dCu+Geschw[nS[nI]].dCu>0):
                    dLu = -dLu
            
            #Ausgabe der gewünschten Ebenen
            if bFarbe:
                self.Color(nS[nI],  bFarbe)
            else:
                self.Color(0,  False)
            
            strText = '%i. Ebene' % nS[nI]
            if EbWerte[nS[nI]-1].nKgit == 2:
                strText = '%s - Leitrad - ' % strText
                self.Schaufel(Geschw[nS[nI]-1].dCu, Geschw[nS[nI]-1].dCax, Geschw[nS[nI]].dCu  , Geschw[nS[nI]].dCax, EbWerte[nS[nI]-1].dTzl, EbWerte[nS[nI]-1].dDzl, dLu, dLx, nX[nI], nY[nI], nMax)
            else:
                strText = '%s - Laufrad - ' % strText
                self.Schaufel(-Geschw[nS[nI]-1].dWu, Geschw[nS[nI]-1].dWax, -Geschw[nS[nI]].dWu  , Geschw[nS[nI]].dWax, EbWerte[nS[nI]-1].dTzl, EbWerte[nS[nI]-1].dDzl, dLu, dLx, nX[nI], nY[nI], nMax)
            
            if Check.bAusSch[7].get():
                if Check.bAusSch[0].get():
                    self.Color(0,  False)
                    if (nY[nI]<=150):
                        self.SchaufelDreieck(nS[nI]-1,nX[nI]+50,nY[nI]-nY[1]+10,nY[1]-10)
                    self.SchaufelDreieck(nS[nI],nX[nI]+50,nY[nI]+0.9*nMax,nY[1]-10)
                    if bFarbe:
                        self.Color(nS[nI],bFarbe);         # Farbe
                    else:
                        self.Color(0,FALSE);          # Farbe
                else:
                    self.SchaufelDreieck(nS[nI]-1,nX[nI]+50,nY[nI]-100,150)
                    self.SchaufelDreieck(nS[nI],nX[nI]+50,nY[nI]+nMax,150)
                    pOps = [(T, nX[nI]+300,nY[nI],strText)]
            else:
                pOps = [(T,  nX[nI],nY[nI],  strText)]
            
            self.AutoDraw(pOps)
            
            nI += 1
        
    
   #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def ZeicheneTSDiagramm(self,  nKanal):
        dT0 = 273.16
        dP0 = 101325.0
        
        Check       = self.Vars.pCheck
        Verlauf     = self.Vars.pVerlauf
        EbWerte   = self.Vars.pEBWerte
        nEbenen  = self.Vars.pSteuer.nEbene
        
        #Verlauf einlesen
        if not self.Main.Calc.bVerlaufCalc:
            self.Main.Calc.VerlaufCalc()
        
        bFarbe = Check.bAusTs[6].get()
        if (nKanal == 1) or (not Check.bAusTs[6].get()):
            bFarbe = False
        
        # Koordinatensystem
        nX    =    0
        nY    =    0
        nY0   =  800
        nX0   =  150
        #	if not Check.bAusTs[8].get():                  # halber Bildschirm
        #		nXmax = 500                                             # Programm erweiterbar
        #	else:
        nXmax = 1000
        nYmax =  650
        
        # Bestimmung der Max-Werte als Streckungsfaktoren 
        # Temperatur / Enthalpie 
        dMaxTemp = 0.0
        dMinTemp = dT0
        
        for nI in range(nEbenen):
            dMaxTemp = max(Verlauf[nI].dT,  dMaxTemp,  Verlauf[nI].dTT)
            dMinTemp = min(dMinTemp,Verlauf[nI].dTT,Verlauf[nI].dT)
        
        if (dMaxTemp == 0.0):
            dMaxTemp = 1.0
        
        dT0 = dMinTemp
        if (dT0 == 0.0):
            dT0 = 1.0
        
        # Druck
        dMaxDruck = 0.0
        dMinDruck = dP0
        
        for nI in range(nEbenen):
            dMaxDruck = max(dMaxDruck,  Verlauf[nI].dP, Verlauf[nI].dPT)  
            dMinDruck = min(dMinDruck, Verlauf[nI].dPT, Verlauf[nI].dP)
        
        if (dMaxDruck == 0.0):
            dMaxDruck = 1.0
        
        dP0 = dMinDruck
        if (dP0 == 0.0):
            dP0 = 1.0
        
        # Entropie 
        dMaxEntrop = 0.0
        dMinEntrop = self.Entropie(Verlauf[0].dT, dT0, Verlauf[0].dP, dP0)
        
        for nI in range(nEbenen):
            dS1 = self.Entropie(Verlauf[nI].dT, dT0, Verlauf[nI].dP, dP0)
            dS2 = self.Entropie(Verlauf[nI].dTT, dT0, Verlauf[nI].dPT, dP0)
            dMaxEntrop = max(dMaxEntrop,  dS1,  dS2)
            dMinEntrop = min(dMinEntrop,  dS1,  dS2)
        
        if (dMaxEntrop == 0.0):
            dMaxEntrop = 1.0
        if (dMinEntrop == 0.0):
            dMinEntrop = 1.0
        
       # Zeichnen Koordinatensystem 
        self.Color(0,FALSE)
        self.Pfeil(nX0,nY0,nX0+nXmax+50,nY0)
        self.Pfeil(nX0,nY0,nX0,nY0-nYmax-50)
        
        pOps = [
            (T, nX0+nXmax+60,nY0-30,'Entropie s'),
            (T, nX0+nXmax+60,nY0,'[J/(kg*K)]')
        ]
        
        if Check.bAusTs[1].get():                 # h-s-Diagramm
            pOps.extend([
                (T, nX0-125,nY0-nYmax-100+30,'Enthalpie h'),
                (T, nX0-125,nY0-nYmax-100+60,'[1000*J/kg]')
            ])
        else:
            pOps.extend([
                (T, nX0-125,nY0-nYmax-100,'Temperatur T'),
                (T, nX0-125,nY0-nYmax-100+30,'   [K]')
            ])
        
       # Masstäbe 
        if Check.bAusTs[2].get():
            # Temperatur / Enthalpie 
            if ((dMaxTemp-dMinTemp) < 10):
                nSchritte = 1
            elif ((dMaxTemp-dMinTemp) < 100):
                nSchritte = 10
            elif ((dMaxTemp-dMinTemp) < 200):
                nSchritte = 20
            elif ((dMaxTemp-dMinTemp) < 500):
                nSchritte = 50
            elif ((dMaxTemp-dMinTemp) < 1000):
                nSchritte = 100
            else:
                nSchritte = 200
            
            dHilf   = pow(10,int(log(dMinTemp)/log(10)))
            nAnfang = int(int(dMinTemp/dHilf)*dHilf)
            nEnde   = int(int(dMaxTemp/dHilf)*dHilf)
            
            nI = nAnfang
            while(nI <= nEnde+nSchritte):
                nY = int(nYmax/20.0+(nI-dMinTemp)*0.95*nYmax/(dMaxTemp-dMinTemp))
                if ((nY >= 0) and (nY <= nYmax)):
                    pOps.extend([
                        (M, nX0-20, nY0-nY), 
                        (L, nX0   , nY0-nY), 
                        (T, nX0-100, nY0-nY,'%i' % nI)
                    ])
                
                nI += nSchritte
            
            # Entropie 
            if ((dMaxEntrop-dMinEntrop) < 10):
                nSchritte = 1
            elif ((dMaxEntrop-dMinEntrop) < 20):
                nSchritte = 2
            elif ((dMaxEntrop-dMinEntrop) < 50):
                nSchritte = 5
            elif ((dMaxEntrop-dMinEntrop) < 100):
                nSchritte = 10
            elif ((dMaxEntrop-dMinEntrop) < 200):
                nSchritte = 20
            elif ((dMaxEntrop-dMinEntrop) < 500):
                nSchritte = 50
            elif ((dMaxEntrop-dMinEntrop) < 1000):
                nSchritte = 100
            elif ((dMaxEntrop-dMinEntrop) < 2000):
                nSchritte = 200
            elif ((dMaxEntrop-dMinEntrop) < 5000):
                nSchritte = 500
            elif ((dMaxEntrop-dMinEntrop) < 10000):
                nSchritte = 1000
            else:
                nSchritte = 2000
            
            dHilf   = (pow(10,int(log(dMaxEntrop-dMinEntrop)/log(10))))/10.0
            nEnde   = int(int((dMaxEntrop-dMinEntrop)/dHilf)*dHilf)
            
            nI = 0
            while(nI <= nEnde+nSchritte):
                nX = int(nXmax/20.0+nI*0.95*nXmax/(dMaxEntrop-dMinEntrop))
                if (nX >= 0) and (nX <= 1.1*nXmax):
                    pOps.extend([
                        (M, nX0+nX, nY0+20), 
                        (L, nX0+nX, nY0), 
                        (T, nX0+nX, nY0+30, '%i' % nI), 
                    ])
                
                nI += nSchritte
        
        self.AutoDraw(pOps)
        pOps = []
        
        # Isobaren zeichnen
        if Check.bAusTs[4].get():
            for nK in range(11):
                #Polyline emulieren
                nPolyX = [0]*102
                nPolyY = [0]*102
                
                for nI in range(102):
                    dTemp = dMinTemp+nI*(dMaxTemp-dMinTemp)/100.0
                    dDruck = dMinDruck+nK*(dMaxDruck-dMinDruck)/10.0
                    dS = self.Entropie(dTemp,dT0,dDruck,dP0)
                    
                    if ((dMaxEntrop-dMinEntrop) != 0.0):
                        nX = int(nXmax/20.0+(dS-dMinEntrop)*0.95*nXmax/(dMaxEntrop-dMinEntrop))
                    if ((dMaxTemp-dMinTemp) != 0.0):
                        nY = int(nYmax/20.0+(dTemp-dMinTemp)*0.95*nYmax/(dMaxTemp-dMinTemp))
                    
                    nPolyX[nI] = nX
                    nPolyY[nI] = nY
                
                self.Color (3,bFarbe)
                nMerke = 100
                for nI in range(102):
                    if ((nPolyX[0] < 0) or (nPolyY[0] < 0)):
                        for nI in range(nMerke):
                            nPolyX[nI] = nPolyX[nI+1]
                            nPolyY[nI] = nPolyY[nI+1]
                        nMerke -= 1
                
                for nI in range(nMerke+1):
                    if ((nPolyX[nI] > 1.2*nXmax) or (nPolyY[nI] > 1.2*nYmax)):
                        if (nI < nMerke):
                            nMerke = nI
                
                for nI in range(nMerke+1):
                    nPolyX[nI] += nX0
                    nPolyY[nI] = nY0-nPolyY[nI]
                
                pOps = []
                if (nMerke > 2):
                    pOps.append((M,  nPolyX[0],  nPolyY[0]))
                    #Emulier, emulier
                    for nIndex in range(nMerke-1):
                        pOps.append((L,  nPolyX[nIndex+1],  nPolyY[nIndex+1]))
                
                self.AutoDraw(pOps)
        
        pOps = []
       # Zeichnen der Punkte 
        self.Color(0,FALSE)
        for nI in range(nEbenen):
            if (nI != 0):
                pOps.append((M, nX0+nX,nY0-nY))
            
            dS = self.Entropie(Verlauf[nI].dTT,dT0,Verlauf[nI].dPT,dP0)
            if ((dMaxEntrop-dMinEntrop) != 0.0):
                nX = int(nXmax/20.0+(dS-dMinEntrop)*0.95*nXmax/(dMaxEntrop-dMinEntrop))
            if ((dMaxTemp-dMinTemp) != 0.0):
                nY = int(nYmax/20.0+(Verlauf[nI].dTT-dMinTemp)*0.95*nYmax/(dMaxTemp-dMinTemp))
            
            if (nI == 0):
                pOps.append((M,nX0+nX,nY0-nY))
            else:
                pOps.append((L,nX0+nX,nY0-nY))
            
            pOps.extend([
                (L,nX0+10+nX,nY0-nY), 
                (L,nX0-10+nX,nY0-nY), 
                (L,nX0+nX,nY0-nY)
            ])
            
            # Beschriftung 
            if Check.bAusTs[3].get():
                strText = 'Tt '
                
                if Check.bAusTs[1].get():
                    strText = 'ht '
                
                strText = '%s%i' % (strText,  nI+1)
                
                if (EbWerte[nI].nKgit == 1):
                    pOps.append((T, nX0+25+nX,nY0-nY+2,strText))
                else:
                    pOps.append((T,nX0+10+nX,nY0-nY+2,strText))
                
                if (EbWerte[nI].nKgit == 1):
                    pOps.append((T, nX0-10+nX,nY0-nY-30, 'pt %i' % (nI+1)))
                else:
                    pOps.append((T,nX0-25+nX,nY0-nY-30, 'pt %i' % (nI+1)))
            
            if (not Check.bAusTs[5].get()):
                # Absoluttemperatur -druck 
                nXTotal = nX
                nYTotal = nY
                
                dS = self.Entropie(Verlauf[nI].dTT,dT0,Verlauf[nI].dPT,dP0)
                if ((dMaxEntrop-dMinEntrop) != 0.0):
                    nX = int(nXmax/20.0+(dS-dMinEntrop)*0.95*nXmax/(dMaxEntrop-dMinEntrop))
                if ((dMaxTemp-dMinTemp) != 0.0):
                    nY = int(nYmax/20.0+(Verlauf[nI].dT-dMinTemp)*0.95*nYmax/(dMaxTemp-dMinTemp))
                
                pOps.extend([
                    (L,nX0+nX,nY0-nY), 
                    (L,nX0+10+nX,nY0-nY), 
                    (L,nX0-10+nX,nY0-nY), 
                    (L,nX0+nX,nY0-nY), 
                    (L,nX0+nXTotal,nY0-nYTotal)     # zurück zu Totalgröße
                ])
                
                # Beschriftung 
                if Check.bAusTs[3].get():
                    strText = 'T '
                    if Check.bAusTs[1].get():
                        strText = 'h '
                    
                    strText = '%s%i' % (strText,  nI+1)
                    if (EbWerte[nI].nKgit == 1):
                        pOps.append((T,nX0+25+nX,nY0-nY+2, strText))
                    else:
                        pOps.append((T,nX0+10+nX,nY0-nY+2, strText))
                    
                    if (EbWerte[nI].nKgit == 1):
                        pOps.append((T,nX0-10+nX,nY0-nY-30,'p %i' % (nI+1)))
                    else:
                        pOps.append((T,nX0-25+nX,nY0-nY-30,'p %i' % (nI+1)))
                
                nX = nXTotal
                nY = nYTotal
        
        self.AutoDraw(pOps)

    
    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def pack(self,  **kw):
        self.Layout.pack(kw)
    
    def Cancel(self):
        self.Master.remove()
    
    def destroy(self):
        self.Layout.forget()
    
    def Apply(self):
        pass
    
    
#-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
# CViewport - Helferklasse zur Emulierung der Windowsfunktionen
#-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
class CViewport:
    def __init__(self,  pTarget,  RangeX = 100,  RangeY = 100):
        self.pCanvas = pTarget
        self._iRangeX = RangeX
        self._iRangeY = RangeY
        
        self._iCurX = 0
        self._iCurY = 0
        
        self._iCurPenColor = makecol(0,  0,  0)
        self._iCurPenPattern = None
        self._iCurPenWidth = 1
        self._iCurTextColor = makecol(0,  0,  0)
    
    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    #Passt die Koordinaten an
    def _CalcPos(self,  iX,  iY):
        #Werte berechnen
        fTempX = float(iX.get())/float(self._iRangeX)
        fTempY = float(iY.get())/float(self._iRangeY)
        
        #Anpassen
        iX.set(int(fTempX*float(self.pCanvas['width'])))
        iY.set(int(fTempY*float(self.pCanvas['height'])))
    
    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    #Windowsfunktionen emulieren
    #Setzt die Position des Stiftes
    def MoveTo(self,  iX,  iY):
        iNewX = IntVar()
        iNewX.set(iX)
        
        iNewY = IntVar()
        iNewY.set(iY)
        #Koordinaten umwandeln
        self._CalcPos(iNewX,  iNewY)
        #Position setzen
        self._iCurX = iNewX.get()
        self._iCurY = iNewY.get()
    
    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    #Zieht eine Linie zur angegeben Position
    def LineTo(self,  iX,  iY):
        iNewX = IntVar()
        iNewY = IntVar()
        
        iNewX.set(iX)
        iNewY.set(iY)
        
        #Koordinaten umwandeln
        self._CalcPos(iNewX,  iNewY)
        
        #Line ziehen
        self.pCanvas.create_line(self._iCurX,  self._iCurY,  iNewX.get(),  iNewY.get(),  dash=self._iCurPenPattern,  fill=self._iCurPenColor,  width=self._iCurPenWidth)
        #Punkte als neuen Anfang verwenden
        self._iCurX = iNewX.get()
        self._iCurY = iNewY.get()
    
    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    #Setzt die Farbe des Textes    
    def SetTextColor(self,  Color):
        self._iCurTextColor = Color
    
    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    #Setzt den Stift
    def SetPen(self, pattern,  width,  color):
        #Werte übernehmen
        self._iCurPenWidth = width
        self._iCurPenColor = color
        
        #Muster auswerten
        #Python-switch @.@
        self._iCurPenPattern = {
                                'PS_SOLID' : None, 
                                'PS_DOT' : (1,  5), 
                                'PS_DASH' : (5,  5), 
                                'PS_DASHDOT' : (5,  5,  1,  5), 
                                'PS_DASHDOTDOT' : (5,  5,  1,  5,  1,  5)
                                }[pattern]

    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    #Gibt Text an einer Stelle aus
    def TextOut(self,  iX,  iY,  strText,  *options):
        iNewX = IntVar()
        iNewY = IntVar()
        
        iNewX.set(iX)
        iNewY.set(iY)
        
        #Koordinaten umwandeln
        self._CalcPos(iNewX,  iNewY)
        
        #Text ausgeben
        self.pCanvas.create_text(iNewX.get(),  iNewY.get(),  text=strText,  anchor=NW,  fill=self._iCurTextColor)

    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def Arc(self,  iX1, iY1,  iX2,  iY2,  Start=0.0,  End=360.0):
        iNewX1 = IntVar()
        iNewX2 = IntVar()
        
        iNewY1 = IntVar()
        iNewY2 = IntVar()
        
        iNewX1.set(iX1)
        iNewX2.set(iX2)
        
        iNewY1.set(iY1)
        iNewY2.set(iY2)
        
        #Koordinaten berechnen
        self._CalcPos(iNewX1,  iNewY1)
        self._CalcPos(iNewX2,  iNewY2)
        
        #Winkel hinzufügen
        self.pCanvas.create_arc(iNewX1.get(),  iNewY1.get(),  iNewX2.get(),  iNewY2.get(),  outline=self._iCurPenColor,  start=Start,  extent=End,  style=ARC)
    
    #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    #Löscht alle Zeichnungen im Viewport
    def Clear(self):
        self.pCanvas.delete('all')
    
   #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def Drucken(self,  strDatei=None,  colormode='color'):
        #Kein Dateipfad angegeben?
        if strDatei == None:
            #In Postscriptdatei drucken
            self.pCanvas.postscript(file='Ausdruck.ps',  colormode=colormode)
            #ToDo: Ausdruck drucken
            os.remove('Ausdruck.ps')
        else:
            #Nur in der Datei ablegen
            self.pCanvas.postscript(file=strDatei,  colormode=colormode)
        
    
    
#Hilfsfunktionen
def makecol(r,  g,  b):
    return "#%02x%02x%02x" % (r, g, b)
