#!/usr/bin/env python
# -*- coding: utf-8 -*-

#***************************************************************************
#*   Copyright (C) 2008-2008 by Steve Walter                               *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation; either version 3 of the License, or     *
#*   (at your option) any later version.                                   *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program; if not, write to the                         *
#*   Free Software Foundation, Inc.,                                       *
#*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
#***************************************************************************

import Mittel_T
import tkFileDialog
import tkMessageBox
import string
import os

from Mittel_T import *
from tkFileDialog import *

#Statisches
FLOAT   = 0
INT         = 1
BOOL    = 2
STRING =3
SPECIAL1 = 4
SPECIAL2 = 5

class CIO:
    def __init__(self,  pVariablen=None,  pMain=None):
        self.pVariablen = pVariablen
        self.Main = pMain
        #DateiEndungen
        self.FileExt = [('Steuerdatei',  '*.tve'),  ('Alle Dateien',  '*.*')]
        #Startverzeichnis
        self.CurDir = '.'
        self.FilePath = ''
    
    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def SaveAs(self):        
        #Dateiname holen
        self.FilePath = asksaveasfilename(filetypes=self.FileExt,  initialdir=self.CurDir, title="Mittel - Steuerdatei Speichern")
        
        #Keine Datei ausgewählt?
        if self.FilePath == '':
            #Nicht gespeichert
            self.pVariablen.pCheck.bDiskOperationOK = False
            return
        
        #Speichern
        if self.SaveFunction():
            self.Main.root.title('%s - %s' % (self.Main.szTitle,  self.FilePath))
        else:
            self.Main.root.title(self.Main.szTitle)
        
        #Dateizugriff erfolgreich
        self.pVariablen.pCheck.bDiskOperationOK = True
    
    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def Save(self):
        try:
            Datei = open(self.FilePath,  'r')
            Datei.close()
            #Speichern
            self.SaveFunction()
            self.pVariablen.pCheck.bDiskOperationOK =  True
        except:
            #Per SaveAs speichern
            self.SaveAs()

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def Load(self):
        #Dateiname holen
        self.FilePath = askopenfilename(filetypes=self.FileExt,  initialdir=self.CurDir,  title='Mittel - Laden')
        
        #Keine Datei ausgewählt?
        if self.FilePath == '':
            #Nichts geladen
            self.pVariablen.pCheck.bDiskOperationOK = False
            return False
        
        #Ladefunktion
        if self.LoadFunction():
	    #Fensterüberschrift anpassen
            self.Main.root.title('%s - %s' % (self.Main.szTitle,  self.FilePath))
        else:
            #ToDo: Fensterüberschrift anpassen
            self.Main.root.title(self.Main.szTitle)
            return False
        
        #Dateizugriff erfolgreich
        self.pVariablen.pCheck.bDiskOperationOK = True

	#Prüfen ob Datei existiert
	if os.path.exists(self.FilePath[:-1]+"a") and (os.stat(self.FilePath[:-1]+"a").st_mtime > os.stat(self.FilePath).st_mtime):
		self.tva = self.FilePath[:-1] + "a"
		self.Main.Calc.OutFileName = self.tva
		self.Main.Calc.DrawCalc()
	
        return True
    
    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def SaveFunction(self):
        #Datei zuöffnen versuchen
        Datei = None
        
        try:
            Datei = open(self.FilePath,  'w')
        except:
            showerror("Datei nicht vorhanden", "Die Datei " + self.FilePath + " konnte nicht geöffnet werden")
            return False
        
        #Dateiinhalt erstellen
        strDatei = ''
        #1 schreiben weil 1 Datensatz
        strDatei = '%s  %d\n' % (strDatei,  1)
        #Daten schreiben
        strDatei = '%s%s\n' % (strDatei,  self.pVariablen.pSteuer.szText)
        #Steuervariablen
        strDatei = '%s%3d%3d%3d%3d%3d%3d%3d%3d\n' % (strDatei,  self.pVariablen.pSteuer.nEbene,  self.pVariablen.pSteuer.nStufen,  int(self.pVariablen.pSteuer.bKein1)+1, int(self.pVariablen.pSteuer.bKiter),  self.pVariablen.pSteuer.nKabbl,  int(self.pVariablen.pSteuer.bKrad),  int(self.pVariablen.pSteuer.bKdrall),  2-int(self.pVariablen.pSteuer.bKaus))
        #GesamtDaten
        strDatei = '%s%10.5f%12.3f%10.5f%10.5f%10.5f%10.5f%10.3f\n' % (strDatei,  self.pVariablen.pGesDat.dTt_ein, self.pVariablen.pGesDat.dPt_ein, self.pVariablen.pGesDat.dAlfz_ein, self.pVariablen.pGesDat.dAlfz_aus, self.pVariablen.pGesDat.dM_ein, self.pVariablen.pGesDat.dM_aus, self.pVariablen.pGesDat.dN  )
        #Weitere GesamtDAten
        strDatei = '%s%10.5f%10.5f%10.5f%10.5f\n'% (strDatei,  self.pVariablen.pGesDat.dBln_ein, self.pVariablen.pGesDat.dBln_aus, self.pVariablen.pGesDat.dBlg_ein, self.pVariablen.pGesDat.dBlg_aus)
        
        #Nur Falls Kitter vorhanden
        if self.pVariablen.pSteuer.bKiter:
            strDatei = '%s%10.5f\n' % (strDatei,  self.pVariablen.pGesDat.dPig_soll)
        
        #Ebenen schreiben
        for Zahl in range(self.pVariablen.pSteuer.nEbene-1):
            #Aktuelle Ebene holen
            pCurrent = self.pVariablen.pEBWerte[Zahl]
            
            strDatei = '%s%3d%3d\n' % (strDatei, pCurrent.nKgit, int(pCurrent.bKein2))
            
            #Kein1 vorhanden?
            if self.pVariablen.pSteuer.bKein1:
                strDatei = '%s%10.5f%10.5f\n' % (strDatei, pCurrent.dRngeo, pCurrent.dRggeo)
            else:
                strDatei = '%s%10.5f%10.5f\n' % (strDatei, pCurrent.dCax, pCurrent.dRmittel)
            
            #Rotor?
            #Achtung: Bin mir nicht sicher, ob die Werte stimmen, oder ob nKgit nicht von 0-2, statt 1-3 reichen sollte
            if pCurrent.nKgit == 1:
                strDatei = '%s%10.5f%10.5f%10.5f%10.5f%10.5f%10.5f\n'% (strDatei,  pCurrent.dDzl, pCurrent.dTzl, pCurrent.dBax, pCurrent.dSsp, pCurrent.dRGrad, pCurrent.dDeltaTt)
            else:
                strDatei = '%s%10.5f%10.5f%10.5f%10.5f\n' % (strDatei,  pCurrent.dDzl, pCurrent.dTzl,pCurrent.dBax, pCurrent.dSsp)
            
            #Kein2 gesetzt?
            if pCurrent.bKein2:
                strDatei = '%s%10.5f%10.5f%10.5f%10.5f%10.5f%10.5f%10.5f%10.5f\n' % (strDatei, pCurrent.dXl, pCurrent.dKsec, pCurrent.dKspa, pCurrent.dEpseb, pCurrent.dEpsra, pCurrent.dEpswa, pCurrent.dKrauh, pCurrent.dLamwa)
            
            #Strömungswinkel
            if Zahl > 0:
                if (self.pVariablen.pEBWerte[Zahl-1].nKgit == 2) and (pCurrent.nKgit == 2):
                    strDatei = '%s%10.5f\n' % (strDatei, pCurrent.dAlfz)
        
        #Werte der letzen Ebene
        pCurrent = self.pVariablen.pEBWerte[self.pVariablen.pSteuer.nEbene-1]
        
        #Kein1 aktiv?
        if self.pVariablen.pSteuer.bKein1:
            strDatei = '%s%10.5f%10.5f\n'% (strDatei,  pCurrent.dRngeo, pCurrent.dRggeo)
        else:
            strDatei = '%s%10.5f%10.5f\n' % (strDatei,  pCurrent.dCax, pCurrent.dRmittel)
        
        #Daten schreiben
        Datei.write(strDatei)
        
        #Datei schließen
        Datei.close()
        
        return True
    
    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def LoadFunction(self):
        #Datei öffen
        Datei = None
        try:
            Datei = open(self.FilePath,  'r')
        except:
            showerror("Datei nicht vorhanden", "Die Datei " + self.FilePath + " konnte nicht geöffnet werden")
            return False
        
        #Variablen reinitialisiern
        self.pVariablen.InitVars()
        
        #Erste Zeile einlesen
        line = Datei.next()
        #Leerzeichen wegschneiden
        line = line.strip()
        
        #Kennziffer einlesen
        try:
            if int(line) != 1:
                return False
        except:
            return False
        
        
        #Sessionname einlesen
        self.__readLine(Datei.next(),  [(STRING,  'self.pVariablen.pSteuer.szText')])
        #Steuervariablen
	#SW: bKrad -> bKdrall
        self.__readLine(Datei.next(),  [(INT,  'self.pVariablen.pSteuer.nEbene'),  (INT,  'self.pVariablen.pSteuer.nStufen'), (SPECIAL1, 'self.pVariablen.pSteuer.bKein1'),  (BOOL,  'self.pVariablen.pSteuer.bKiter'),  (INT,  'self.pVariablen.pSteuer.nKabbl'),  (BOOL,  'self.pVariablen.pSteuer.bKrad'),  (BOOL,  'self.pVariablen.pSteuer.bKdrall'),  (SPECIAL2,  'self.pVariablen.pSteuer.bKaus')])

        #GesDat
        self.__readLine(Datei.next(),  [(FLOAT,  'self.pVariablen.pGesDat.dTt_ein'),  (FLOAT,  'self.pVariablen.pGesDat.dPt_ein'),  (FLOAT,  'self.pVariablen.pGesDat.dAlfz_ein'),  (FLOAT,  'self.pVariablen.pGesDat.dAlfz_aus'),  (FLOAT,  'self.pVariablen.pGesDat.dM_ein'),  (FLOAT,  'self.pVariablen.pGesDat.dM_aus'),  (FLOAT,  'self.pVariablen.pGesDat.dN')])
        #Weitere Gesamtdaten
        self.__readLine(Datei.next(),  [(FLOAT,  'self.pVariablen.pGesDat.dBln_ein'),  (FLOAT,  'self.pVariablen.pGesDat.dBln_aus'),  (FLOAT,  'self.pVariablen.pGesDat.dBlg_ein'),  (FLOAT,  'self.pVariablen.pGesDat.dBlg_aus')])
        
        #Kiter vorhanden?
        if self.pVariablen.pSteuer.bKiter:
            self.__readLine(Datei.next(),  [(FLOAT,  'self.pVariablen.pGesDat.dPig_soll')])
        
        #Durch die Ebenen gehen
        for Zahl in range(self.pVariablen.pSteuer.nEbene-1):
            #Werte einlesen
            self.__readLine(Datei.next(),  [(INT,  'self.pVariablen.pEBWerte[%i].nKgit'% Zahl),  (BOOL,  'self.pVariablen.pEBWerte[%i].bKein2'% Zahl)])
            
            #Kein1 aktiv?
            if self.pVariablen.pSteuer.bKein1:
                self.__readLine(Datei.next(),  [(FLOAT, 'self.pVariablen.pEBWerte[%i].dRngeo'% Zahl),  (FLOAT,  'self.pVariablen.pEBWerte[%i].dRggeo'% Zahl)])
            else:
                self.__readLine(Datei.next(),  [(FLOAT, 'self.pVariablen.pEBWerte[%i].dCax'% Zahl),  (FLOAT,  'self.pVariablen.pEBWerte[%i].dRmittel'% Zahl)])
            
            Zeile = Datei.next()
            #Wenn Zeile länger als 45 Zeichen ist, enthält sie Reakt-Grad usw
            if len(Zeile) > 45:
                self.__readLine(Zeile,  [(FLOAT,  'self.pVariablen.pEBWerte[%i].dDzl'% Zahl),  (FLOAT,  'self.pVariablen.pEBWerte[%i].dTzl'% Zahl),  (FLOAT,  'self.pVariablen.pEBWerte[%i].dBax'% Zahl),  (FLOAT,  'self.pVariablen.pEBWerte[%i].dSsp'% Zahl),  (FLOAT,  'self.pVariablen.pEBWerte[%i].dRGrad'% Zahl),  (FLOAT,  'self.pVariablen.pEBWerte[%i].dDeltaTt'% Zahl)])
            else:
                self.__readLine(Zeile,  [(FLOAT,  'self.pVariablen.pEBWerte[%i].dDzl'% Zahl),  (FLOAT,  'self.pVariablen.pEBWerte[%i].dTzl'% Zahl),  (FLOAT,  'self.pVariablen.pEBWerte[%i].dBax'% Zahl),  (FLOAT,  'self.pVariablen.pEBWerte[%i].dSsp'% Zahl)])
            
            #Kein2 aktiv?
            if self.pVariablen.pEBWerte[Zahl].bKein2:
                self.__readLine(Datei.next(),  [(FLOAT,  'self.pVariablen.pEBWerte[%i].dXl'% Zahl),(FLOAT,  'self.pVariablen.pEBWerte[%i].dKsec'% Zahl),(FLOAT,  'self.pVariablen.pEBWerte[%i].dKspa'% Zahl),(FLOAT,  'self.pVariablen.pEBWerte[%i].dEpseb'% Zahl),(FLOAT,  'self.pVariablen.pEBWerte[%i].dEpsra'% Zahl),(FLOAT,  'self.pVariablen.pEBWerte[%i].dEpswa'% Zahl),(FLOAT,  'self.pVariablen.pEBWerte[%i].dKrauh'% Zahl),(FLOAT,  'self.pVariablen.pEBWerte[%i].dLamwa'% Zahl) ])
		
            #Strömungswinkel
            if Zahl > 0:
                if (self.pVariablen.pEBWerte[Zahl-1].nKgit == 2) and (self.pVariablen.pEBWerte[Zahl].nKgit == 2):
                    self.__readLine(Datei.next(),  [(FLOAT,  'self.pVariablen.pEBWerte[%i].dAlfz'% Zahl)])
        
        #Daten der letzten Ebene einlesen
        #Achtung: Korrektur von mir, steht so nicht um Quelltext. Ich glaube der Quelltext ist fehlerhaft
        Zahl = self.pVariablen.pSteuer.nEbene-1
        
        if self.pVariablen.pSteuer.bKein1:
            self.__readLine(Datei.next(),  [(FLOAT,  'self.pVariablen.pEBWerte[%i].dRngeo'% Zahl),  (FLOAT,  'self.pVariablen.pEBWerte[%i].dRggeo'% Zahl)])
        else:
            self.__readLine(Datei.next(),  [(FLOAT,  'self.pVariablen.pEBWerte[%i].dCax'% Zahl),  (FLOAT,  'self.pVariablen.pEBWerte[%i].dRmittel'% Zahl)])

        #Datei schließen
        Datei.close()
        
        return True
    
    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def __readLine(self,  line,  Arguments):
        #Argumente splitten
        Entrys = line.split()
        
        #Länge ermitteln
        iRange = len(Entrys)
        
        #Weniger Argument als aus dem String zuziehen gehen?
        if len(Arguments) < iRange:
            iRange = len(Arguments)
        
        try:
            #Durch alle Argumente gehen
            for Zahl in range(iRange):
                Type,  Ziel = Arguments[Zahl]
		
                #Typ auswerten
                if Type == FLOAT:
                    exec '%s = float(Entrys[Zahl])\n' % Ziel
                if Type == INT:
                    exec '%s = int(Entrys[Zahl])\n' % Ziel
                if Type == BOOL:
                    exec '%s = bool(int(Entrys[Zahl]))\n' % Ziel
                if Type == STRING:
                    exec '%s = string.join(Entrys)\n' % Ziel
                if Type == SPECIAL1:
                    exec '%s = bool(int(Entrys[Zahl])-1)\n' % Ziel
                if Type == SPECIAL2:
                    exec '%s = bool(2-int(Entrys[Zahl]))\n' % Ziel
        except (),  Except:
            print 'Exception!', Exception.message,   line,  Arguments,
            return False
	
        return True
