#!/usr/bin/env python
# -*- coding: utf-8 -*-

#***************************************************************************
#*   Copyright (C) 2008-2008 by Steve Walter                               *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation; either version 3 of the License, or     *
#*   (at your option) any later version.                                   *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program; if not, write to the                         *
#*   Free Software Foundation, Inc.,                                       *
#*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
#***************************************************************************

#import Tkinter
#import Dialog22
#import tkMessageBox
#import Draw
import Pmw

from Tkinter import *
from Dialog22 import *
from tkMessageBox import *
from Draw import *


class CMenu:
    def __init__(self,  master=None,  pMain=None):
        #Master übernehmen
        self.master = master
        self.Main = pMain

        #Menüleiste erstellen
        self.MenuBar = Frame(master, relief=RAISED,  borderwidth=5)
        self.MenuBar.pack(side=TOP, fill=X)

	self.frame1 = Frame(master)
	self.frame1.pack(side=TOP, fill='both', expand=1)

	self.frame2 = Frame(self.frame1)
	self.frame2.pack()

        #Menüeintragäe erstellen
        self.DateiBtn = self.makeDateiMenu()
        self.BearbeitenBtn = self.makeBearbeitenMenu()
        self.EingabeBtn = self.makeEingabeMenu()
        self.BerechnungBtn = self.makeBerechnungMenu()
        self. AusgabeBtn = self.makeAusgabeMenu()
        self.OptionenBtn = self.makeOptionenMenu()
        self.HilfeBtn = self.makeHilfeMenu()

        #Menüeintrage in die Menüleiste einfügen
        self.MenuBar.tk_menuBar(self.DateiBtn,  self.BearbeitenBtn,  self.EingabeBtn,  self.BerechnungBtn,
                                                            self.AusgabeBtn,  self.OptionenBtn,  self.HilfeBtn)

        #Ersten Grobcheck durchführen
        self.GrobCheck()

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def makeDateiMenu(self):
        DateiBtn = Menubutton(self.MenuBar,  text='Datei',  underline=0)
        DateiBtn.pack(side=LEFT,  padx='2m')
        DateiBtn.menu = Menu(DateiBtn)

        DateiBtn.menu.add_command(label='Neu',  underline=0,  command=self.New)
        DateiBtn.menu.add_command(label='Laden',  underline=0,  command=self.Load)
        DateiBtn.menu.add_command(label='Speichern',  underline=0,  command=self.Save)
        DateiBtn.menu.add_command(label='Speichern unter...',  underline=0,  command=self.SaveAs)

        DateiBtn.menu.add('separator')

        DateiBtn.menu.add_command(label='Druckoptionen...',  underline=0,  command=lambda e=None: CDruckerDlg(self.Main.Workspace,  self.Main.Variablen,  self.Recover))
        DateiBtn.menu.add_command(label='Drucken',  underline=0,  command=self.OnDrucken)

        DateiBtn.menu.add('separator')

        DateiBtn.menu.add_command(label='Beenden',  underline=0,  command=self.Close)

        DateiBtn['menu'] = DateiBtn.menu
        return DateiBtn

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def makeBearbeitenMenu(self):
        BearbeitenBtn = Menubutton(self.MenuBar,  text='Bearbeiten',  underline=0)
        BearbeitenBtn.pack(side=LEFT,  padx='2m')
        BearbeitenBtn.menu = Menu(BearbeitenBtn)

        BearbeitenBtn.menu.add_command(label='Kopieren/Strg+Einfg',  underline=0)
        BearbeitenBtn.menu.add('separator')
        #BearbeitenBtn.menu.add_command(label='Bildschirm löschen',  underline=0, command=lambda e=CLEARSCREEN:self.Redraw(e))
	BearbeitenBtn.menu.add_command(label='Bildschirm löschen',  underline=0, command=lambda e=CLEARSCREEN:self.clrscr(e))

        BearbeitenBtn['menu'] = BearbeitenBtn.menu
        return BearbeitenBtn


    def clrscr(self, e):
	if self.frame2:
		self.frame2.destroy()
		self.frame2 = Frame(self.frame1)
		self.frame2.pack(fill='both', expand=1)
	self.Redraw(e)
    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def makeEingabeMenu(self):
        EingabeBtn = Menubutton(self.MenuBar,  text='Eingabe',  underline=0)
        EingabeBtn.pack(side=LEFT,  padx='2m')
        EingabeBtn.menu = Menu(EingabeBtn)

        #Untermenüs des Eingabemenüs erstellen
        EingabeBtn.menu.Kontrolle = Menu(EingabeBtn.menu)
        EingabeBtn.menu.Ebenen = Menu(EingabeBtn.menu)

        #CheckbuttonVariablen
        self.bSteuerung = BooleanVar()
        self.bVerdichter  = BooleanVar()

        #Einträge für das Eingabemenü
        #Dieser Eintrag soll die Eingabedialoge als Registerkarten aufrufen!
        #Einträge sind: Steuerzahlen, Gesamtverdichter, Ebenen- und Gitterwerte(1-10)
        EingabeBtn.menu.add_checkbutton(label='Steuerkennzahl', variable=self.bSteuerung,  underline=0, command=lambda e=None : CSteuerkennzahlDlg(self.Main.Workspace,  self.Main.Variablen.pSteuer,  self.GrobCheck))
        EingabeBtn.menu.add_checkbutton(label='Gesamtverdichter',  variable=self.bVerdichter,  underline=0,  command=lambda e=None : CVerdichterDlg(self.Main.Workspace,  self.Main.Variablen,  self.GrobCheck))
        EingabeBtn.menu.add_cascade(label='Kontrolle',  menu=EingabeBtn.menu.Kontrolle)
        EingabeBtn.menu.add_cascade(label='Ebenen- und Gitterwerte',  menu=EingabeBtn.menu.Ebenen)

        #Ebenenwerte
        self.bEbene1 = BooleanVar()
        self.bEbene2 = BooleanVar()
        self.bEbene3 = BooleanVar()
        self.bEbene4 = BooleanVar()
        self.bEbene5 = BooleanVar()
        self.bEbene6 = BooleanVar()
        self.bEbene7 = BooleanVar()
        self.bEbene8 = BooleanVar()
        self.bEbene9 = BooleanVar()
        self.bEbene10 = BooleanVar()

        #Ebenen erstellen
        #EingabeBtn.menu.Ebenen.add_checkbutton(label='Ebene 1',  variable=self.bEbene1,  underline=0,  command=lambda e=None: CEbenenBook(self.Main.Workspace,  self.Main.Variablen,  0,  self.GrobCheck))
        #EingabeBtn.menu.Ebenen.add_checkbutton(label='Ebene 2',  variable=self.bEbene2,  underline=0,  command=lambda e=None: CEbenenBook(self.Main.Workspace,  self.Main.Variablen,  1, self.GrobCheck))
        #EingabeBtn.menu.Ebenen.add_checkbutton(label='Ebene 3',  variable=self.bEbene3,  underline=0,  command=lambda e=None: CEbenenBook(self.Main.Workspace,  self.Main.Variablen,  2,  self.GrobCheck))
        #EingabeBtn.menu.Ebenen.add_checkbutton(label='Ebene 4',  variable=self.bEbene4,  underline=0,  command=lambda e=None: CEbenenBook(self.Main.Workspace,  self.Main.Variablen,  3,  self.GrobCheck))
        #EingabeBtn.menu.Ebenen.add_checkbutton(label='Ebene 5',  variable=self.bEbene5,  underline=0,  command=lambda e=None: CEbenenBook(self.Main.Workspace,  self.Main.Variablen,  4,  self.GrobCheck))
        #EingabeBtn.menu.Ebenen.add_checkbutton(label='Ebene 6',  variable=self.bEbene6,  underline=0,  command=lambda e=None: CEbenenBook(self.Main.Workspace,  self.Main.Variablen,  5,  self.GrobCheck))
        #EingabeBtn.menu.Ebenen.add_checkbutton(label='Ebene 7',  variable=self.bEbene7,  underline=0,  command=lambda e=None: CEbenenBook(self.Main.Workspace,  self.Main.Variablen,  6,  self.GrobCheck))
        #EingabeBtn.menu.Ebenen.add_checkbutton(label='Ebene 8',  variable=self.bEbene8,  underline=0,  command=lambda e=None: CEbenenBook(self.Main.Workspace,  self.Main.Variablen,  7,  self.GrobCheck))
        #EingabeBtn.menu.Ebenen.add_checkbutton(label='Ebene 9',  variable=self.bEbene9,  underline=0,  command=lambda e=None: CEbenenBook(self.Main.Workspace,  self.Main.Variablen,  8,  self.GrobCheck))
        #EingabeBtn.menu.Ebenen.add_checkbutton(label='Ebene 10',  variable=self.bEbene10,  underline=0,  command=lambda e=None: CEbenenBook(self.Main.Workspace,  self.Main.Variablen,  9,  self.GrobCheck))


	EingabeBtn.menu.Ebenen.add_checkbutton(label='Ebene 1',  variable=self.bEbene1,  underline=0,  command=lambda i=0: self.cmd1(i))
        EingabeBtn.menu.Ebenen.add_checkbutton(label='Ebene 2',  variable=self.bEbene2,  underline=0,  command=lambda i=1: self.cmd1(i))
        EingabeBtn.menu.Ebenen.add_checkbutton(label='Ebene 3',  variable=self.bEbene3,  underline=0,  command=lambda i=2: self.cmd1(i))
        EingabeBtn.menu.Ebenen.add_checkbutton(label='Ebene 4',  variable=self.bEbene4,  underline=0,  command=lambda i=3: self.cmd1(i))
        EingabeBtn.menu.Ebenen.add_checkbutton(label='Ebene 5',  variable=self.bEbene5,  underline=0,  command=lambda i=4: self.cmd1(i))
        EingabeBtn.menu.Ebenen.add_checkbutton(label='Ebene 6',  variable=self.bEbene6,  underline=0,  command=lambda i=5: self.cmd1(i))
        EingabeBtn.menu.Ebenen.add_checkbutton(label='Ebene 7',  variable=self.bEbene7,  underline=0,  command=lambda i=6: self.cmd1(i))
        EingabeBtn.menu.Ebenen.add_checkbutton(label='Ebene 8',  variable=self.bEbene8,  underline=0,  command=lambda i=7: self.cmd1(i))
        EingabeBtn.menu.Ebenen.add_checkbutton(label='Ebene 9',  variable=self.bEbene9,  underline=0,  command=lambda i=8: self.cmd1(i))
        EingabeBtn.menu.Ebenen.add_checkbutton(label='Ebene 10',  variable=self.bEbene10,  underline=0,  command=lambda i=9: self.cmd1(i))

        #Untermenü des Untermenü Kontrolle
        EingabeBtn.menu.Kontrolle.Verlaufe = Menu(EingabeBtn.menu.Kontrolle)

        Check = self.Main.Variablen.pCheck

        #Einträge des Untermenü Kontrolle
        EingabeBtn.menu.Kontrolle.add_command(label='Tabelle',  underline=0,  command=self.OnKontrollTabelle)
        EingabeBtn.menu.Kontrolle.add_command(label='Kanal',  underline=0,  command=self.OnKontrollKanal)
        EingabeBtn.menu.Kontrolle.add_cascade(label='Verläufe',  menu=EingabeBtn.menu.Kontrolle.Verlaufe)

        #Einträge des Untermenü Kontrolle->Verläufe
        EingabeBtn.menu.Kontrolle.Verlaufe.add_command(label='Alles',  underline=0,  command=self.OnKontrollAll)
        EingabeBtn.menu.Kontrolle.Verlaufe.add('separator')
        EingabeBtn.menu.Kontrolle.Verlaufe.add_checkbutton(label='Nabenradius [m]',  underline=0, variable=Check.bKVB[1],  command=self.OnKontrollKanal)
        EingabeBtn.menu.Kontrolle.Verlaufe.add_checkbutton(label='Gehäuseradius [m]',  underline=0, variable=Check.bKVB[2],  command=self.OnKontrollKanal)
        EingabeBtn.menu.Kontrolle.Verlaufe.add_checkbutton(label='Mittelschnittsradius [m]',  underline=0, variable=Check.bKVB[3],  command=self.OnKontrollKanal)
        EingabeBtn.menu.Kontrolle.Verlaufe.add_checkbutton(label='Querschnittsfläche [m²]',  underline=0, variable=Check.bKVB[4],  command=self.OnKontrollKanal)
        EingabeBtn.menu.Kontrolle.Verlaufe.add_checkbutton(label='Maxim. Dickenverhältnis d/s [-]',  underline=0, variable=Check.bKVB[5],  command=self.OnKontrollKanal)
        EingabeBtn.menu.Kontrolle.Verlaufe.add_checkbutton(label='Teilungsverhältnis t/s [-]',  underline=0, variable=Check.bKVB[6],  command=self.OnKontrollKanal)
        EingabeBtn.menu.Kontrolle.Verlaufe.add_checkbutton(label='Spalthöhe [mm]',  underline=0, variable=Check.bKVB[7],  command=self.OnKontrollKanal)
        EingabeBtn.menu.Kontrolle.Verlaufe.add('separator')
        EingabeBtn.menu.Kontrolle.Verlaufe.add_checkbutton(label='Kin. Reaktionsgrad [-]',  underline=0, variable=Check.bKVB[8],  command=self.OnKontrollKanal)
        EingabeBtn.menu.Kontrolle.Verlaufe.add_checkbutton(label='Δ T_t [K]',  underline=0, variable=Check.bKVB[9],  command=self.OnKontrollKanal)
        EingabeBtn.menu.Kontrolle.Verlaufe.add('separator')
        EingabeBtn.menu.Kontrolle.Verlaufe.add_checkbutton(label='Axiale Länge [m]',  underline=0, variable=Check.bKVB[10],  command=self.OnKontrollKanal)
        EingabeBtn.menu.Kontrolle.Verlaufe.add('separator')
        EingabeBtn.menu.Kontrolle.Verlaufe.add_checkbutton(label='Farben',  underline=0, variable=Check.bKVB[11],  command=self.OnKontrollKanal)
        EingabeBtn.menu.Kontrolle.Verlaufe.add_checkbutton(label='Daten [oder Kanal]',  underline=0, variable=Check.bKVB[12],  command=self.OnKontrollKanal)
        EingabeBtn.menu.Kontrolle.Verlaufe.add_checkbutton(label='Über Breite [Ebenenzahl]',  underline=0, variable=Check.bKVB[13],  command=self.OnKontrollKanal)

        EingabeBtn['menu'] = EingabeBtn.menu
        return EingabeBtn

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def cmd1(self, i):
	CEbenenBook(self.Main.Workspace,  self.Main.Variablen,  i,  self.GrobCheck)
	if self.frame2:
		self.frame2.destroy()
		self.frame2 = Frame(self.frame1)
		self.frame2.pack(fill='both', expand=1)


    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def makeBerechnungMenu(self):
        BerechnungBtn = Menubutton(self.MenuBar,  text='Berechnung',  underline=0)
        BerechnungBtn.pack(side=LEFT,  padx='2m')
        BerechnungBtn.menu = Menu(BerechnungBtn)

        BerechnungBtn.menu.add_command(labe='Aktueller Verdichter',  underline=0,  command=self.Calc)

        BerechnungBtn['menu'] = BerechnungBtn.menu
        return BerechnungBtn

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def makeAusgabeMenu(self):
        AusgabeBtn = Menubutton(self.MenuBar,  text='Ausgabe',  underline=0)
        AusgabeBtn.pack(side=LEFT,  padx='2m')
        AusgabeBtn.menu = Menu(AusgabeBtn)

        AusgabeBtn.menu.add_command(label='Tabelle',  underline=0,  command=self.OnAusTabelle)

        #Einträge für AusgabeMenü
        AusgabeBtn.menu.Dreiecke = Menu(AusgabeBtn.menu)
        AusgabeBtn.menu.Kanal = Menu(AusgabeBtn.menu)
        AusgabeBtn.menu.Schaufel = Menu(AusgabeBtn.menu)
        AusgabeBtn.menu.Verlaufe = Menu(AusgabeBtn.menu)
        AusgabeBtn.menu.hsDiagramm = Menu(AusgabeBtn.menu)

        #Unterverzeichnisse erstellen
        #AusgabeBtn.menu.add_cascade(label='Dreiecke',  menu=AusgabeBtn.menu.Dreiecke)
	AusgabeBtn.menu.add_command(label='Dreiecke',  command=self.DreieckChecks)
        #AusgabeBtn.menu.add_cascade(label='Kanal',  menu=AusgabeBtn.menu.Kanal)
	AusgabeBtn.menu.add_command(label='Kanal',  command=self.KanalChecks)
        #AusgabeBtn.menu.add_cascade(label='Schaufel',  menu=AusgabeBtn.menu.Schaufel)
	AusgabeBtn.menu.add_command(label='Schaufel',  command=self.SchaufelChecks)
        #AusgabeBtn.menu.add_cascade(label='Verläufe',  menu=AusgabeBtn.menu.Verlaufe)
	AusgabeBtn.menu.add_command(label='Verläufe', command=self.VerlaufeChecks)
        #AusgabeBtn.menu.add_cascade(label='h-s-Diagramm',  menu=AusgabeBtn.menu.hsDiagramm)
	AusgabeBtn.menu.add_command(label='h-s-Diagramm', command=self.hsDiagrammChecks)

        Check = self.Main.Variablen.pCheck

        AusgabeBtn['menu'] = AusgabeBtn.menu
        return AusgabeBtn

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def makeOptionenMenu(self):
        OptionenBtn = Menubutton(self.MenuBar,  text='Optionen',  underline=0)
        OptionenBtn.pack(side=LEFT,  padx='2m')
        OptionenBtn.menu = Menu(OptionenBtn)

        OptionenBtn.menu.add_checkbutton(labe='Rahmen zeichnen',  underline=0,  variable=self.Main.Variablen.pCheck.bRahmen,  command=self.OnRahmen)

        OptionenBtn['menu'] = OptionenBtn.menu
        return OptionenBtn

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def makeHilfeMenu(self):
        HilfeBtn = Menubutton(self.MenuBar,  text='Hilfe',  underline=0)
        HilfeBtn.pack(side=RIGHT,  padx='2m')
        HilfeBtn.menu = Menu(HilfeBtn)

        HilfeBtn.menu.add_command(label='Über...',  underline=0, command=self.About)
        HilfeBtn.menu.add_command(label='Stufe',  underline=0,  command=lambda e=1: self.OnHelp(e))
        HilfeBtn.menu.add_command(label='Dreiecke',  underline=0,  command=lambda e=2: self.OnHelp(e))
        HilfeBtn.menu.add_command(label='Schaufel',  underline=0,  command=lambda e=3: self.OnHelp(e))

        HilfeBtn['menu'] = HilfeBtn.menu
        return HilfeBtn

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def OnInit(self):
        pass

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def GrobCheck(self):
        #Variablen temporär speichern
        pVariablen = self.Main.Variablen

        #Alle nötigen Werte für Stufenkennzahl gesetzt?
        if (pVariablen.pSteuer.nStufen > 0) and (pVariablen.pSteuer.nEbene > 0):
            pVariablen.pCheck.bContr = True
            self.bSteuerung.set(True)
        else:
            self.bSteuerung.set(False)
            pVariablen.pCheck.bContr = False

        #Gesamtdaten prüfen
        if (pVariablen.pGesDat.dTt_ein > 0.0) and (pVariablen.pGesDat.dPt_ein > 0.0) and (pVariablen.pGesDat.dM_ein > 0.0) and (pVariablen.pGesDat.dM_aus > 0.0) and (pVariablen.pGesDat.dN > 0.0):
            pVariablen.pCheck.bTurbo = True
            self.bVerdichter.set(True)
        else:
            pVariablen.pCheck.bTurbo= False
            self.bVerdichter.set(False)

        #Steuerung aktiviert?
        if pVariablen.pCheck.bContr:
            #Ebenen ausnullen
            for iZahl in range(10):
                pVariablen.pCheck.bPlane[iZahl] = False
                exec 'self.bEbene%i.set(False)\n' % (iZahl+1)
                exec 'self.setEntry(self.EingabeBtn.menu.Ebenen, "Ebene %i", DISABLED)\n' % (iZahl+1)

            #Vorhandene Ebenen wieder herstellen
            for iZahl in range(pVariablen.pSteuer.nEbene):
                exec 'self.setEntry(self.EingabeBtn.menu.Ebenen, "Ebene %i", NORMAL)\n' % (iZahl+1)

            #Ebenen prüfen
            for iZahl in range(pVariablen.pSteuer.nEbene-1):
                if pVariablen.pSteuer.bKein1 == False:
                    if(pVariablen.pEBWerte[iZahl].dRmittel > 0.0) and (pVariablen.pEBWerte[iZahl].dDzl > 0.0) and (pVariablen.pEBWerte[iZahl].dBax > 0.0):
                        pVariablen.pCheck.bPlane[iZahl] = True
                        exec 'self.bEbene%i.set(True)\n' %  (iZahl+1)
                    else:
                        pVariablen.pCheck.bPlane[iZahl] = False
                else:
                    if (pVariablen.pEBWerte[iZahl].dRggeo > 0.0) and (pVariablen.pEBWerte[iZahl].dDzl > 0.0) and (pVariablen.pEBWerte[iZahl].dBax > 0.0):
                        pVariablen.pCheck.bPlane[iZahl] = True
                        exec 'self.bEbene%i.set(True)\n' %  (iZahl+1)
                    else:
                        pVariablen.pCheck.bPlane[iZahl] = False

            #Letzte Ebene seperat prüfen
            iZahl = pVariablen.pSteuer.nEbene-1
            if pVariablen.pSteuer.bKein1 == False:
                if pVariablen.pEBWerte[iZahl].dRmittel > 0.0:
                    pVariablen.pCheck.bPlane[iZahl] = True
                    exec 'self.bEbene%i.set(True)\n' % (iZahl+1)
                else:
                    pVariablen.pCheck.bPlane[iZahl] = False
            else:
                if pVariablen.pEBWerte[iZahl].dRggeo > 0.0:
                    pVariablen.pCheck.bPlane[iZahl] = True
                    exec 'self.bEbene%i.set(True)\n' % (iZahl+1)
                else:
                    pVariablen.pCheck.bPlane[iZahl] = False
        else:
            #Ebenen ausnullen
            for iZahl in range(10):
                pVariablen.pCheck.bPlane[iZahl] = False
                exec 'self.bEbene%i.set(False)\n' % (iZahl+1)
                exec 'self.setEntry(self.EingabeBtn.menu.Ebenen, "Ebene %i", DISABLED)\n' % (iZahl+1)

        pVariablen.pCheck.bEbAlle = True

        #Prüfen ob alle Ebenen startbereit sind
        for iZahl in range(pVariablen.pSteuer.nEbene-1):
            if pVariablen.pCheck.bPlane[iZahl] == False:
                pVariablen.pCheck.bEbAlle = False

        #Verdichter, Steuerung und alle Ebenen okay?
        if pVariablen.pCheck.bContr and pVariablen.pCheck.bTurbo and pVariablen.pCheck.bEbAlle:
            #Alternative: Kontrolleintrag aktivieren oder deaktivieren

            #Kontrollmenü aktivieren
            for iZahl in range(18):
                if self.EingabeBtn.menu.Kontrolle.Verlaufe.type(iZahl+1) == 'separator':
                    continue
                self.EingabeBtn.menu.Kontrolle.Verlaufe.entryconfigure(iZahl+1 ,  state=NORMAL)
            self.setEntry(self.EingabeBtn.menu.Kontrolle,  'Tabelle',  NORMAL)
            self.setEntry(self.EingabeBtn.menu.Kontrolle,  'Kanal',  NORMAL)

            #K-Ein nicht gesetzt?
            if not pVariablen.pSteuer.bKein1:
                #Kanal wieder deakitvieren
                self.setEntry(self.EingabeBtn.menu.Kontrolle,  'Kanal',  NORMAL)
                if self.Main.Zeichnen.nWasZeichnen == KONKANAL:
                    self.Redraw(CLEARSCREEN)

        else:
            #Kontrollmenü deaktivieren
            for iZahl in range(18):
                if self.EingabeBtn.menu.Kontrolle.Verlaufe.type(iZahl+1) == 'separator':
                    continue
                self.EingabeBtn.menu.Kontrolle.Verlaufe.entryconfigure(iZahl+1 ,  state=DISABLED)
            self.setEntry(self.EingabeBtn.menu.Kontrolle,  'Tabelle',  DISABLED)
            self.setEntry(self.EingabeBtn.menu.Kontrolle,  'Kanal',  DISABLED)
            #self.Redraw(CLEARSCREEN)
            #ToDo: VarCalc disabeln

        #Nicht gespeichert? Bei Veränderung muß erst eine neue Berechnung durchgeführt werden, deshalb
        #Ausgabemenü deaktivieren
        if not pVariablen.pCheck.bSaveChanges:
            self.setEntry(self.EingabeBtn.menu.Kontrolle,  'Tabelle',  DISABLED)
            self.AusgabeBtn.configure(state=DISABLED)

            if self.Main.Zeichnen.nWasZeichnen > KONVB:
                self.Redraw(CLEARSCREEN)

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def setEntry(self, menu,  Entry,  state):
            menu.entryconfigure(menu.index(Entry),  state=state)

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def New(self):
        #Gespeichert?
        if not self.Main.Variablen.pCheck.bSaveChanges:
            if not askyesno('Dateiänderung', 'Aktuelle Datei wurde geändert und nicht gespeichert.\nTrotzdem Neu erstellen?') :
                return

        #Variablen reinitialisieren
        self.Main.Variablen.InitVars()

        #Einträge deaktivieren
        self.GrobCheck()

        #Ausgabemenü deaktivieren
        self.AusgabeBtn.configure(state=DISABLED)
        self.Main.Variablen.pCheck.bRahmen.set(False)

        for nI in range(10):
            self.Main.Variablen.pCheck.bAusSch[nI].set(False)
            self.Main.Variablen.pCheck.bAusTs[nI].set(False)
            if nI < 9:
                self.Main.Variablen.pCheck.bKanal[nI].set(False)

        #ToDo: Zeugs

        #Zeichenfläche löschen
        self.Redraw(CLEARSCREEN)
        #Fensterüberschrift zurücksetzen
        self.Main.root.title(self.Main.szTitle)

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def Load(self):
	self.Redraw(CLEARSCREEN)
        #Daten laden
        self.Main.IO.Load()

        Check = self.Main.Variablen.pCheck

        #Laden erfolgreich?
        if Check.bDiskOperationOK:
            #Checkwerte zurücksetzen
            Check.bSaveChanges = True
            Check.bDiskOperationOK = False
            self.GrobCheck()

            #Ausgabe deaktivieren falls Ausgabedatei nicht vorhanden
	    try:
		self.Main.IO.tva
            	self.AusgabeBtn.configure(state=NORMAL)
	    except:
		self.AusgabeBtn.configure(state=DISABLED)

		for nI in range(10):
			self.Main.Variablen.pCheck.bAusSch[nI].set(False)
			self.Main.Variablen.pCheck.bAusTs[nI].set(False)
			if nI < 9:
				self.Main.Variablen.pCheck.bKanal[nI].set(False)

	#ToDo: Zeugs

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def Save(self):
        #Datei speichern
        self.Main.IO.Save()

        Check = self.Main.Variablen.pCheck

        #Speichern erfolgreich?
        if Check.bDiskOperationOK:
            #Checkwerte zurücksetzen
            Check.bSaveChanges = True
            Check.bDiskOperationOK = False
            self.GrobCheck()

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def SaveAs(self):
        #Datei speichern
        self.Main.IO.SaveAs()

        Check = self.Main.Variablen.pCheck

        #Speichern erfolgreich?
        if Check.bDiskOperationOK:
            #Checkwerte zurücksetzen
            Check.bSaveChanges = True
            Check.bDiskOperationOK = False
            self.GrobCheck()

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def Close(self):
        #Gespeichert?
        if not self.Main.Variablen.pCheck.bSaveChanges:
            if not askyesno('Dateiänderung', 'Aktuelle Datei wurde geändert und nicht gespeichert.\nTrotzdem beenden?') :
                return

        self.master.destroy()

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def Calc(self):
        #Kontrollen
        pVariablen = self.Main.Variablen
        #Steuerkennzahlen
        if not pVariablen.pCheck.bContr:
            showerror('Fehler!',  'Die Steuerzahlen wurden noch nicht eingegeben!')
            return

        #Verdichter
        if not pVariablen.pCheck.bTurbo:
            showerror('Fehler!',  'Die Gesamtverdichterwerte wurden noch nicht eingegeben!')
            return

        #Ebenen
        for Index in range(pVariablen.pSteuer.nEbene):
            if not pVariablen.pCheck.bPlane[Index]:
                showerror('Fehler!',  'Die Ebenenwerte der Ebene %i wurden noch nicht eingegeben!' % (Index+1))
                pVariablen.pCheck.bEbAlle = False
                break

        if not pVariablen.pCheck.bEbAlle:
            return

        #Rotoren hintereinander prüfen
        for Index in range(pVariablen.pSteuer.nEbene-2):
            #Index anpassen, damit wir nicht bei 0 anfangen
            Index += 1
            #Zwei Rotoren hintereinander?
            if (pVariablen.pEBWerte[Index].nKgit == 1)  and (pVariablen.pEBWerte[Index-1].nKgit == 1):
                showerror('Fehler!',  'Es folgen zwei Rotoren direkt hintereinander \nnach den Ebenen %i und %i\n\nEs können jedoch keine zwei Rotoren hintereinander berechnet werden.\n\nBitte ändern Sie dies vor der Berechnung!'%(Index-1,Index ))
                pVariablen.pCheck.bEbAlle = False
                break

        if not pVariablen.pCheck.bEbAlle:
            pVariablen.pCheck.bEbAlle = True
            return

        #Gespeichert?
        if not pVariablen.pCheck.bSaveChanges:
            showerror('Dateiänderung!', 'Aktuelle Datei wurde geändert und nicht gespeichert.\nVor der Berechnung muß die Datei gespeichert werden!')
            return

        #Statoren testen
        for Index in range(pVariablen.pSteuer.nEbene-2):
            #Index anpassen, damit wir nicht bei 0 anfangen
            Index += 1
            #Zwei Statoren hintereinander?
            if (pVariablen.pEBWerte[Index].nKgit == 2) and (pVariablen.pEBWerte[Index-1].nKgit == 2):
                Result = askokcancel('Hinweis',  'Es folgen zwei Statoren direkt hintereinander\nnach den Ebenen %i und %i\n\nZur Berechnung muß hierbei der Strömungswinkel\nbei Zylinder-Flächenströmung eingegeben werden.\n\nBrechen sie die Berechnung ab, \nfalls der Winkel noch nicht eingegeben ist!')
                if not Result:
                    pVariablen.pCheck.bEbAlle = False
                    break

        if not pVariablen.pCheck.bEbAlle:
            pVariablen.pCheck.bEbAlle = True
            return

        ##Letzte Warnung vor der Berechnung
        #Result = askyesno('Berechnung',  'Die Berechnung kann je nach Rechnergeschwindigkeit einige Sekunden oder gar Minuten dauern!\nWährend der Berechnung sollten keine anderen Optionen aufgerufen werden!\nTrotzdem berechnen?')

        ##Abgebrochen
        #if not Result:
            #return

        #Endlich die Berechnung
        if (not self.Main.Calc.DoCalc()):
            return

        #Ausgabe freigeben
        self.AusgabeBtn.configure(state=NORMAL)

        #Sonderfälle deaktivieren
        if pVariablen.pSteuer.bKein1:
            self.AusgabeBtn.menu.entryconfigure('Kanal',  state=NORMAL)
        else:
            self.AusgabeBtn.menu.entryconfigure('Kanal',  state=DISABLED)

        ##Schaufelmenu disablen
        #for Index in range(1,8):
           ##self.AusgabeBtn.menu.Schaufel.entryconfigure(Index,  state=DISABLED)
	   #exec "self.c%i.config(status=DISABLED)" %Index
        ###########################################################################################
        ##for Entry in ('Übersicht',  'Geschw.-Dreiecke',  'Profil',  'Farbe'):
           ##self.setEntry(self.AusgabeBtn.menu.Schaufel,  Entry,  NORMAL)


        ##Vorleitrad?
        ##Hinweis: Die For-Schleifen kann man sicher irgendwie schöner machen
        #if (pVariablen.pEBWerte[0].nKgit == 2):
            ##Vorleitrad aktivieren
            #self.setEntry(self.AusgabeBtn.menu.Schaufel,  'Vorleitrad',  NORMAL)
            ##Stufen aktivieren
            ##For Schleife der anderen Art
            #Index = 2
            #while(True):
                #if Zahl <= (pVariablen.pSteuer.nEbene/2):
                    #self.AusgabeBtn.menu.Schaufel.entryconfigure(Index+1,  state=NORMAL)
                    #Index += 1
                #else:
                    #break

        #else:
            ##Stufen aktivieren
            ##Vorschleife der anderen Art
            #Index = 2
            #while(True):
                #if Index <= ((pVariablen.pSteuer.nEbene+1)/2):
                    #self.AusgabeBtn.menu.Schaufel.entryconfigure(Index+1,  state=NORMAL)
                    #Index += 1
                #else:
                    #break

        #ToDo: Hier ggf Variation einschalten

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def About(self):
	Pmw.MessageDialog(self.master, defaultbutton='', title = 'Über',iconpos = 's', icon_bitmap = 'info', message_justify='left' ,message_text = 'MITTEL\n\nErweitertes Mittelschnittsprogramm zur aerodynamischen Auslegung von\nmehrstufigen Axialverdichtern\n\nGrafische Oberfläche ursprünglich von:\nWolfgang Ganzert und\nThomas Hüttl\n\nNach Python konvertiert von:\nSteve Walter\n\nFortran Programmkern erstellt von:\nAndreas Biagosch,\nWolfgang Ganzert und\nAndreas Ascherl\n\n*******************************\nThis program is free software; you can redistribute it and/or modify\nit under the terms of the GNU General Public License as published by\nthe Free Software Foundation; either version 3 of the License, or \n(at your option) any later version.\n\nThis program is distributed in the hope that it will be useful,\nbut WITHOUT ANY WARRANTY; without even the implied warranty of\nMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the\nGNU General Public License for more details.\n\nYou should have received a copy of the GNU General Public License\nalong with this program; if not, write to\nthe Free Software Foundation, Inc.,\n59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.\n*******************************\n\nCopyrigth (c) Lehrstuhl für Flugantriebe 1982-2009')

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------

    def DreieckChecks(self):
	for i in range(self.Main.Variablen.pSteuer.nEbene+1):
        	self.Main.Variablen.pCheck.bDreieck[i].set(True)

	for i in range(11,15):
		self.Main.Variablen.pCheck.bDreieck[i].set(True)

	Check = self.Main.Variablen.pCheck

	self.frame2.destroy()
	self.frame2 = Frame(self.frame1)
	self.frame2.pack()
	self.checks = "dreieck"
	Label(self.frame2, text="Ebene:").grid(row=0, column=0)
	self.list = []
	for i in range(10):
		self.list.append(Checkbutton(self.frame2, text=str(i+1), variable=Check.bDreieck[i+1], command=self.OnDreieck))
	self.list.append(Checkbutton(self.frame2, text='Farben', variable=Check.bDreieck[11], command=self.OnDreieck))
	self.list.append(Checkbutton(self.frame2, text='Daten', variable=Check.bDreieck[12], command=self.OnDreieck))
	self.list.append(Checkbutton(self.frame2, text='Beschriftung', variable=Check.bDreieck[13], command=self.OnDreieck))
	self.list.append(Checkbutton(self.frame2, text='Maßstab', variable=Check.bDreieck[14], command=self.OnDreieck))
	for i in range(14):
		self.list[i].grid(row=0, column=i+1)
	self.OnDreieck()

    def OnDreieck(self):
        #Dreiecke zeichnen
        self.Redraw(DREIECKE)

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def OnKanal(self):
        #Kanal zeichnen
        self.Redraw(KANAL)


    def KanalChecks(self):
	for iIndex in range(8):
            self.Main.Variablen.pCheck.bKanal[iIndex+1].set(True)

	Check = self.Main.Variablen.pCheck

	self.frame2.destroy()
	self.frame2 = Frame(self.frame1)
	self.frame2.pack()
	self.checks = "Kanal"
	self.list = []
	textlist = ["Ebenenbezeichnung", "Ebenenabstände", "Eintritts-/Austrittsradien",
		"Mittelschnittsradius", "sonst. Bezeichnungen", "Strömung", "Maßstabsgetreu", "Farbe"]
	for i in range(len(textlist)):
		self.list.append(Checkbutton(self.frame2, text=textlist[i], variable=Check.bKanal[i+1],  command=self.OnKanal))
		self.list[i].grid(row=0, column=i)
	self.OnKanal()

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def SchaufelAll(self):
        #Alle Einträge deaktivieren
        for Index in range(7):
            self.Main.Variablen.pCheck.bAusSch[Index].set(False)

        #Geschw-Dreieck, Profil, Farbe setzen
        self.Main.Variablen.pCheck.bAusSch[7].set(False)
        self.Main.Variablen.pCheck.bAusSch[8].set(False)
        self.Main.Variablen.pCheck.bAusSch[9].set(True)

        #Schaufel zeichnen
        self.OnSchaufel(0)

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def OnSchaufel(self,  Index):
        #Kleiner 6?
        if Index <= 6:
            #Deaktivieren
            for iIndex in range(7):
                self.Main.Variablen.pCheck.bAusSch[iIndex].set(False)

            self.Main.Variablen.pCheck.bAusSch[Index].set(True)

        #Geflippt wird automatisch beim anklicken

        #Zeichnen
        self.Redraw(SCHAUFEL)

    def SchaufelChecks(self):
	for Index in range(7):
            self.Main.Variablen.pCheck.bAusSch[Index].set(False)

	Check = self.Main.Variablen.pCheck

	self.frame2.destroy()
	self.frame2 = Frame(self.frame1)
	self.frame2.pack()

	self.c1 = Checkbutton(self.frame2, text="Übersicht", variable=Check.bAusSch[0],  command=self.SchaufelAll)
	self.c2 = Checkbutton(self.frame2, text="Vorleitrad", variable=Check.bAusSch[1],  command=lambda: self.OnSchaufel(1))
	self.c3 = Checkbutton(self.frame2, text="1. Stufe", variable=Check.bAusSch[2],  command=lambda: self.OnSchaufel(2))
	self.c4 = Checkbutton(self.frame2, text="2. Stufe", variable=Check.bAusSch[3],  command=lambda: self.OnSchaufel(3))
	self.c5 = Checkbutton(self.frame2, text="3. Stufe", variable=Check.bAusSch[4],  command=lambda: self.OnSchaufel(4))
	self.c6 = Checkbutton(self.frame2, text="4. Stufe", variable=Check.bAusSch[5],  command=lambda: self.OnSchaufel(5))
	self.c7 = Checkbutton(self.frame2, text="5. Stufe", variable=Check.bAusSch[6],  command=lambda: self.OnSchaufel(6))

	self.c8 = Checkbutton(self.frame2, text="Geschw.-Dreiecke", variable=Check.bAusSch[7], command=lambda: self.OnSchaufel(7))
	self.c9 = Checkbutton(self.frame2, text="Profil", variable=Check.bAusSch[8], command=lambda: self.OnSchaufel(8))
	self.c10 = Checkbutton(self.frame2, text="Farbe", variable=Check.bAusSch[9], command=lambda: self.OnSchaufel(9))

	self.c1.grid(row=0, column=0)
	self.c2.grid(row=0, column=1)
	self.c3.grid(row=0, column=2)
	self.c4.grid(row=0, column=3)
	self.c5.grid(row=0, column=4)
	self.c6.grid(row=0, column=5)
	self.c7.grid(row=0, column=6)
	self.c8.grid(row=0, column=7)
	self.c9.grid(row=0, column=8)
	self.c10.grid(row=0, column=9)

	self.OnSchaufel(0)

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def OnVerlaufe(self, Index):
        #Prüfen ob es bearbeitet werden muß
        if Index < 32:
            #Eintrag aktiv? -> dh er war vorher aus
            if self.Main.Variablen.pCheck.bAusVerl[Index].get() == True:
                if self.Main.Variablen.pCheck.nAnzahlAusVerl == 10:
                    #Es dürfen nur 10 aktiviert sein -> deaktivieren und Fehler ausgeben
                    self.Main.Variablen.pCheck.bAusVerl[Index].set(False)
                    showinfo('Hinweis: Ausgabe der Verläufe',  'Es können höchstens 10 Größen ausgegeben werden!')
                else:
                    #Anzahl anpassen
                    self.Main.Variablen.pCheck.nAnzahlAusVerl += 1
            else:
                #Anzahl anpssen
                self.Main.Variablen.pCheck.nAnzahlAusVerl -= 1
        #Zeichnen
        self.Redraw(AUSVERL)

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def VerlaufeAll(self):
        #Elemente aktivieren
        for Index in range(38):
            if Index < 11:
                self.Main.Variablen.pCheck.bAusVerl[Index].set(True)
            else:
                self.Main.Variablen.pCheck.bAusVerl[Index].set(False)

            #Markierte Anzahl setzen
            self.Main.Variablen.pCheck.nAnzahlAusVerl = 10
            #Farbe, Breite, Kanal aktivieren
            self.Main.Variablen.pCheck.bAusVerl[32].set(True)
            self.Main.Variablen.pCheck.bAusVerl[33].set(True)
            self.Main.Variablen.pCheck.bAusVerl[34].set(True)

        #Zeichnen
        self.OnVerlaufe(99)

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def VerlaufeNone(self):
        #Alle Einträge deaktivieren
        for Index in range(38):
            self.Main.Variablen.pCheck.bAusVerl[Index].set(False)

        #Anzahl setzen
        self.Main.Variablen.pCheck.nAnzahlAusVerl = 0

        #Zeichnen
        self.OnVerlaufe(99)

    def VerlaufeChecks(self):
	Check = self.Main.Variablen.pCheck

	self.frame2.destroy()
	self.frame2 = Frame(self.frame1)
	self.frame2.pack(fill='both', expand=1)

	notebook = Pmw.NoteBook(self.frame2)
	notebook.pack(fill='both', expand=1)

	self.page1 = notebook.add('Alles')
	Button(self.page1, text="Alles", command=self.VerlaufeAll).pack()
	notebook.tab('Alles').focus_set()

	self.page2 = notebook.add('Nichts')
	Button(self.page2, text="Nichts", command=self.VerlaufeNone).pack()

	self.page3 = notebook.add("Geometrie")
	text3 = ['Gehäuseradius [m]', 'Nabenradius [m]', 'Mittelschnittsradius [m]', 'Querschnittsfläche [m²]', 'Axiale Länge [m]',
		'Dicken Verhältnis d/s [-]', 'Teilungs Verhältnis t/s [-]', 'Axiale Schaufellänge [m]', 'Spalthöhe [mm]']
	Checkbutton(self.page3, text=text3[0], variable=Check.bAusVerl[1], command=lambda: self.OnVerlaufe(1)).grid(row=0, column=0)
	Checkbutton(self.page3, text=text3[1], variable=Check.bAusVerl[2], command=lambda: self.OnVerlaufe(2)).grid(row=0, column=1)
	Checkbutton(self.page3, text=text3[2], variable=Check.bAusVerl[3], command=lambda: self.OnVerlaufe(3)).grid(row=0, column=2)
	Checkbutton(self.page3, text=text3[3], variable=Check.bAusVerl[4], command=lambda: self.OnVerlaufe(4)).grid(row=1, column=0)
	Checkbutton(self.page3, text=text3[4], variable=Check.bAusVerl[5], command=lambda: self.OnVerlaufe(5)).grid(row=1, column=1)
	Checkbutton(self.page3, text=text3[5], variable=Check.bAusVerl[6], command=lambda: self.OnVerlaufe(6)).grid(row=1, column=2)
	Checkbutton(self.page3, text=text3[6], variable=Check.bAusVerl[7], command=lambda: self.OnVerlaufe(7)).grid(row=2, column=0)
	Checkbutton(self.page3, text=text3[7], variable=Check.bAusVerl[8], command=lambda: self.OnVerlaufe(8)).grid(row=2, column=1)
	Checkbutton(self.page3, text=text3[8], variable=Check.bAusVerl[9], command=lambda: self.OnVerlaufe(9)).grid(row=2, column=2)

	page4 = notebook.add('Temperatur')
	text4 = ['Temperatur [K] T', 'Totaltemperatur [K] T_t', 'Relative Totaltemperatur [K] T_t,rel']
	Checkbutton(page4, text=text4[0], variable=Check.bAusVerl[10], command=lambda: self.OnVerlaufe(10)).grid(row=0, column=0)
	Checkbutton(page4, text=text4[1], variable=Check.bAusVerl[11], command=lambda: self.OnVerlaufe(11)).grid(row=0, column=1)
	Checkbutton(page4, text=text4[2], variable=Check.bAusVerl[12], command=lambda: self.OnVerlaufe(12)).grid(row=0, column=2)

	page5 = notebook.add('Druck')
	text5 = ['Druck [N/m²] p', 'Totaldruck [N/m²] p_t', 'Relativer Totaldruck [N/m²] p_t,rel']
	Checkbutton(page5, text=text5[0], variable=Check.bAusVerl[13], command=lambda: self.OnVerlaufe(13)).grid(row=0, column=0)
	Checkbutton(page5, text=text5[1], variable=Check.bAusVerl[14], command=lambda: self.OnVerlaufe(14)).grid(row=0, column=1)
	Checkbutton(page5, text=text5[2], variable=Check.bAusVerl[15], command=lambda: self.OnVerlaufe(15)).grid(row=0, column=2)

	page6 = notebook.add('Strömungswinkel')
	text6 = ['alpha', 'beta']
	Checkbutton(page6, text=text6[0], variable=Check.bAusVerl[16], command=lambda: self.OnVerlaufe(16)).grid(row=0, column=0)
	Checkbutton(page6, text=text6[1], variable=Check.bAusVerl[17], command=lambda: self.OnVerlaufe(17)).grid(row=0, column=1)

	page7 = notebook.add('Stufenkenngrößen')
	text7 = ['Kin. Reaktionsgrad [-]', 'Δ H [J/kg]', 'Isentroper Stufenwirkungsgrad [-]', 'Δ T_t [K]', 'Π_t Stufe [-]']
	Checkbutton(page7, text=text7[0], variable=Check.bAusVerl[18], command=lambda: self.OnVerlaufe(18)).grid(row=0, column=0)
	Checkbutton(page7, text=text7[1], variable=Check.bAusVerl[19], command=lambda: self.OnVerlaufe(19)).grid(row=0, column=1)
	Checkbutton(page7, text=text7[2], variable=Check.bAusVerl[20], command=lambda: self.OnVerlaufe(20)).grid(row=0, column=2)
	Checkbutton(page7, text=text7[3], variable=Check.bAusVerl[21], command=lambda: self.OnVerlaufe(21)).grid(row=1, column=0)
	Checkbutton(page7, text=text7[4], variable=Check.bAusVerl[22], command=lambda: self.OnVerlaufe(22)).grid(row=1, column=1)

	page8 = notebook.add('Geschwindigkeiten')
	text8 = ['c [m/s]', 'c_u [m/s]', 'c_ax [m/s]', 'w [m/s]', 'w_u [m/s]', 'w_ax [m/s]']
	Checkbutton(page8, text=text8[0], variable=Check.bAusVerl[23], command=lambda: self.OnVerlaufe(23)).grid(row=0, column=0)
	Checkbutton(page8, text=text8[1], variable=Check.bAusVerl[24], command=lambda: self.OnVerlaufe(24)).grid(row=0, column=1)
	Checkbutton(page8, text=text8[2], variable=Check.bAusVerl[25], command=lambda: self.OnVerlaufe(25)).grid(row=0, column=2)
	Checkbutton(page8, text=text8[3], variable=Check.bAusVerl[26], command=lambda: self.OnVerlaufe(26)).grid(row=1, column=0)
	Checkbutton(page8, text=text8[4], variable=Check.bAusVerl[27], command=lambda: self.OnVerlaufe(27)).grid(row=1, column=1)
	Checkbutton(page8, text=text8[5], variable=Check.bAusVerl[28], command=lambda: self.OnVerlaufe(28)).grid(row=1, column=2)

	page9 = notebook.add('Kennzahlen')
	text9 = ['κ', 'Ma_c', 'Ma_w']
	Checkbutton(page9, text=text9[0], variable=Check.bAusVerl[29], command=lambda: self.OnVerlaufe(29)).grid(row=0, column=0)
	Checkbutton(page9, text=text9[1], variable=Check.bAusVerl[30], command=lambda: self.OnVerlaufe(30)).grid(row=0, column=1)
	Checkbutton(page9, text=text9[2], variable=Check.bAusVerl[31], command=lambda: self.OnVerlaufe(31)).grid(row=0, column=2)

	page10 = notebook.add('Darstellung')
	text10 = ['Daten [oder Kanal]', 'Über Breite [Ebenenzahl]', 'Farben']
	Checkbutton(page10, text=text10[0], variable=Check.bAusVerl[34], command=lambda: self.OnVerlaufe(34)).grid(row=0, column=0)
	Checkbutton(page10, text=text10[1], variable=Check.bAusVerl[33], command=lambda: self.OnVerlaufe(33)).grid(row=0, column=1)
	Checkbutton(page10, text=text10[2], variable=Check.bAusVerl[32], command=lambda: self.OnVerlaufe(32)).grid(row=0, column=2)

	self.VerlaufeAll()
	notebook.setnaturalsize()
    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def OnDiagramm(self):
        self.Redraw(TSDIAGRAMM)

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def hsDiagrammChecks(self):
        #Alle Einträge aktivieren
        for Index in range(9):
            self.Main.Variablen.pCheck.bAusTs[Index].set(True)

	Check = self.Main.Variablen.pCheck
	self.frame2.destroy()
	self.frame2 = Frame(self.frame1)
	self.frame2.pack()
	self.list = []
	textlist = ["h-s-Diagramm", "Maßstäbe", "Beschriftungen",
		"Isobaren", "nur Totalgrößen", "Farbe"]
	for i in range(len(textlist)):
		self.list.append(Checkbutton(self.frame2, text=textlist[i], variable=Check.bAusTs[i+1],  command=self.OnDiagramm))
		self.list[i].grid(row=0, column=i)
        #Zeichnen
        self.OnDiagramm()

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def OnHelp(self,  Index):
        self.Main.Variablen.pCheck.nHilfe = Index
        #Neuzeichnen
        self.Redraw(HILFE)

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def OnRahmen(self):
        self.Redraw(self.Main.Zeichnen.nWasZeichnen)

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def Redraw(self,  nMessage):
        self.Main.Workspace.add(self.Main.Zeichnen)
        self.Main.Zeichnen.nWasZeichnen = nMessage
        self.Main.Zeichnen.Draw(0)


    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def Recover(self):
        self.Main.Workspace.add(self.Main.Zeichnen)
        self.Main.Zeichnen.Draw(0)

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def OnKontrollKanal(self):
	if self.frame2:
		self.frame2.destroy()
		self.frame2 = Frame(self.frame1)
		self.frame2.pack(fill='both', expand=1)
        self.Redraw(KONKANAL)

    #---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def OnKontrollAll(self):
        for nI in range(14):
            self.Main.Variablen.pCheck.bKVB[nI].set(True)

        self.OnKontrollKanal()

   #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def OnKontrollTabelle(self):
        self.Main.Calc.ShowFile(self.Main.IO.FilePath)

   #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def OnAusTabelle(self):
        self.Main.Calc.ShowFile(self.Main.Calc.OutFileName)

   #----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    def OnDrucken(self):
        nKanal = 1
        #Schwarz/Weiß oder bunt zeichen
        if self.Main.Variablen.pCheck.bDruckFarbe.get():
            nKanal = 0

        #Canvas neuzeichen
        self.Main.Zeichnen.Draw(nKanal)
        #Canvas drucken
        self.Main.Zeichnen.Drucken()
        #Wieder normal zeichenen
        self.Main.Zeichnen.Draw(0)
