#!/usr/bin/env python
# -*- coding: utf-8 -*-

#***************************************************************************
#*   Copyright (C) 2008-2008 by Steve Walter                               *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation; either version 3 of the License, or     *
#*   (at your option) any later version.                                   *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program; if not, write to the                         *
#*   Free Software Foundation, Inc.,                                       *
#*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
#***************************************************************************

import Tkinter
from Tkinter import *

class SMenu:
    def __init__(self):
        self.bDreieck          = False
        self.bTabelle          = False
        self.bMarkieren     = False

#Steuergrößen
class SSteuer:
    def __init__(self):
        self.nEbene            = 0
        self.nStufen           = 0
        self.nKabbl            = 0
        self.bKein1             = True
        self.bKiter               = False
        self.bKrad               = False
        self.bKdrall             = False
        self.bKaus               = False
        self.szText               = ''

#Ebenenwerte
class SEBWerte:
    def __init__(self):
        self.nKgit          = 2
        self.bKein2       = False
        self.dCax          = 0.0
        self.dRmittel    = 0.0
        self.dRngeo      = 0.0
        self.dRggeo      = 0.0
        self.dDzl             = 0.0
        self.dTzl             = 0.0
        self.dBax           = 0.0
        self.dSsp           = 0.0
        self.dRGrad       = 0.0
        self.dDeltaTt     = 0.0
        self.dXl               = 0.0
        self.dKsec         = 0.0
        self.dKspa         = 0.0
        self.dEpseb       = 0.0
        self.dEpsra        = 0.0
        self.dEpswa       = 0.0
        self.dKrauh        = 0.0
        self.dLamwa      = 0.0
        self.dAlfz             = 0.0
    
    def copy(self):
        pResult = SEBWerte()
        pResult.nKgit          = self.nKgit
        pResult.bKein2       = self.bKein2
        pResult.dCax          = self.dCax  
        pResult.dRmittel    =   self.dRmittel
        pResult.dRngeo      = self.dRngeo
        pResult.dRggeo      = self.dRggeo
        pResult.dDzl             = self.dDzl
        pResult.dTzl             = self.dTzl
        pResult.dBax           =self.dBax
        pResult.dSsp           = self.dSsp 
        pResult.dRGrad       = self.dRGrad
        pResult.dDeltaTt     = self.dDeltaTt
        pResult.dXl               =self.dXl 
        pResult.dKsec         = self.dKsec
        pResult.dKspa         = self.dKspa 
        pResult.dEpseb       = self.dEpseb
        pResult.dEpsra        = self.dEpsra
        pResult.dEpswa       =self.dEpswa
        pResult.dKrauh        =self.dKrauh 
        pResult.dLamwa      = self.dLamwa
        pResult.dAlfz             = self.dAlfz
        
        return pResult

#Gesamtgröße
class SGesDat:
    def __init__(self):
        self.dTt_ein        = 0.0
        self.dPt_ein        = 0.0
        self.dAlfz_ein     = 0.0
        self.dAlfz_aus    = 0.0
        self.dM_ein         = 0.0
        self.dM_aus        = 0.0
        self.dN                 = 0.0
        self.dBln_ein      = 0.0
        self.dBln_aus    = 0.0
        self.dBlg_ein       = 0.0
        self.dBlg_aus      = 0.0
        self.dPig_soll       = 0.0

#Gechwindigkeit
class SGeschw:
    def __init__(self):
        self.dC         = 0.0
        self.dCax     = 0.0
        self.dCu       = 0.0
        self.dCr        = 0.0
        self.dU         = 0.0
        self.dW         = 0.0
        self.dWax     = 0.0
        self.dWu       = 0.0

#Verlaufswerte
class SVerlauf:
    def __init__(self):
        self.dALP       = 0.0
        self.dBET      = 0.0
        self.dKAP      = 0.0
        self.dMAC     = 0.0
        self.dMAW     = 0.0
        self.dP           = 0.0
        self.dPT         = 0.0
        self.dPTR       = 0.0
        self.dT            = 0.0
        self.dTT          = 0.0
        self.dTTR       = 0.0
        self.dL            = 0.0    #Schaufelsehnenlänge

#Verlauf der Stufengröße
class SStufenGr:
    def __init__(self):
        self.  dRgr = 0.0         # Reakt.-Grad
        self.  dDH = 0.0          # Delta H
        self.  dEta = 0.0         # Eta St
        self.  dDtt = 0.0          # Delta T_t
        self.  dPiS = 0.0         # Pi Stufe

#Kontroll- und Übergabewerte
class SCheck:
    def __init__(self):
        self.bContr                     = False
        self.bTurbo                    = False
        self.bPlane                     = [False]*11
        self.bEbAlle                    = False
        self.bDiskOperationOK = False
        self.bSaveChanges       = False
        self.bCancel                    = False
        self.bDreieck                   = [BooleanVar]*16
        self.bKVB                          = [BooleanVar]*14     # Kontrolle Verlauf
        self.bKanal                       = [BooleanVar]*9       # Ausgabe des Kanals
        self.bAusVerl                   = [BooleanVar]*38    # Ausgabe Verlauf
        self.bAusSch                   = [BooleanVar]*10     # Ausgabe Schaufel
        self.bAusTs                     = [BooleanVar]*10     # Ausgabe T-s-Diagramm
        self.szRahmenText        = ''
        self.nHilfe                         = 0
        self.nAnzahlAusVerl       = 0
        self.bRahmen                  = BooleanVar()
        self.bDruckFarbe            = BooleanVar()
        self.bPrintToFile              = BooleanVar()
        
        #Initialisieren
        for Index in range(38):
            if Index < 9:
                self.bKanal[Index] = BooleanVar()
            if Index < 10:
                self.bAusSch[Index] = BooleanVar()
                self.bAusTs[Index] = BooleanVar()
            if Index < 14:
                self.bKVB[Index] = BooleanVar()
            if Index < 16: 
                self.bDreieck[Index] = BooleanVar()
            
            self.bAusVerl[Index] = BooleanVar()

#Variablen
#pMenu       = SMenu()
#pSteuer     = SSteuer()
#pEBWerte   =[SEBWerte]*10
#pGesDat    = SGesDat()
#pCheck       = SCheck()
#pStufenGr  = [SStufenGr()]*10
#pGeschw    = [SGeschw]*10
#pVerlauf      = [SVerlauf]*10

#Variablen Initialisieren
def InitVar():
    #Menueinträge setzen
    pMenu.bDreieck = False
    pMenu.bTablle = False
    pMenu.bMarkieren = False
    
    #Steuereinträge setzen
    pSteuer.nEbene            = 0
    pSteuer.nStufen           = 0
    pSteuer.nKabbl            = 0
    pSteuer.bKein1.set(False)
    pSteuer.bKiter.set(False)
    pSteuer.bKrad.set(False)
    pSteuer.bKdrall.set(False)
    pSteuer.bKaus.set(False)
    pSteuer.szText               = '' 
    
    #Gesamtdaten setzen
    pGesDat.dTt_ein        = 0.0
    pGesDat.dPt_ein        = 0.0
    pGesDat.dAlfz_ein     = 0.0
    pGesDat.dAlfz_aus    = 0.0
    pGesDat.dM_ein         = 0.0
    pGesDat.dM_aus        = 0.0
    pGesDat.dN                 = 0.0
    pGesDat.dBln_ein      = 0.0
    pGesDat.dBln_aus    = 0.0
    pGesDat.dBlg_ein       = 0.0
    pGesDat.dBlg_aus      = 0.0
    pGesDat.dPig_soll       = 0.0
    
    #Ebenenwerte setzen
    for pEBWert in pEBWerte:
        pEBWert.nKgit          = 0
        pEBWert.bKein2       = False
        pEBWert.dCax          = 0.0
        pEBWert.dRmittel    = 0.0
        pEBWert.dRngeo      = 0.0
        pEBWert.dRggeo      = 0.0
        pEBWert.dDzl             = 0.0
        pEBWert.dTzl             = 0.0
        pEBWert.dBax           = 0.0
        pEBWert.dSsp           = 0.0
        pEBWert.dRGrad       = 0.0
        pEBWert.dDeltaTt     = 0.0
        pEBWert.dXl               = 0.0
        pEBWert.dKsec         = 0.0
        pEBWert.dKspa         = 0.0
        pEBWert.dEpseb       = 0.0
        pEBWert.dEpsra        = 0.0
        pEBWert.dEpswa       = 0.0
        pEBWert.dKrauh        = 0.0
        pEBWert.dLamwa      = 0.0
        pEBWert.dAlfz             = 0.0
    
    #Verlaufwerte setzen
    for Verlauf in pVerlauf:
        Verlauf.dALP       = 0.0
        Verlauf.dBET      = 0.0
        Verlauf.dKAP      = 0.0
        Verlauf.dMAC     = 0.0
        Verlauf.dMAW     = 0.0
        Verlauf.dP           = 0.0
        Verlauf.dPT         = 0.0
        Verlauf.dPTR       = 0.0
        Verlauf.dT            = 0.0
        Verlauf.dTT          = 0.0
        Verlauf.dTTR       = 0.0
        Verlauf.dL            = 0.0     

    #Stufengröße setzen
    for StufenGr in pStufenGr:
        StufenGr.  dRgr = 0.0         
        StufenGr.  dDH = 0.0          
        StufenGr.  dEta = 0.0         
        StufenGr.  dDtt = 0.0          
        StufenGr.  dPiS = 0.0         
  
    #Ausgabewerte setzen
    for Geschw in pGeschw:
        Geschw.dC         = 0.0
        Geschw.dCax     = 0.0
        Geschw.dCu       = 0.0
        Geschw.dCr        = 0.0
        Geschw.dU         = 0.0
        Geschw.dW         = 0.0
        Geschw.dWax     = 0.0
        Geschw.dWu       = 0.0
    
    #Checkwerte setzen
        pCheck.bContr                     = False
        pCheck.bTurbo                    = False
        pCheck.bPlane                     = [False]*11
        pCheck.bEbAlle                    = False
        pCheck.bDiskOperationOK = False
        pCheck.bSaveChanges       = False
        pCheck.bCancel                    = False
        pCheck.bDreieck                   = [BooleanVar]*16
        pCheck.bKVB                          = [BooleanVar]*14       # Kontrolle Verlauf
        pCheck.bKanal                       = [BooleanVar]*9                              # Ausgabe des Kanals
        pCheck.bAusVerl                   = [BooleanVar]*38    # Ausgabe Verlauf
        pCheck.bAusSch                   = [BooleanVar]*10     # Ausgabe Schaufel
        pCheck.bAusTs                     = [BooleanVar]*10     # Ausgabe T-s-Diagramm
        pCheck.szRahmenText        = ''
        pCheck.nHilfe                         = 0
        pCheck.nAnzahlAusVerl       = 0
        
        #Initialisieren
        for Index in range(38):
            if Index < 9:
                pCheck.bKanal[Index] = BooleanVar()
            if Index < 10:
                pCheck.bAusSch[Index] = BooleanVar()
                pCheck.bAusTs[Index] = BooleanVar()
            if Index < 14:
                pCheck.bKVB[Index] = BooleanVar()
            if Index < 16: 
                pCheck.bDreieck[Index] = BooleanVar()
            
            pCheck.bAusVerl[Index] = BooleanVar()

#Andere Version von InitVar
def InitVa():
    #Variablen bekommen Standardwerte zugewiesen -> Reset
    self.pMenu       = SMenu()
    self.pSteuer     = SSteuer()
    self.pEBWerte   = [SEBWerte]*10
    self.pGesDat    = SGesDat()
    self.pCheck       = SCheck()
    self.pStufenGr  = [SStufenGr()]*10
    self.pGeschw    = [SGeschw]*10
    self.pVerlauf      = [SVerlauf]*10
    

#Klasse für die Variablen
class CVariablen:
    def __init__(self):
        self.pMenu       = SMenu()
        self.pSteuer     = SSteuer()
        self.pEBWerte   = [SEBWerte]*10
        self.pGesDat    = SGesDat()
        self.pCheck       = SCheck()
        self.pStufenGr  = [SStufenGr]*10
        self.pGeschw    = [SGeschw]*10
        self.pVerlauf      = [SVerlauf]*10

    def InitVars(self):
        #Variablen bekommen Standardwerte zugewiesen -> Reset
        self.pMenu       = SMenu()
        self.pSteuer     = SSteuer()
        self.pEBWerte   = [SEBWerte]*10
        self.pGesDat    = SGesDat()
        self.pStufenGr  = [SStufenGr]*10
        self.pGeschw    = [SGeschw]*10
        self.pVerlauf      = [SVerlauf]*10
        
        for Index in range(10):
            self.pEBWerte[Index] = SEBWerte()
            self.pStufenGr[Index] = SStufenGr()
            self.pGeschw[Index] = SGeschw()
            self.pVerlauf[Index] = SVerlauf()
