! ***************************************************************************
! *   Copyright (C) 1982-2008 by Institute for Flight Propulsion,           *
! *   Technische Universität München                                        *
! *   borm@lfa.mw.tum.de                                                    *
! *                                                                         *
! *   This program is free software; you can redistribute it and/or modify  *
! *   it under the terms of the GNU General Public License as published by  *
! *   the Free Software Foundation; either version 3 of the License, or     *
! *   (at your option) any later version.                                   *
! *                                                                         *
! *   This program is distributed in the hope that it will be useful,       *
! *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
! *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
! *   GNU General Public License for more details.                          *
! *                                                                         *
! *   You should have received a copy of the GNU General Public License     *
! *   along with this program; if not, write to the                         *
! *   Free Software Foundation, Inc.,                                       *
! *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
! ***************************************************************************

C**********************************************************************
C
C  AUFGABE DES PROGRAMMES     M I T T E L
C     DAS PROGRAMM FUEHRT EINE AERODYNAMISCHE AUSLEGUNG
C     FUER MEHRSTUFIGE AXIAL-VERDICHTER NACH EINEM MODIFI-
C     ZIERTEN MITTELSCHNITTS-VERFAHREN DURCH, DAS UM EINIGE
C     RADIALE EFFEKTE ERWEITERT WURDE.
C
C  VERWENDETE UNTERPROGRAMME :
C     BLOCK, CAXIT, FKAPPA, GEO, KAPPA, ROTOR,
C     STATOR, DRALL
C
C**********************************************************************
C
      PROGRAM MITTEL

      INTEGER I1,I2,I3,J,J1,J2,JJ,JMAX,K,KABBL,KALF(20),KAUS,KD,
     #        KDAT,KDRALL,KEIN1,KEIN2,KGIT(20),KITER,KMAX,KRAD
C
      REAL    A(20),ALF(20),ALFZ(20),AS(20),BAX(20),BET(20),BLG(20),
     #        BLGA,BLGE,BLN(20),BLNA,BLNE,C(20),C2Z1(20),CAP(20),
     #        CAPIS,CAPM,CAPP,CAPSTA,CAX(20),CAX2Z1(20),CP(20),CPIS,
     #        CPSTA,CR(20),CU(20),D(20),DELALF(20),DELBET(20),
     #        DELH(20),DELT(20),DT,DZL(20),EPSEB(20),EPSRA(20),
     #        EPSWA(20),ETAGES,ETAST(20),F(20),FGEO(20),FPI,HZL(20),
     #        KRAUH(20),KSEC(20),KSPA(20),L(20),LAC(20),LACAX(20),
     #        LAMB(20),LAMWA(20),LAU(20),LAW(20),M,M1,M2,MAC(20),
     #        MAW(20),N,NRED,OGES(20),OGESK(20),OM(20),OPIK(20),
     #        OPIKK(20),OPKO(20),OPKOK(20),OSEC(20),OSECK(20),OSPA(20),
     #        OSPAK(20),OSTOS(20),OWA(20),OWAK(20),P(20),PI,PIG,PIGES,
     #        PIGES1,PIST(20),PT(20),PTREL(20),R,RE(20),
     #        REA(20),RG(20),RGGEO(20),RM(20),RMGEO(20),RN(20),
     #        RNGEO(20),SSP(20),T(20),TT(20),TTIS,TTREL(20),TZL(20),
     #        U(20),W(20),W2Z1(20),WU(20),XAX(20),XL(20),ZETA(20)

C     Aenderungen von Wolfgang Ganzert und Andreas Ascherl 05.05.1993
      REAL FROT(107)

      REAL FSTAT(94)
C

      CHARACTER*80  TEXT
      CHARACTER*4100  InputDatei, OutputDatei       ! Oliver Borm
C
C----------------------------------------------------------------------
C  BEGINN DES EINLESETEILS MIT KONTROLLAUSDRUCK
C----------------------------------------------------------------------
C
C=====================================
C Beginn Änderungen Oliver Borm
C
!     Achtung get_command_argument ist erst ab dem Fortran2003 Standard implementiert!
!      CALL get_command_argument(1, InputDatei)
!      CALL get_command_argument(2, OutputDatei)

      call GETARG(1, InputDatei)
      call GETARG(2, OutputDatei)

      OPEN(1,file=TRIM(InputDatei))
      OPEN(2,file=TRIM(OutputDatei))

!       OPEN(1,file='input.dat')
!       OPEN(2,file='output.dat')

C
C Ende Änderungen Oliver Borm
C=====================================
C
      READ(1,1)  KDAT
      KD = 0
100   KD = KD+1
      WRITE(2,21)
      READ(1,2)  TEXT
      WRITE(2,2) TEXT
      WRITE(2,39)
      READ(1,3)  JMAX,KMAX,KEIN1,KITER,KABBL,KRAD,KDRALL,KAUS
      WRITE(2,40)JMAX,KMAX,KEIN1,KITER,KABBL,KRAD,KDRALL,KAUS
      READ(1,4)  TT(1),PT(1),ALFZ(1),ALFZ(JMAX),M1,M2,N
      READ(1,5)  BLNE,BLNA,BLGE,BLGA
      WRITE(2,41)TT(1),PT(1),ALFZ(1),ALFZ(JMAX),M1,M2,N,BLNE,BLNA,
     #           BLGE,BLGA
      IF(KITER.EQ.1)THEN
         READ(1,6)  PIG
         WRITE(2,42)PIG
      END IF
C
C  EBENENWEISES EINLESEN
C
      WRITE(2,43)
      DO 120 J=1,JMAX
         WRITE(2,44)J
         IF(J.EQ.JMAX) GOTO 110
         READ(1,7)  KGIT(J),KEIN2
         WRITE(2,45)KGIT(J),KEIN2
 110     IF(KEIN1.EQ.1)THEN
            READ(1,8)  CAX(J),RM(J)
            WRITE(2,46)CAX(J),RM(J)
         ELSE IF(KEIN1.EQ.2) THEN
            READ(1,8)  RNGEO(J),RGGEO(J)
            WRITE(2,47)RNGEO(J),RGGEO(J)
         END IF
         IF(J.EQ.JMAX) GOTO 120
         IF(KGIT(J).EQ.1)THEN
            READ(1,9)  DZL(J),TZL(J),BAX(J),SSP(J),REA(J),DELT(J)
            WRITE(2,48)DZL(J),TZL(J),BAX(J),SSP(J),REA(J),DELT(J)
         ELSE IF(KGIT(J).EQ.2)THEN
            READ(1,5)  DZL(J),TZL(J),BAX(J),SSP(J)
            WRITE(2,49)DZL(J),TZL(J),BAX(J),SSP(J)
         END IF
         IF(KEIN2.EQ.1)THEN
            READ(1,10) XL(J),KSEC(J),KSPA(J),EPSEB(J),EPSRA(J),
     #                 EPSWA(J),KRAUH(J),LAMWA(J)
         ELSE
            JJ = J-1
            XL(J)      = XL(JJ)
            KSEC(J)    = KSEC(JJ)
            KSPA(J)    = KSPA(JJ)
            EPSEB(J)   = EPSEB(JJ)
            EPSRA(J)   = EPSRA(JJ)
            EPSWA(J)   = EPSWA(JJ)
            KRAUH(J)   = KRAUH(JJ)
            LAMWA(J)  = LAMWA(JJ)
         END IF
         WRITE(2,50) XL(J),KSEC(J),KSPA(J),EPSEB(J),EPSRA(J),
     #               EPSWA(J),KRAUH(J),LAMWA(J)
         IF(J.EQ.1) GOTO 120
         IF(KGIT(J).EQ.2.AND.KGIT(J-1).EQ.2) THEN
            KALF(J) = 1
            READ(1,6)  ALFZ(J)
            WRITE(2,51)ALFZ(J)
         ELSE
            KALF(J) = 0
         END IF
 120  CONTINUE
C----------------------------------------------------------------------
C  ENDE DES EINLESETEILS
C----------------------------------------------------------------------
C  BESETZEN VON KONSTANTEN, UMRECHNUNGEN UND RINGRAUM-GEOMETRIE
C----------------------------------------------------------------------
C
      R    = 287.05
      PI   = 3.14159
      NRED = PI * N / 30.
      M     = M1
      I1   = 0
      J1   = JMAX - 1
      KALF(1)    = 1
      KALF(JMAX) = 1
      DO 130 J = 1,JMAX
         IF (KALF(J).EQ.1) ALFZ(J) = ALFZ(J) * PI/180.
 130  CONTINUE
C
C  UMRECHNEN VON RADIALSPALTWEITE UND RAUHIGKEITSHOEHE IN [M]
C
      DO 140 J=1,J1
         KRAUH(J) = KRAUH(J)*1.E-6
         SSP(J)   = SSP(J)*1.E-3
 140  CONTINUE
C
C  BERECHNEN ALLER BLOCKAGE-FAKTOREN AN NABE UND GEHAEUSEWAND
C
      CALL BLOCK(KMAX,JMAX,J1,KALF,KGIT,BLGE,BLGA,BLNE,BLNA,BLG,BLN)
      IF(KEIN1.EQ.1) GOTO 160
C
C  BERECHNUNG DER FEHLENDEN RINGRAUMABMESSUNGEN, WENN
C  RGGEO UND RNGEO GEGEBEN SIND
C
      DO 150 J=1,JMAX
         RMGEO(J) = SQRT((RNGEO(J)**2+RGGEO(J)**2)/2.)
         FGEO(J)  = PI*(RGGEO(J)**2-RNGEO(J)**2)
         RG(J)    = SQRT(RGGEO(J)**2-BLG(J)*(RGGEO(J)**2-RNGEO(J)**2))
         RN(J)    = SQRT(RNGEO(J)**2+BLN(J)*(RGGEO(J)**2-RNGEO(J)**2))
         F(J)     = PI*(RG(J)**2-RN(J)**2)
         RM(J)    = SQRT((RN(J)**2+RG(J)**2)/2.)
 150  CONTINUE
C
C  BERECHNUNG DER STROMLINIEN-NEIGUNGSWINKEL
C
 160  DO 170 J=1,J1
         IF(KRAD.NE.1) LAMB(J) = 0.
         IF(KRAD.EQ.1) LAMB(J) = ATAN((RM(J+1)-RM(J))/BAX(J))
 170  CONTINUE
      LAMB(JMAX) = 0.
C----------------------------------------------------------------------
C  BERECHNEN DER EINTRITTSEBENE
C----------------------------------------------------------------------
      CALL KAPPA(TT(1),CP(1),CAP(1))
      CALL FKAPPA(CAP(1),CAPP,CAPM,CAPIS)
      AS(1) = SQRT(2.*CAP(1)*R*TT(1)/CAPP)
      U(1)  = NRED*RM(1)
      LAU(1)= U(1)/AS(1)
      IF(KEIN1.EQ.2)THEN
         CALL CAXIT(KALF(1),TT(1),PT(1),M,F(1),PI,R,CAP(1),
     #              CAPP,CAPM,AS(1),ALF(1),ALFZ(1),LAMB(1),CU(1),
     #               CAX(1),CR(1),C(1),LACAX(1),LAC(1))
      ELSE IF(KEIN1.EQ.1) THEN
         IF(ALFZ(1).NE.(PI/2.))  CU(1) = CAX(1)/TAN(ALFZ(1))
         IF(ALFZ(1).EQ.(PI/2.)) CU(1) = 0.
         CR(1)    = CAX(1)*TAN(LAMB(1))
         C(1)     = SQRT(CAX(1)**2+CU(1)**2+CR(1)**2)
         LAC(1)   = C(1)/AS(1)
         LACAX(1) = CAX(1)/AS(1)
         ALF(1)   = ACOS(CU(1)/C(1))
         CALL GEO(LACAX(1),LAC(1),BLG(1),BLN(1),F(1),FGEO(1),
     #            RG(1),RGGEO(1),RM(1),RMGEO(1),RN(1),RNGEO(1),
     #            PI,R,M,CAP(1),CAPP,CAPM,TT(1),PT(1))
      END IF
      T(1)    = TT(1)-C(1)**2/(2.*CP(1))
      P(1)    = PT(1)*(T(1)/TT(1))**CAPIS
      CALL KAPPA(T(1),CPSTA,CAPSTA)
      A(1)    = SQRT(CAPSTA*R*T(1))
      MAC(1)  = C(1)/A(1)
      XAX(1)  = 0.
C----------------------------------------------------------------------
C  BEGINN DER GESAMTDRUCK-ITERATION, WENN KITER=1
C----------------------------------------------------------------------
 180  I1 = I1+1
      M  = M1
      DO 200 J=1,J1
         IF(J.EQ.KABBL) M = M2
         JJ = J+1

C-********************************************************************
C     Aenderungen von Wolfgang Ganzert, Mai 1993
C-********************************************************************

      FROT( 1)=J
      FROT( 2)=KEIN1
      FROT( 3)=NRED
      FROT( 4)=PI
      FROT( 5)=BLG(JJ)
      FROT( 6)=BLN(JJ)
      FROT( 7)=RM(J)
      FROT( 8)=RM(JJ)
      FROT( 9)=RG(J)
      FROT(10)=RG(JJ)
      FROT(11)=RN(J)
      FROT(12)=RN(JJ)
      FROT(13)=RMGEO(JJ)
      FROT(14)=RGGEO(J)
      FROT(15)=RGGEO(JJ)
      FROT(16)=RNGEO(J)
      FROT(17)=RNGEO(JJ)
      FROT(18)=F(JJ)
      FROT(19)=FGEO(JJ)
      FROT(20)=A(J)
      FROT(21)=A(JJ)
      FROT(22)=AS(J)
      FROT(23)=AS(JJ)
      FROT(24)=C(JJ)
      FROT(25)=CAX(J)
      FROT(26)=CAX(JJ)
      FROT(27)=CR(J)
      FROT(28)=CR(JJ)
      FROT(29)=CU(J)
      FROT(30)=CU(JJ)
      FROT(31)=LAC(JJ)
      FROT(32)=LACAX(JJ)
      FROT(33)=MAC(JJ)
      FROT(34)=U(J)
      FROT(35)=U(JJ)
      FROT(36)=LAU(J)
      FROT(37)=LAU(JJ)
      FROT(38)=W(J)
      FROT(39)=W(JJ)
      FROT(40)=WU(J)
      FROT(41)=WU(JJ)
      FROT(42)=LAW(J)
      FROT(43)=LAW(JJ)
      FROT(44)=MAW(J)
      FROT(45)=MAW(JJ)
      FROT(46)=W2Z1(J)
      FROT(47)=CAX2Z1(J)
      FROT(48)=ALF(JJ)
      FROT(49)=ALFZ(JJ)
      FROT(50)=BET(J)
      FROT(51)=BET(JJ)
      FROT(52)=DELBET(J)
      FROT(53)=LAMB(J)
      FROT(54)=LAMB(JJ)
      FROT(55)=M
      FROT(56)=R
      FROT(57)=REA(J)
      FROT(58)=DELH(J)
      FROT(59)=DELT(J)
      FROT(60)=CAP(J)
      FROT(61)=CP(J)
      FROT(62)=CAP(JJ)
      FROT(63)=CP(JJ)
      FROT(64)=TT(J)
      FROT(65)=TT(JJ)
      FROT(66)=TTREL(J)
      FROT(67)=TTREL(JJ)
      FROT(68)=T(J)
      FROT(69)=T(JJ)
      FROT(70)=PT(J)
      FROT(71)=PT(JJ)
      FROT(72)=PTREL(J)
      FROT(73)=PTREL(JJ)
      FROT(74)=P(J)
      FROT(75)=P(JJ)
      FROT(76)=KSEC(J)
      FROT(77)=KSPA(J)
      FROT(78)=EPSEB(J)
      FROT(79)=EPSWA(J)
      FROT(80)=EPSRA(J)
      FROT(81)=BAX(J)
      FROT(82)=DZL(J)
      FROT(83)=HZL(J)
      FROT(84)=TZL(J)
      FROT(85)=XL(J)
      FROT(86)=SSP(J)
      FROT(87)=KRAUH(J)
      FROT(88)=LAMWA(J)
      FROT(89)=D(J)
      FROT(90)=OM(J)
      FROT(91)=L(J)
      FROT(92)=RE(J)
      FROT(93)=OPIK(J)
      FROT(94)=OPIKK(J)
      FROT(95)=OPKO(J)
      FROT(96)=OPKOK(J)
      FROT(97)=OWA(J)
      FROT(98)=OWAK(J)
      FROT(99)=OSEC(J)
      FROT(100)=OSECK(J)
      FROT(101)=OSPA(J)
      FROT(102)=OSPAK(J)
      FROT(103)=OSTOS(J)
      FROT(104)=OGES(J)
      FROT(105)=OGESK(J)
      FROT(106)=ZETA(J)
      FROT(107)=KALF(JJ)

      FSTAT( 1)=KEIN1
      FSTAT( 2)=NRED
      FSTAT( 3)=PI
      FSTAT( 4)=BLG(J)
      FSTAT( 5)=BLN(J)
      FSTAT( 6)=RM(J)
      FSTAT( 7)=RM(JJ)          
      FSTAT( 8)=RM(J+2)
      FSTAT( 9)=RG(J)
      FSTAT(10)=RG(JJ)
      FSTAT(11)=RN(J)
      FSTAT(12)=RN(JJ)
      FSTAT(13)=RMGEO(JJ)
      FSTAT(14)=RGGEO(J)          
      FSTAT(15)=RGGEO(JJ) 
      FSTAT(16)=RNGEO(J)
      FSTAT(17)=RNGEO(JJ)
      FSTAT(18)=F(JJ)  
      FSTAT(19)=FGEO(JJ)
      FSTAT(20)=A(JJ)             
      FSTAT(21)=AS(J)
      FSTAT(22)=AS(JJ)
      FSTAT(23)=C(J)
      FSTAT(24)=C(JJ)
      FSTAT(25)=CAX(J)
      FSTAT(26)=CAX(JJ)
      FSTAT(27)=CR(J)
      FSTAT(28)=CR(JJ)           
      FSTAT(29)=CU(J)
      FSTAT(30)=CU(JJ)
      FSTAT(31)=U(J)
      FSTAT(32)=U(JJ)
      FSTAT(33)=LAC(J)
      FSTAT(34)=LAC(JJ)
      FSTAT(35)=LACAX(JJ)              
      FSTAT(36)=MAC(J)
      FSTAT(37)=MAC(JJ)
      FSTAT(38)=ALF(J)
      FSTAT(39)=ALF(JJ)
      FSTAT(40)=DELALF(J)
      FSTAT(41)=ALFZ(J)               
      FSTAT(42)=ALFZ(JJ) 
      FSTAT(43)=LAMB(J)
      FSTAT(44)=LAMB(JJ)
      FSTAT(45)=C2Z1(J)
      FSTAT(46)=CAX2Z1(J)
      FSTAT(47)=M
      FSTAT(48)=R               
      FSTAT(49)=REA(JJ)
      FSTAT(50)=DELT(JJ)
      FSTAT(51)=CAP(J)
      FSTAT(52)=CP(J)
      FSTAT(53)=CAP(JJ) 
      FSTAT(54)=CP(JJ)
      FSTAT(55)=TT(J)            
      FSTAT(56)=TT(JJ)
      FSTAT(57)=T(J)
      FSTAT(58)=T(JJ)
      FSTAT(59)=PT(J)
      FSTAT(60)=PT(JJ) 
      FSTAT(61)=P(J)
      FSTAT(62)=P(JJ)
      FSTAT(63)=KSEC(J)             
      FSTAT(64)=KSPA(J)
      FSTAT(65)=EPSEB(J)
      FSTAT(66)=EPSWA(J)
      FSTAT(67)=EPSRA(J)
      FSTAT(68)=BAX(J)
      FSTAT(69)=DZL(J)              
      FSTAT(70)=HZL(J)
      FSTAT(71)=TZL(J)
      FSTAT(72)=XL(J)
      FSTAT(73)=SSP(J)
      FSTAT(74)=KRAUH(J)
      FSTAT(75)=LAMWA(J)                  
      FSTAT(76)=D(J)
      FSTAT(77)=OM(J)
      FSTAT(78)=L(J)
      FSTAT(79)=RE(J)
      FSTAT(80)=OPIK(J)
      FSTAT(81)=OPIKK(J)
      FSTAT(82)=OPKO(J)                
      FSTAT(83)=OPKOK(J)
      FSTAT(84)=OWA(J)
      FSTAT(85)=OWAK(J)
      FSTAT(86)=OSEC(J)
      FSTAT(87)=OSECK(J) 
      FSTAT(88)=OSPA(J)              
      FSTAT(89)=OSPAK(J)
      FSTAT(90)=OSTOS(J)
      FSTAT(91)=OGES(J)
      FSTAT(92)=OGESK(J)
      FSTAT(93)=ZETA(J)
      FSTAT(94)=KALF(JJ)           

C-********************************************************************
C     Ende der Aenderungen
C-********************************************************************

C----------------------------------------------------------------------
C  AUFRUFEN DES UP ROTOR, WENN EIN ROTOR FOLGT
C----------------------------------------------------------------------
      IF(KGIT(J).EQ.1)THEN
         I2=1
         CALL ROTOR(FROT)

C-********************************************************************
C     Aenderungen von Wolfgang Ganzert, Mai 1993
C-********************************************************************

      KEIN1=FROT( 2)
      NRED=FROT( 3)
      PI=FROT( 4)
      BLG(JJ)=FROT( 5)
      BLN(JJ)=FROT( 6)
      RM(J)=FROT( 7)
      RM(JJ)=FROT( 8)
      RG(J)=FROT( 9)
      RG(JJ)=FROT(10)
      RN(J)=FROT(11)
      RN(JJ)=FROT(12)
      RMGEO(JJ)=FROT(13)
      RGGEO(J)=FROT(14)
      RGGEO(JJ)=FROT(15)
      RNGEO(J)=FROT(16)
      RNGEO(JJ)=FROT(17)
      F(JJ)=FROT(18)
      FGEO(JJ)=FROT(19)
      A(J)=FROT(20)
      A(JJ)=FROT(21)
      AS(J)=FROT(22)
      AS(JJ)=FROT(23)
      C(JJ)=FROT(24)
      CAX(J)=FROT(25)
      CAX(JJ)=FROT(26)
      CR(J)=FROT(27)
      CR(JJ)=FROT(28)
      CU(J)=FROT(29)
      CU(JJ)=FROT(30)
      LAC(JJ)=FROT(31)
      LACAX(JJ)=FROT(32)
      MAC(JJ)=FROT(33)
      U(J)=FROT(34)
      U(JJ)=FROT(35)
      LAU(J)=FROT(36)
      LAU(JJ)=FROT(37)
      W(J)=FROT(38)
      W(JJ)=FROT(39)
      WU(J)=FROT(40)
      WU(JJ)=FROT(41)
      LAW(J)=FROT(42)
      LAW(JJ)=FROT(43)
      MAW(J)=FROT(44)
      MAW(JJ)=FROT(45)
      W2Z1(J)=FROT(46)
      CAX2Z1(J)=FROT(47)
      ALF(JJ)=FROT(48)
      ALFZ(JJ)=FROT(49)
      BET(J)=FROT(50)
      BET(JJ)=FROT(51)
      DELBET(J)=FROT(52)
      LAMB(J)=FROT(53)
      LAMB(JJ)=FROT(54)
      M=FROT(55)
      R=FROT(56)
      REA(J)=FROT(57)
      DELH(J)=FROT(58)
      DELT(J)=FROT(59)
      CAP(J)=FROT(60)
      CP(J)=FROT(61)
      CAP(JJ)=FROT(62)
      CP(JJ)=FROT(63)
      TT(J)=FROT(64)
      TT(JJ)=FROT(65)
      TTREL(J)=FROT(66)
      TTREL(JJ)=FROT(67)
      T(J)=FROT(68)
      T(JJ)=FROT(69)
      PT(J)=FROT(70)
      PT(JJ)=FROT(71)
      PTREL(J)=FROT(72)
      PTREL(JJ)=FROT(73)
      P(J)=FROT(74)
      P(JJ)=FROT(75)
      KSEC(J)=FROT(76)
      KSPA(J)=FROT(77)
      EPSEB(J)=FROT(78)
      EPSWA(J)=FROT(79)
      EPSRA(J)=FROT(80)
      BAX(J)=FROT(81)
      DZL(J)=FROT(82)
      HZL(J)=FROT(83)
      TZL(J)=FROT(84)
      XL(J)=FROT(85)
      SSP(J)=FROT(86)
      KRAUH(J)=FROT(87)
      LAMWA(J)=FROT(88)
      D(J)=FROT(89)
      OM(J)=FROT(90)
      L(J)=FROT(91)
      RE(J)=FROT(92)
      OPIK(J)=FROT(93)
      OPIKK(J)=FROT(94)
      OPKO(J)=FROT(95)
      OPKOK(J)=FROT(96)
      OWA(J)=FROT(97)
      OWAK(J)=FROT(98)
      OSEC(J)=FROT(99)
      OSECK(J)=FROT(100)
      OSPA(J)=FROT(101)
      OSPAK(J)=FROT(102)
      OSTOS(J)=FROT(103)
      OGES(J)=FROT(104)
      OGESK(J)=FROT(105)
      ZETA(J)=FROT(106)
      KALF(JJ)=FROT(107)

C-********************************************************************
C     Ende der Aenderungen
C-********************************************************************


C----------------------------------------------------------------------
C  AUFRUFEN DES UP STATOR, WENN EIN STATOR FOLGT
C----------------------------------------------------------------------
      ELSE IF(KGIT(J).EQ.2)THEN
           CALL STATOR(FSTAT)

C-********************************************************************
C     Aenderungen von Wolfgang Ganzert, Mai 1993
C-********************************************************************

      KEIN1=FSTAT( 1)
      NRED=FSTAT( 2)
      PI=FSTAT( 3)
      BLG(J)=FSTAT( 4)
      BLN(J)=FSTAT( 5)
      RM(J)=FSTAT( 6)
      RM(JJ)=FSTAT( 7)
      RM(J+2)=FSTAT( 8)
      RG(J)=FSTAT( 9)
      RG(JJ)=FSTAT(10)
      RN(J)=FSTAT(11)
      RN(JJ)=FSTAT(12)
      RMGEO(JJ)=FSTAT(13)
      RGGEO(J)=FSTAT(14)
      RGGEO(JJ)=FSTAT(15)
      RNGEO(J)=FSTAT(16)
      RNGEO(JJ)=FSTAT(17)
      F(JJ)=FSTAT(18)
      FGEO(JJ)=FSTAT(19)
      A(JJ)=FSTAT(20)
      AS(J)=FSTAT(21)
      AS(JJ)=FSTAT(22)
      C(J)=FSTAT(23)
      C(JJ)=FSTAT(24)
      CAX(J)=FSTAT(25)
      CAX(JJ)=FSTAT(26)
      CR(J)=FSTAT(27)
      CR(JJ)=FSTAT(28)
      CU(J)=FSTAT(29)
      CU(JJ)=FSTAT(30)
      U(J)=FSTAT(31)
      U(JJ)=FSTAT(32)
      LAC(J)=FSTAT(33)
      LAC(JJ)=FSTAT(34)
      LACAX(JJ)=FSTAT(35)
      MAC(J)=FSTAT(36)
      MAC(JJ)=FSTAT(37)
      ALF(J)=FSTAT(38)
      ALF(JJ)=FSTAT(39)
      DELALF(J)=FSTAT(40)
      ALFZ(J)=FSTAT(41)
      ALFZ(JJ)=FSTAT(42)
      LAMB(J)=FSTAT(43)
      LAMB(JJ)=FSTAT(44)
      C2Z1(J)=FSTAT(45)
      CAX2Z1(J)=FSTAT(46)
      M=FSTAT(47)
      R=FSTAT(48)
      REA(JJ)=FSTAT(49)
      DELT(JJ)=FSTAT(50)
      CAP(J)=FSTAT(51)
      CP(J)=FSTAT(52)
      CAP(JJ)=FSTAT(53)
      CP(JJ)=FSTAT(54)
      TT(J)=FSTAT(55)
      TT(JJ)=FSTAT(56)
      T(J)=FSTAT(57)
      T(JJ)=FSTAT(58)
      PT(J)=FSTAT(59)
      PT(JJ)=FSTAT(60)
      P(J)=FSTAT(61)
      P(JJ)=FSTAT(62)
      KSEC(J)=FSTAT(63)
      KSPA(J)=FSTAT(64)
      EPSEB(J)=FSTAT(65)
      EPSWA(J)=FSTAT(66)
      EPSRA(J)=FSTAT(67)
      BAX(J)=FSTAT(68)
      DZL(J)=FSTAT(69)
      HZL(J)=FSTAT(70)
      TZL(J)=FSTAT(71)
      XL(J)=FSTAT(72)
      SSP(J)=FSTAT(73)
      KRAUH(J)=FSTAT(74)
      LAMWA(J) =FSTAT(75)
      D(J)=FSTAT(76)
      OM(J)=FSTAT(77)
      L(J)=FSTAT(78)
      RE(J)=FSTAT(79)
      OPIK(J)=FSTAT(80)
      OPIKK(J)=FSTAT(81)
      OPKO(J)=FSTAT(82)
      OPKOK(J)=FSTAT(83)
      OWA(J)=FSTAT(84)
      OWAK(J)=FSTAT(85)
      OSEC(J)=FSTAT(86)
      OSECK(J)=FSTAT(87)
      OSPA(J)=FSTAT(88)
      OSPAK(J)=FSTAT(89)
      OSTOS(J)=FSTAT(90)
      OGES(J)=FSTAT(91)
      OGESK(J)=FSTAT(92)
      ZETA(J)=FSTAT(93)
      KALF(JJ)=FSTAT(94)


C-********************************************************************
C     Ende der Aenderungen
C-********************************************************************

      IF(I2.NE.1) GOTO 190
C-----------------------------------------------------------------------
C  BERECHNUNG DER STUFENWERTE
C-----------------------------------------------------------------------
            PIST(J-1) = PT(J+1)/PT(J-1)
            CAPIS     = (CAP(J-1)-1.)/CAP(J-1)
            TTIS      = TT(J-1)*PIST(J-1)**CAPIS
            CALL KAPPA(TTIS,CPIS,CAPIS)
            ETAST(J-1)= (CPIS*TTIS-CP(J-1)*TT(J-1))/(CP(J+1)*TT(J+1)
     #                  -CP(J-1)*TT(J-1))
            I2 = 0
      END IF
 190     XAX(J+1) = XAX(J)+BAX(J)
 200  CONTINUE
C-----------------------------------------------------------------------
C  BERECHNEN DER GESAMTWERTE UND ANPASSUNG DER TOTAL-
C  TEMPERATUR-ERHOEHUNGEN AN DAS GEFORDERTE GESAMTDRUCK-
C  VERHAELTNIS, WENN KITER=1
C-----------------------------------------------------------------------
      PIGES  = PT(JMAX)/PT(1)
      IF(KITER.NE.1) GOTO 250
      GOTO(210,220,250),I1
 210  IF(PIGES.LT.PIG) DT=1.
      IF(PIGES.GE.PIG) DT=-1.
      PIGES1 = PIGES
      GOTO 230
 220  IF(PIGES.GT.PIGES1) DT =-(PIG-PIGES)/(PIGES1-PIGES)
      IF(PIGES.LE.PIGES1) DT = (PIG-PIGES)/(PIGES1-PIGES)
 230  DO 240 J=1,J1
         IF(KGIT(J).EQ.1) DELT(J) = DELT(J)+DT
 240  CONTINUE
      GOTO 180
C
 250  CAPIS  = (CAP(1)-1.)/CAP(1)
      TTIS   = TT(1)*PIGES**CAPIS
      CALL KAPPA(TTIS,CPIS,CAPIS)
      ETAGES = (CPIS*TTIS-CP(1)*TT(1))/(CP(JMAX)*TT(JMAX)-CP(1)*TT(1))
      HZL(JMAX) = 0.
C
C  UMRECHNEN ALLER WINKEL INS GRADMASS FUER DIE AUSGABE
C
      FPI = 180./PI
      DO 260 J=1,JMAX
         ALF(J)  = ALF(J)*FPI
         LAMB(J) = LAMB(J)*FPI
         IF(KGIT(J).EQ.2) DELALF(J) = DELALF(J)*FPI
         IF(KGIT(J).EQ.1) THEN
            DELBET(J) = DELBET(J)*FPI
            BET(J)    = BET(J)*FPI
            BET(J+1)  = BET(J+1)*FPI
         END IF
 260  CONTINUE
C-----------------------------------------------------------------------
C  BEGINN DER AUSGABE
C-----------------------------------------------------------------------
      J2 = 1
      K  = 0
      IF(KGIT(1).EQ.1) GOTO 270
C
C  AUSGABE DER ERSTEN EBENE, WENN ES EIN VORLEITRAD GIBT,
C  BZW. EINER EBENE ZWISCHEN 2 STATOREN
C
      I3 = 0
      J  = 1
 265  IF(I3.EQ.1) J = J+2
      WRITE(2,23) J,C(J),LAC(J),MAC(J),CAX(J),LACAX(J),CU(J),CR(J),
     #            LAMB(J),ALF(J),DELALF(J),C2Z1(J),CAX2Z1(J),TT(J),
     #            PT(J),T(J),P(J),CAP(J),OM(J),TZL(J),DZL(J),D(J),
     #            ZETA(J),RE(J),L(J)
      WRITE(2,24)
      WRITE(2,25) OPIK(J),OPKO(J),OWA(J),OSEC(J),OSPA(J),
     #            OSTOS(J),OGES(J)
      WRITE(2,26)
      WRITE(2,25) OPIKK(J),OPKOK(J),OWAK(J),OSECK(J),OSPAK(J),
     #            OSTOS(J),OGESK(J)
      J2 = J+1
C
C  STUFENWEISES AUSGEBEN DER BERECHNETEN WERTE
C
 270  I3 = 1
      DO 280 J=J2,J1,2
         K  = K+1
         JJ = J+1
         WRITE(2,28) K,DELH(J),DELT(J),REA(J),ETAST(J),PIST(J),J,JJ,
     #               C(J),W(JJ),LAC(J),LAW(JJ),MAC(J),MAW(JJ),CU(J),
     #               WU(JJ),ALF(J),BET(JJ),TT(J),TTREL(JJ),PT(J),
     #               PTREL(JJ),T(J),T(JJ),P(J),P(JJ)
         WRITE(2,29) U(J),U(JJ),LAU(J),LAU(JJ),DELBET(J),DELALF(JJ),
     #               W2Z1(J),C2Z1(JJ),CAX2Z1(J),CAX2Z1(JJ),TZL(J),
     #               TZL(JJ),DZL(J),DZL(JJ),D(J),D(JJ),ZETA(J),ZETA(JJ)
         WRITE(2,30) CAX(J),CAX(JJ),LACAX(J),LACAX(JJ),W(J),C(JJ),
     #               LAW(J),LAC(JJ),MAW(J),MAC(JJ),WU(J),CU(JJ),CR(J),
     #               CR(JJ),LAMB(J),LAMB(JJ),
     #               BET(J),ALF(JJ),TTREL(J),TT(JJ),PTREL(J),PT(JJ),
     #               OM(J),OM(JJ),CAP(J),CAP(JJ),RE(J),RE(JJ),L(J),
     #               L(JJ)
         WRITE(2,24)
         WRITE(2,31) OPIK(J),OPIK(JJ),OPKO(J),OPKO(JJ),OWA(J)
     #               ,OWA(JJ),OSEC(J),OSEC(JJ),OSPA(J),OSPA(JJ)
     #               ,OSTOS(J),OSTOS(JJ),OGES(J),OGES(JJ)
         WRITE(2,26)
         WRITE(2,31) OPIKK(J),OPIKK(JJ),OPKOK(J),OPKOK(JJ),OWAK(J)
     #               ,OWAK(JJ),OSECK(J),OSECK(JJ),OSPAK(J),OSPAK(JJ)
     #               ,OSTOS(J),OSTOS(JJ),OGESK(J),OGESK(JJ)
         IF(KALF(J+2).EQ.1.AND.(J+2).NE.JMAX) GOTO 265
 280  CONTINUE
C
C  AUSGABE DER LETZTEN EBENE
C
      WRITE(2,33) JMAX,CAX(JMAX),LACAX(JMAX),CU(JMAX),C(JMAX),LAC(JMAX),
     #            MAC(JMAX),CR(JMAX),LAMB(JMAX),ALF(JMAX),TT(JMAX),
     #            T(JMAX),PT(JMAX),P(JMAX)
      WRITE(2,34)
C
C  AUSGABE DER RINGRAUM-ABMESSUNGEN UND DER GESAMTWERTE
C
      DO 290 J=1,JMAX
         WRITE(2,35) J,XAX(J),RN(J),RM(J),RG(J),F(J),BLN(J),BLG(J)
 290  CONTINUE
      WRITE(2,36)
      DO 300 J=1,JMAX
         WRITE(2,37) J,XAX(J),RNGEO(J),RMGEO(J),RGGEO(J),FGEO(J),HZL(J)
 300  CONTINUE
      WRITE(2,38) ETAGES,PIGES
C-----------------------------------------------------------------------
C  ENDE DER AUSGABE
C-----------------------------------------------------------------------
C  ABSCHAETZEN DER GITTERBELASTUNG IN 5 RADIALEN SCHNITTEN
C  FUER JE 5 TOTAL-TEMPERATUR UND DRALL-VERTEILUNGEN DURCH
C  UP DRALL, WENN KDRALL=1
C-----------------------------------------------------------------------
      IF(KDRALL.EQ.1) THEN
         CALL DRALL(RM,RN,RG,F,TT,PT,R,PI,CU,KGIT,CAX,U,JMAX,CAP,
     #              DZL,TZL,T,P,BAX,M1,M2,KABBL,KRAD,KAUS)
      END IF
      IF(KD.LT.KDAT) GOTO 100
C
C  EINGABEFORMATE
C
   1  FORMAT (I3)
   2  FORMAT (A80)
   3  FORMAT (8I3)
   4  FORMAT (F10.5,F10.3,4F10.5,F10.3)
   5  FORMAT (4F10.5)
   6  FORMAT (F10.5)
   7  FORMAT (2I3)
   8  FORMAT (2F10.5)
   9  FORMAT (6F10.5)
  10  FORMAT (8F10.5)
C
C  AUSGABEFORMATE
C
  21  FORMAT('1',4X,'MITTELSCHNITTS-AUSLEGUNG FUER AXIALVERDICHTER',//)
  23  FORMAT('1',5(/),5X,I2,'. EBENE',//,
     #        /,5X,'C           ',E10.5E1,'  M/S',
     #        /,5X,'LAC         ',E10.5E1,/,5X,'MAC         ',E10.5E1,
     #        /,5X,'CAX         ',E10.5E1,'  M/S',
     #        /,5X,'LACAX       ',E10.5E1,
     #        /,5X,'CU          ',E10.5E1,'  M/S',
     #        /,5X,'CR          ',E10.5E1,'  M/S',
     #        /,5X,'LAMBDA      ',E10.5E1,
     #        /,5X,'ALPHA       ',E10.5E1,'  GRAD',
     #        /,5X,'DELTA ALPHA ',E10.5E1,'  GRAD',
     #        /,5X,'C2/C1       ',E10.5E1,/,5X,'CAX2/CAX1   ',E10.5E1,
     #        /,5X,'TT          ',E10.5E1,'  K',
     #        /,5X,'PT          ',E10.5E1,'  N/M**2',
     #        /,5X,'T           ',E10.5E1,'  K',
     #        /,5X,'P           ',E10.5E1,'  N/M**2',
     #        /,5X,'KAPPA       ',E10.5E1,/,5X,'OMEGA       ',E10.5E1,
     #        /,5X,'T/L         ',E10.5E1,/,5X,'D/L         ',E10.5E1,
     #        /,5X,'D           ',E10.5E1,/,5X,'ZETA        ',E10.5E1,
     #        /,5X,'RE',10X,E10.5E1,/,5X,'L',11X,E10.5E1,'  M',/)
  24  FORMAT (5X,'UNKORRIGIERTE VERLUSTE')
  25  FORMAT (/,5X,'OMPROFINK   ',E10.5E1,/,5X,'OMPROFKOMP  ',E10.5E1,
     #        /,5X,'OMWAND      ',E10.5E1,/,5X,'OMSEK       ',E10.5E1,
     #        /,5X,'OMSPA       ',E10.5E1,/,5X,'OMSTOS      ',E10.5E1,
     #        /,5X,'OMGES       ',E10.5E1)
  26  FORMAT (/,5X,'KORRIGIERTE VERLUSTE')
  28  FORMAT ('1',4X,I2,'. STUFE',//,
     #        5X,'DELTA H    ',E10.5E1,'  KJ/KG',/,
     #        5X,'DELTA TT   ',E10.5E1,'  K',/,
     #        5X,'REAKT-GRAD ',E10.5E1,/,
     #        5X,'ETAST      ',E10.5E1,/,
     #        5X,'PIST       ',E10.5E1,//,
     #        5X,I2,'. EBENE',24X,I2,'. EBENE',//,
     #        5X,'(LE AUS)',25X,'(LA AUS)',/,
     #        5X,'C',10X,E10.5E1,'  M/S',7X,'W',10X,E10.5E1,'  M/S',/,
     #        5X,'LAC',8X,E10.5E1,12X,'LAW',8X,E10.5E1,/,
     #        5X,'MAC',8X,E10.5E1,12X,'MAW',8X,E10.5E1,/,
     #        5X,'CU',9X,E10.5E1,'  M/S',7X,'WU',9X,E10.5E1,'  M/S',/,
     #        5X,'ALPHA',6X,E10.5E1,'  GRAD',
     #        6X,'BETA',7X,E10.5E1,'  GRAD',/,
     #        5X,'TT',9X,E10.5E1,'  K',9X,'TTREL',6X,E10.5E1,'  K',/,
     #        5X,'PT',9X,E10.5E1,'  N/M**2',
     #        4X,'PTREL',6X,E10.5E1,'  N/M**2',/,
     #        5X,'T',10X,E10.5E1,'  K',9X,'T',10X,E10.5E1,'  K',/,
     #        5X,'P',10X,E10.5E1,'  N/M**2',
     #        4X,'P',10X,E10.5E1,'  N/M**2')
  29  FORMAT (//,5X,'(LA EIN)',25X,'(LE EIN)',/,
     #        5X,'U',10X,E10.5E1,'  M/S',7X,'U',10X,E10.5E1,'  M/S',/,
     #        5X,'LAU',8X,E10.5E1,12X,'LAU',8X,E10.5E1,/,
     #        5X,'DELTA BETA ',E10.5E1,'  GRAD',
     #        6X,'DELTA ALPHA ',E10.5E1,'  GRAD',/,
     #        5X,'W2/W1',6X,E10.5E1,12X,'C2/C1',6X,E10.5E1,/,
     #        5X,'CAX2/CAX1  ',E10.5E1,12X,'CAX2/CAX1  ',E10.5E1,/,
     #        5X,'T/L',8X,E10.5E1,12X,'T/L',8X,E10.5E1,/,
     #        5X,'D/L',8X,E10.5E1,12X,'D/L',8X,E10.5E1,/,
     #        5X,'D',10X,E10.5E1,12X,'D',10X,E10.5E1,/,
     #        5X,'ZETA',7X,E10.5E1,12X,'ZETA',7X,E10.5E1)
  30  FORMAT (5X,'CAX',8X,E10.5E1,'  M/S',7X,'CAX',8X,E10.5E1,' M/S',/,
     #        5X,'LACAX',6X,E10.5E1,12X,'LACAX',6X,E10.5E1,/,
     #        5X,'W',10X,E10.5E1,'  M/S',7X,'C',10X,E10.5E1,'  M/S',/,
     #        5X,'LAW',8X,E10.5E1,12X,'LAC',8X,E10.5E1,/,
     #        5X,'MAW',8X,E10.5E1,12X,'MAC',8X,E10.5E1,/,
     #        5X,'WU',9X,E10.5E1,'  M/S',7X,'CU',9X,E10.5E1,'  M/S',/,
     #        5X,'CR',9X,E10.5E1,'  M/S',7X,'CR',9X,E10.5E1,'  M/S',/,
     #        5X,'LAMBDA',5X,E10.5E1,'  GRAD',
     #        6X,'LAMBDA',5X,E10.5E1,'  GRAD',/,
     #        5X,'BETA',7X,E10.5E1,'  GRAD',
     #        6X,'ALPHA',6X,E10.5E1,'  GRAD',/,
     #        5X,'TTREL',6X,E10.5E1,'  K',9X,'TT',9X,E10.5E1,'  K',/,
     #        5X,'PTREL',6X,E10.5E1,'  N/M**2',
     #        4X,'PT',9X,E10.5E1,'  N/M**2',/,
     #        5X,'OMEGA',6X,E10.5E1,12X,'OMEGA',6X,E10.5E1,/,
     #        5X,'KAPPA',6X,E10.5E1,12X,'KAPPA',6X,E10.5E1,/,
     #        5X,'RE',9X,E10.5E1,12X,'RE',9X,E10.5E1,/,
     #        5X,'L',10X,E10.5E1,'  M',9X,'L',10X,E10.5E1,'  M',/)
  31  FORMAT (/,5X,'OMPROFINK  ',E10.5E1,12X,'OMPROFINK  ',E10.5E1,/,
     #        5X,'OMPROFKOMP ',E10.5E1,12X,'OMPROFKOMP ',E10.5E1,/,
     #        5X,'OMWAND     ',E10.5E1,12X,'OMWAND     ',E10.5E1,/,
     #        5X,'OMSEC      ',E10.5E1,12X,'OMSEC      ',E10.5E1,/,
     #        5X,'OMSPA      ',E10.5E1,12X,'OMSPA      ',E10.5E1,/,
     #        5X,'OMSTOS     ',E10.5E1,12X,'OMSTOS     ',E10.5E1,/,
     #        5X,'OMGES      ',E10.5E1,12X,'OMGES      ',E10.5E1)
  33  FORMAT('1',///,5X,I2,'. EBENE',///,
     #       5X,'CAX         ',E10.5E1,'  M/S',/
     #       5X,'LACAX       ',E10.5E1,/,
     #       5X,'CU          ',E10.5E1,'  M/S',/,
     #       5X,'C           ',E10.5E1,'  M/S',/,
     #       5X,'LAC         ',E10.5E1,/,
     #       5X,'MAC         ',E10.5E1,/,
     #       5X,'CR          ',E10.5E1,'  M/S',/,
     #       5X,'LAMBDA      ',E10.5E1,'  GRAD',/,
     #       5X,'ALPHA       ',E10.5E1,'  GRAD',/,
     #       5X,'TT          ',E10.5E1,'  K',/,
     #       5X,'T           ',E10.5E1,'  K',/,
     #       5X,'PT          ',E10.5E1,'  N/M**2',/,
     #       5X,'P           ',E10.5E1,'  N/M**2')
  34  FORMAT (4(/),5X,'RINGRAUM EFFEKTIV',//,
     #       5X,'EBENE   AX.LAGE    R-NABE    R-MITTE   R-GEH.    ',
     #       'FLAECHE   BL-NABE   BL-GEH.',/)
  35  FORMAT (6X,I2,2X,7F10.5)
  36  FORMAT (4(/),5X,'RINGRAUM GEOMETRISCH',//,5X,'EBENE  ',
     #        ' AX.LAGE    R-NABE    R-MITTE   R-GEH.    FLAECHE',
     #        '    H/L',/)
  37  FORMAT (6X,I2,2X,6F10.5)
  38  FORMAT (///,5X,'GESAMTWERTE :',//,
     #        5X,'ETAGES',5X,F10.5,/,5X,'PIGES',6X,F10.5)
  39  FORMAT (//,5X,'EINGABEWERTE',//)
  40  FORMAT (5X,'STEUERZAHLEN :',//,
     #        5X,'EBENENZAHL    ',I5,/,5X,'STUFENZAHL    ',I5,/,
     #        5X,'KEIN1         ',I5,/,5X,'KITER         ',I5,/,
     #        5X,'KABBL         ',I5,/,5X,'KRAD          ',I5,/,
     #        5X,'KDRALL        ',I5,/,5X,'KAUS          ',I5)
  41  FORMAT (//,5X,'GESAMTVERDICHTER :',//,
     #           5X,'TT,EIN        ',F10.5,'  K',/,
     #           5X,'PT,EIN      ',F12.5,'  N/M**2',/,
     #           5X,'ALFZ,EIN      ',F10.5,'  GRAD',/,
     #           5X,'ALFZ,AUS      ',F10.5,'  GRAD',/,
     #           5X,'MASSENSTR.1   ',F10.5,'  KG/S',/,
     #           5X,'MASSENSTR.2   ',F10.5,'  KG/S',/,
     #           5X,'DREHZAHL    ',F12.5,'  1/MIN',/,
     #           5X,'BLN,EIN       ',F10.5,/,
     #           5X,'BLN,AUS       ',F10.5,/,
     #           5X,'BLG,EIN       ',F10.5,/,
     #           5X,'BLG,AUS       ',F10.5)
  42  FORMAT (5X,'PIG,SOLL      ',F10.5)
  43  FORMAT (//,5X,'EBENEN- UND GITTER-WERTE :')
  44  FORMAT (/,5X,I2,'. EBENE :',/)
  45  FORMAT (5X,'KGIT         ',I5,/,5X,'KEIN2        ',I5)
  46  FORMAT (5X,'CAX           ',F10.5,'  M/S',/,
     #        5X,'RM            ',F10.5,'  M')
  47  FORMAT (5X,'RNGEO         ',F10.5,'  M',/,
     #        5X,'RGGEO         ',F10.5,'  M')
  48  FORMAT (5X,'D/L           ',F10.5,/,
     #        5X,'T/L           ',F10.5,/,
     #        5X,'BAX           ',F10.5,'  M',/,
     #        5X,'SSP           ',F10.5,'  MM',/,
     #        5X,'REAKT.-GRAD   ',F10.5,/,
     #        5X,'DELTA-TT      ',F10.5,'  K')
  49  FORMAT (5X,'D/L           ',F10.5,/,
     #        5X,'T/L           ',F10.5,/,
     #        5X,'BAX           ',F10.5,'  M',/,
     #        5X,'SSP           ',F10.5,'  MM')
  50  FORMAT (5X,'XL            ',F10.5,/,
     #        5X,'KSEC          ',F10.5,/,
     #        5X,'KSPA          ',F10.5,/,
     #        5X,'EPSEB         ',F10.5,/,
     #        5X,'EPSRA         ',F10.5,/,
     #        5X,'EPSWA         ',F10.5,/,
     #        5X,'KRAUH         ',F10.5,'  MUE-M',/,
     #        5X,'LAMWA         ',F10.5)
  51  FORMAT (5X,'ALFZ          ',F10.5,'  GRAD')
      END


      SUBROUTINE ROTOR(FROT)

C
C**********************************************************************
C
C  AUFGABEN DES UNTERPROGRAMMS  R O T O R :
C     - BERECHNEN DER RELATIVEN ROTOR-EINTRITTSGROESSEN
C     - BERECHNEN DER ABSOLUTEN UND RELATIVEN ROTOR-AUSTRITTS-
C          GROESSEN
C     - ITERATION DER ROTOR-GITTER-VERLUSTE
C
C  VERWENDETE UNTERPROGRAMME :
C     CAXIT, FKAPPA, GEO, KAPPA, VLUSTE, WREL
C
C  AUFRUFENDES PROGRAMM :
C     MITTEL
C
C**********************************************************************
C
      INTEGER J,KALF,KEIN1
      REAL    A1,A2,ALF2,ALFZ2,AS1,AS2,BAX,BET1,BET2,BETZ1,BETZ2,BLG2,
     #        BLN2,C2,CAX1,CAX2,CAX2Z1,CAP1,CAP2,CAPIS1,CAPIS2,CAPM1,
     #        CAPM2,CAPP1,CAPP2,CAPREL,CAPSTA,CP1,CP2,CPREL,CPSTA,
     #        CR1,CR2,CU1,CU2,CZ2,D,DELBET,DELH,DELT,DZL,EPSEB,EPSRA,
     #        EPSWA,FGEO2,F2,HZL,KRAUH,KSEC,KSPA,L,LAC2,LACAX2,LAMB1,
     #        LAMB2,LAMWA,LAU1,LAU2,LAW1,LAW2,M,MAC2,MAW1,MAW2,NRED,
     #        OGES,OGESK,OM,OPIK,OPIKK,OPKO,OPKOK,OSEC,OSECK,OSPA,
     #        OSPAK,OSTOS,OWA,OWAK,P1,P2,PI,PIVERL,PT1,PT2,PTREL1,
     #        PTREL2,R,RE,REA,RG1,RG2,RGGEO1,RGGEO2,RM1,RM2,RMGEO2,RN1,
     #        RN2,RNGEO1,RNGEO2,SSP,T1,T2,TT1,TT2,TTREL1,TTREL2,TZL,
     #        U1,U2,W1,W2,W2Z1,WU1,WU2,XL,ZETA,ZETA1

      REAL FROT(107)

            J=FROT(1)
            KEIN1=FROT(2)
            NRED=FROT(3)
            PI=FROT(4)
            BLG2=FROT(5)
            BLN2=FROT(6)
            RM1=FROT(7)
            RM2=FROT(8)
            RG1=FROT(9)
            RG2=FROT(10)
            RN1=FROT(11)
            RN2=FROT(12)
            RMGEO2=FROT(13)
            RGGEO1=FROT(14)
            RGGEO2=FROT(15)
            RNGEO1=FROT(16)
            RNGEO2=FROT(17)
            F2=FROT(18)
            FGEO2=FROT(19)
            A1=FROT(20)
            A2=FROT(21)
            AS1=FROT(22)
            AS2=FROT(23)
            C2=FROT(24)
            CAX1=FROT(25)
            CAX2=FROT(26)
            CR1=FROT(27)
            CR2=FROT(28)
            CU1=FROT(29)
            CU2=FROT(30)
            LAC2=FROT(31)
            LACAX2=FROT(32)
            MAC2=FROT(33)
            U1=FROT(34)
            U2=FROT(35)
            LAU1=FROT(36)
            LAU2=FROT(37)
            W1=FROT(38)
            W2=FROT(39)
            WU1=FROT(40)
            WU2=FROT(41)
            LAW1=FROT(42)
            LAW2=FROT(43)
            MAW1=FROT(44)
            MAW2=FROT(45)
            W2Z1=FROT(46)
            CAX2Z1=FROT(47)
            ALF2=FROT(48)
            ALFZ2=FROT(49)      
            BET1=FROT(50)
            BET2=FROT(51)
            DELBET=FROT(52)
            LAMB1=FROT(53)
            LAMB2=FROT(54)
            M=FROT(55)
            R=FROT(56)
            REA=FROT(57)
            DELH=FROT(58)
            DELT=FROT(59)
            CAP1=FROT(60)
            CP1=FROT(61)
            CAP2=FROT(62)
            CP2=FROT(63)
            TT1=FROT(64)  
            TT2=FROT(65)
            TTREL1=FROT(66)
            TTREL2=FROT(67)
            T1=FROT(68)
            T2=FROT(69)
            PT1=FROT(70)
            PT2=FROT(71)      
            PTREL1=FROT(72)
            PTREL2=FROT(73)
            P1=FROT(74)
            P2=FROT(75)
            KSEC=FROT(76)
            KSPA=FROT(77)        
            EPSEB=FROT(78)
            EPSWA=FROT(79)
            EPSRA=FROT(80)
            BAX=FROT(81)
            DZL=FROT(82)
            HZL=FROT(83)      
            TZL=FROT(84)
            XL=FROT(85)
            SSP=FROT(86)
            KRAUH=FROT(87)
            LAMWA=FROT(88)
            D=FROT(89)
            OM=FROT(90)
            L=FROT(91)
            RE=FROT(92)
            OPIK=FROT(93)
            OPIKK=FROT(94)
            OPKO=FROT(95)              
            OPKOK=FROT(96)
            OWA=FROT(97)
            OWAK=FROT(98)
            OSEC=FROT(99)
            OSECK=FROT(100)
            OSPA=FROT(101)
            OSPAK=FROT(102)
            OSTOS=FROT(103)
            OGES=FROT(104)
            OGESK=FROT(105)
            ZETA=FROT(106)
            KALF=FROT(107)   
C
C
C----------------------------------------------------------------------
C  BERECHNUNG DER RELATIVEN EINTRITTSGROESSEN
C----------------------------------------------------------------------
      CALL FKAPPA(CAP1,CAPP1,CAPM1,CAPIS1)
      U1     = NRED*RM1
      LAU1   = U1/AS1
      TTREL1 = TT1+U1*(U1-2.*CU1)/(2.*CP1)
      PTREL1 = PT1*(TTREL1/TT1)**CAPIS1
      CALL KAPPA(TTREL1,CPREL,CAPREL)
      CALL WREL(U1,CU1,CAX1,CR1,TTREL1,PI,R,CAPREL,WU1,W1,LAW1,BET1,
     #     BETZ1)
      MAW1   = W1/A1
C----------------------------------------------------------------------
C  BERECHNUNG DER AUSTRITTSEBENE
C----------------------------------------------------------------------
      TT2    = TT1+DELT
      CALL KAPPA(TT2,CP2,CAP2)
      CALL FKAPPA(CAP2,CAPP2,CAPM2,CAPIS2)
      AS2    = SQRT(2.*CAP2*R*TT2/CAPP2)
      U2     = NRED*RM2
      LAU2   = U2/AS2
      DELH   = CP1*DELT
      IF(J.EQ.1) REA = 1.-(CU1+DELH/(U1+U2))/U2
      CU2    = U1*(1.-REA)+DELH/(U1+U2)
      TTREL2 = TTREL1+(U2**2-U1**2)/(2.*CPREL)
      CALL KAPPA(TTREL2,CPREL,CAPREL)
C----------------------------------------------------------------------
C  BEGINN DER VERLUSTITERATION
C----------------------------------------------------------------------
      PIVERL = 0.99
      ZETA1  = 0.01
      IF(KEIN1.EQ.2)GOTO20
C----------------------------------------------------------------------
C  WENN CAX GEGEBEN IST:
C----------------------------------------------------------------------
      CR2    = CAX2*TAN(LAMB2)
      CZ2    = SQRT(CU2**2+CAX2**2)
      C2     = SQRT(CZ2**2+CR2**2)
      LAC2   = C2/AS2
      LACAX2 = CAX2/AS2
      ALFZ2  = ACOS(CU2/CZ2)
      ALF2   = ACOS(CU2/C2)
      CALL WREL(U2,CU2,CAX2,CR2,TTREL2,PI,R,CAPREL,WU2,W2,LAW2,BET2,
     #     BETZ2)
  10  PT2    = PIVERL*PT1*(TT2/TT1)**CAPIS1
      CALL GEO(LACAX2,LAC2,BLG2,BLN2,F2,FGEO2,RG2,RGGEO2,RM2,RMGEO2,
     #     RN2,RNGEO2,PI,R,M,CAP2,CAPP2,CAPM2,TT2,PT2)
      GOTO 30
C----------------------------------------------------------------------
C  WENN CAX NICHT GEGEBEN IST:
C----------------------------------------------------------------------
  20  PT2    = PIVERL*PT1*(TT2/TT1)**CAPIS1
      CALL CAXIT(KALF,TT2,PT2,M,F2,PI,R,CAP2,CAPP2,CAPM2,AS2,
     #     ALF2,ALFZ2,LAMB2,CU2,CAX2,CR2,C2,LACAX2,LAC2)
      CALL WREL(U2,CU2,CAX2,CR2,TTREL2,PI,R,CAPREL,WU2,W2,LAW2,BET2,
     #     BETZ2)
  30  T2     = TT2-C2**2/(2.*CP2)
      P2     = PT2*(T2/TT2)**CAPIS2
      CALL VLUSTE(1,PI,RM1,RG1,RN1,RGGEO1,RGGEO2,RNGEO1,RNGEO2,W1,
     #     W2,CAX1,CAX2,CR1,CR2,CU1,LAW1,MAW1,U1,BET1,BET2,BETZ1,BETZ2,
     #     LAMB1,R,CAP1,TTREL1,TTREL2,T1,T2,P1,P2,KSEC,KSPA,EPSEB,
     #     EPSRA,EPSWA,BAX,DZL,HZL,TZL,XL,SSP,KRAUH,LAMWA,D,
     #     OM,L,RE,OPIK,OPIKK,OPKO,OPKOK,OWA,OWAK,OSEC,OSECK,OSPA,
     #     OSPAK,OSTOS,OGES,OGESK,ZETA,PIVERL)
      IF(ABS(ZETA1-ZETA).LT.0.001) GOTO 40
      ZETA1  = ZETA
      GOTO (10,20),KEIN1
  40  CONTINUE
C----------------------------------------------------------------------
C  ENDE DER VERLUSTITERATION
C  BERECHNEN WEITERER AUSGABE-DATEN
C----------------------------------------------------------------------
      PTREL2 = PT2*(TTREL2/TT2)**CAPIS2
      CALL KAPPA(T2,CPSTA,CAPSTA)
      A2     = SQRT(CAPSTA*R*T2)
      MAC2   = C2/A2
      MAW2   = W2/A2
      DELBET = BET1-BET2
      W2Z1   = W2/W1
      CAX2Z1 = CAX2/CAX1

          FROT(  1)=J
          FROT(  2)=KEIN1
          FROT(  3)=NRED
          FROT(  4)=PI
          FROT(  5)=BLG2
          FROT(  6)=BLN2
          FROT(  7)=RM1
          FROT(  8)=RM2
          FROT(  9)=RG1
          FROT( 10)=RG2
          FROT( 11)=RN1
          FROT( 12)=RN2
          FROT( 13)=RMGEO2
          FROT( 14)=RGGEO1
          FROT( 15)=RGGEO2
          FROT( 16)=RNGEO1
          FROT( 17)=RNGEO2
          FROT( 18)=F2
          FROT( 19)=FGEO2
          FROT( 20)=A1
          FROT( 21)=A2
          FROT( 22)=AS1
          FROT( 23)=AS2
          FROT( 24)=C2
          FROT( 25)=CAX1
          FROT( 26)=CAX2
          FROT( 27)=CR1
          FROT( 28)=CR2
          FROT( 29)=CU1
          FROT( 30)=CU2
          FROT( 31)=LAC2
          FROT( 32)=LACAX2
          FROT( 33)=MAC2
          FROT( 34)=U1
          FROT( 35)=U2
          FROT( 36)=LAU1
          FROT( 37)=LAU2
          FROT( 38)=W1
          FROT( 39)=W2
          FROT( 40)=WU1
          FROT( 41)=WU2
          FROT( 42)=LAW1
          FROT( 43)=LAW2
          FROT( 44)=MAW1
          FROT( 45)=MAW2
          FROT( 46)=W2Z1
          FROT( 47)=CAX2Z1
          FROT( 48)=ALF2
          FROT( 49)=ALFZ2
          FROT( 50)=BET1
          FROT( 51)=BET2
          FROT( 52)=DELBET
          FROT( 53)=LAMB1
          FROT( 54)=LAMB2
          FROT( 55)=M
          FROT( 56)=R
          FROT( 57)=REA
          FROT( 58)=DELH
          FROT( 59)=DELT
          FROT( 60)=CAP1
          FROT( 61)=CP1
          FROT( 62)=CAP2
          FROT( 63)=CP2
          FROT( 64)=TT1
          FROT( 65)=TT2
          FROT( 66)=TTREL1
          FROT( 67)=TTREL2
          FROT( 68)=T1
          FROT( 69)=T2
          FROT( 70)=PT1
          FROT( 71)=PT2
          FROT( 72)=PTREL1
          FROT( 73)=PTREL2
          FROT( 74)=P1
          FROT( 75)=P2
          FROT( 76)=KSEC
          FROT( 77)=KSPA
          FROT( 78)=EPSEB
          FROT( 79)=EPSWA
          FROT( 80)=EPSRA
          FROT( 81)=BAX
          FROT( 82)=DZL
          FROT( 83)=HZL
          FROT( 84)=TZL
          FROT( 85)=XL
          FROT( 86)=SSP
          FROT( 87)=KRAUH
          FROT( 88)=LAMWA
          FROT( 89)=D
          FROT( 90)=OM
          FROT( 91)=L
          FROT( 92)=RE
          FROT( 93)=OPIK
          FROT( 94)=OPIKK
          FROT( 95)=OPKO
          FROT( 96)=OPKOK
          FROT( 97)=OWA
          FROT( 98)=OWAK
          FROT( 99)=OSEC
          FROT(100)=OSECK
          FROT(101)=OSPA
          FROT(102)=OSPAK
          FROT(103)=OSTOS
          FROT(104)=OGES
          FROT(105)=OGESK
          FROT(106)=ZETA
          FROT(107)=KALF



      END


      SUBROUTINE STATOR(FSTAT)


C
C***********************************************************************
C
C  AUFGABEN DES UNTERPROGRAMMS  S T A T O R :
C     - BERECHNEN DER ABSOLUTEN STATOR-AUSTRITTS-GROESSEN
C     - ITERATION DER STATOR-GITTER-VERLUSTE
C
C  VERWENDETE UNTERPROGRAMME :
C     CAXIT, FKAPPA, GEO, KAPPA, VLUSTE
C
C  AUFRUFENDES PROGRAMM :
C     MITTEL
C
C***********************************************************************
C
      INTEGER KALF,KEIN1
      REAL    A2,ALF1,ALF2,ALFZ1,ALFZ2,AS1,AS2,BAX,BLG2,BLN2,C1,C2,
     #        C2Z1,CAP1,CAP2,CAPIS,CAPM,CAPP,CAPSTA,CAX1,CAX2,CAX2Z1,
     #        CP1,CP2,CPSTA,CR1,CR2,CU1,CU2,CZ2,D,DELALF,DELH,DELT,
     #        DZL,EPSEB,EPSRA,EPSWA,F2,FGEO2,HZL,KRAUH,KSEC,KSPA,L,
     #        LAC1,LAC2,LACAX2,LAMB1,LAMB2,LAMWA,M,MAC1,MAC2,NRED,OGES,
     #        OGESK,OM,OPIK,OPIKK,OPKO,OPKOK,OSEC,OSECK,OSPA,OSPAK,
     #        OSTOS,OWA,OWAK,P1,P2,PI,PIVERL,PT1,PT2,R,RE,REA,RG1,RG2,
     #        RGGEO1,RGGEO2,RM1,RM2,RM3,RMGEO2,RN1,RN2,RNGEO1,RNGEO2,
     #        SSP,T1,T2,TT1,TT2,TZL,U1,U2,U3,XL,ZETA,ZETA1

      REAL FSTAT(94)
C----------------------------------------------------------------------

      KEIN1=FSTAT( 1)
      NRED=FSTAT( 2)
      PI=FSTAT( 3)
      BLG2=FSTAT( 4)
      BLN2=FSTAT( 5)
      RM1=FSTAT( 6)
      RM2=FSTAT( 7)
      RM3=FSTAT( 8)
      RG1=FSTAT( 9)
      RG2=FSTAT(10)
      RN1=FSTAT(11)
      RN2=FSTAT(12)
      RMGEO2=FSTAT(13)
      RGGEO1=FSTAT(14)
      RGGEO2=FSTAT(15)
      RNGEO1=FSTAT(16)
      RNGEO2=FSTAT(17)
      F2=FSTAT(18)
      FGEO2=FSTAT(19)
      A2=FSTAT(20)
      AS1=FSTAT(21)
      AS2=FSTAT(22)
      C1=FSTAT(23)
      C2=FSTAT(24)
      CAX1=FSTAT(25)
      CAX2=FSTAT(26)
      CR1=FSTAT(27)
      CR2=FSTAT(28)
      CU1=FSTAT(29)
      CU2=FSTAT(30)
      U1=FSTAT(31)
      U2=FSTAT(32)
      LAC1=FSTAT(33)
      LAC2=FSTAT(34)
      LACAX2=FSTAT(35)
      MAC1=FSTAT(36)
      MAC2=FSTAT(37)
      ALF1=FSTAT(38)
      ALF2=FSTAT(39)
      DELALF=FSTAT(40)
      ALFZ1=FSTAT(41)
      ALFZ2=FSTAT(42)
      LAMB1=FSTAT(43)
      LAMB2=FSTAT(44)
      C2Z1=FSTAT(45)
      CAX2Z1=FSTAT(46)
      M=FSTAT(47)
      R =FSTAT(48)
      REA=FSTAT(49)
      DELT=FSTAT(50)            
      CAP1=FSTAT(51)
      CP1=FSTAT(52)
      CAP2=FSTAT(53)
      CP2=FSTAT(54)
      TT1=FSTAT(55)
      TT2=FSTAT(56)
      T1=FSTAT(57)
      T2=FSTAT(58)
      PT1=FSTAT(59)
      PT2=FSTAT(60)
      P1=FSTAT(61)
      P2=FSTAT(62)
      KSEC=FSTAT(63)    
      KSPA=FSTAT(64)
      EPSEB=FSTAT(65)
      EPSWA=FSTAT(66)
      EPSRA=FSTAT(67)
      BAX=FSTAT(68)
      DZL=FSTAT(69)
      HZL=FSTAT(70)
      TZL=FSTAT(71)
      XL=FSTAT(72)
      SSP=FSTAT(73)         
      KRAUH=FSTAT(74)
      LAMWA=FSTAT(75)
      D=FSTAT(76)
      OM=FSTAT(77)
      L=FSTAT(78)
      RE=FSTAT(79)
      OPIK=FSTAT(80)
      OPIKK=FSTAT(81)
      OPKO=FSTAT(82)
      OPKOK=FSTAT(83)
      OWA=FSTAT(84)               
      OWAK=FSTAT(85)
      OSEC=FSTAT(86)
      OSECK=FSTAT(87)
      OSPA=FSTAT(88)
      OSPAK=FSTAT(89)
      OSTOS=FSTAT(90)
      OGES=FSTAT(91)
      OGESK=FSTAT(92)
      ZETA=FSTAT(93)    
      KALF=FSTAT(94)

C
C----------------------------------------------------------------------
C  BERECHNUNG DER AUSTRITTSEBENE
C----------------------------------------------------------------------
      TT2    = TT1
      AS2    = AS1
      CAP2   = CAP1
      CP2    = CP1
      CALL FKAPPA(CAP2,CAPP,CAPM,CAPIS)
      U2     = NRED*RM2
      IF(KALF.NE.1)THEN
         U3     = NRED*RM3
         DELH   = CP2*DELT
         CU2    = U3*(1.-REA)-DELH/(U2+U3)
      END IF
C----------------------------------------------------------------------
C  BEGINN DER VERLUSTITERATION
C----------------------------------------------------------------------
      PIVERL = 0.99
      ZETA1  = 0.01
      IF(KEIN1.EQ.2) GOTO 20
C----------------------------------------------------------------------
C  WENN CAX2 GEGEBEN IST:
C----------------------------------------------------------------------
      IF(KALF.EQ.1)THEN
         IF(ABS(ABS(ALFZ2)-PI/2.).LE.0.0001) THEN
            CU2 = 0.
         ELSE
            CU2 = CAX2/TAN(ALFZ2)
         END IF
      END IF
      CR2    = CAX2*TAN(LAMB2)
      CZ2    = SQRT(CU2**2+CAX2**2)
      C2     = SQRT(CZ2**2+CR2**2)
      LAC2   = C2/AS2
      LACAX2 = CAX2/AS2
      IF(KALF.NE.1) ALFZ2 = ACOS(CU2/CZ2)
      ALF2   = ACOS(CU2/C2)
  10  PT2    = PIVERL*PT1
      CALL GEO(LACAX2,LAC2,BLG2,BLN2,F2,FGEO2,RG2,RGGEO2,RM2,RMGEO2,
     #     RN2,RNGEO2,PI,R,M,CAP2,CAPP,CAPM,TT2,PT2)
      GOTO 30
C----------------------------------------------------------------------
C  WENN CAX2 NICHT GEGEBEN IST:
C----------------------------------------------------------------------
  20  PT2    = PIVERL*PT1
      CALL CAXIT(KALF,TT2,PT2,M,F2,PI,R,CAP2,CAPP,CAPM,AS2,
     #     ALF2,ALFZ2,LAMB2,CU2,CAX2,CR2,C2,LACAX2,LAC2)
  30  T2     = TT2-C2**2/(2.*CP2)
      P2     = PT2*(T2/TT2)**CAPIS
      CALL VLUSTE(2,PI,RM1,RG1,RN1,RGGEO1,RGGEO2,RNGEO1,RNGEO2,
     #     C1,C2,CAX1,CAX2,CR1,CR2,CU1,LAC1,MAC1,U1,ALF1,ALF2,ALFZ1,
     #     ALFZ2,LAMB1,R,CAP1,TT1,TT2,T1,T2,P1,P2,KSEC,KSPA,EPSEB,
     #     EPSRA,EPSWA,BAX,DZL,HZL,TZL,XL,SSP,KRAUH,LAMWA,D,
     #     OM,L,RE,OPIK,OPIKK,OPKO,OPKOK,OWA,OWAK,OSEC,OSECK,OSPA,
     #     OSPAK,OSTOS,OGES,OGESK,ZETA,PIVERL)
      IF(ABS(ZETA1-ZETA).LT.0.001) GOTO 40
      ZETA1  = ZETA
      GOTO (10,20),KEIN1
  40  CONTINUE
C--------------------------------------------------------------------
C  ENDE DER VERLUSTITERATION
C  BERECHNEN WEITERER AUSGABE-DATEN
C--------------------------------------------------------------------
      CALL KAPPA(T2,CPSTA,CAPSTA)
      A2     = SQRT(CAPSTA*R*T2)
      MAC2   = C2/A2
      DELALF = ALF2-ALF1
      C2Z1   = C2/C1
      CAX2Z1 = CAX2/CAX1

      FSTAT( 1)=KEIN1
      FSTAT( 2)=NRED
      FSTAT( 3)=PI
      FSTAT( 4)=BLG2
      FSTAT( 5)=BLN2
      FSTAT( 6)=RM1
      FSTAT( 7)=RM2
      FSTAT( 8)=RM3
      FSTAT( 9)=RG1
      FSTAT(10)=RG2
      FSTAT(11)=RN1
      FSTAT(12)=RN2
      FSTAT(13)=RMGEO2
      FSTAT(14)=RGGEO1
      FSTAT(15)=RGGEO2
      FSTAT(16)=RNGEO1
      FSTAT(17)=RNGEO2
      FSTAT(18)=F2
      FSTAT(19)=FGEO2
      FSTAT(20)=A2
      FSTAT(21)=AS1
      FSTAT(22)=AS2
      FSTAT(23)=C1
      FSTAT(24)=C2
      FSTAT(25)=CAX1
      FSTAT(26)=CAX2
      FSTAT(27)=CR1
      FSTAT(28)=CR2
      FSTAT(29)=CU1
      FSTAT(30)=CU2
      FSTAT(31)=U1
      FSTAT(32)=U2
      FSTAT(33)=LAC1
      FSTAT(34)=LAC2
      FSTAT(35)=LACAX2
      FSTAT(36)=MAC1
      FSTAT(37)=MAC2
      FSTAT(38)=ALF1
      FSTAT(39)=ALF2
      FSTAT(40)=DELALF
      FSTAT(41)=ALFZ1
      FSTAT(42)=ALFZ2
      FSTAT(43)=LAMB1
      FSTAT(44)=LAMB2
      FSTAT(45)=C2Z1
      FSTAT(46)=CAX2Z1
      FSTAT(47)=M
      FSTAT(48)=R
      FSTAT(49)=REA
      FSTAT(50)=DELT
      FSTAT(51)=CAP1
      FSTAT(52)=CP1
      FSTAT(53)=CAP2
      FSTAT(54)=CP2
      FSTAT(55)=TT1
      FSTAT(56)=TT2
      FSTAT(57)=T1
      FSTAT(58)=T2
      FSTAT(59)=PT1
      FSTAT(60)=PT2
      FSTAT(61)=P1
      FSTAT(62)=P2
      FSTAT(63)=KSEC
      FSTAT(64)=KSPA
      FSTAT(65)=EPSEB
      FSTAT(66)=EPSWA
      FSTAT(67)=EPSRA
      FSTAT(68)=BAX
      FSTAT(69)=DZL
      FSTAT(70)=HZL
      FSTAT(71)=TZL
      FSTAT(72)=XL
      FSTAT(73)=SSP
      FSTAT(74)=KRAUH
      FSTAT(75)=LAMWA
      FSTAT(76)=D
      FSTAT(77)=OM
      FSTAT(78)=L
      FSTAT(79)=RE
      FSTAT(80)=OPIK
      FSTAT(81)=OPIKK
      FSTAT(82)=OPKO
      FSTAT(83)=OPKOK
      FSTAT(84)=OWA
      FSTAT(85)=OWAK
      FSTAT(86)=OSEC
      FSTAT(87)=OSECK
      FSTAT(88)=OSPA
      FSTAT(89)=OSPAK
      FSTAT(90)=OSTOS
      FSTAT(91)=OGES
      FSTAT(92)=OGESK
      FSTAT(93)=ZETA
      FSTAT(94)=KALF


      END

      SUBROUTINE KAPPA(T,CP,CAP)
C
C****************************************************
C
C  AUFGABEN DES UNTERPROGRAMMS  K A P P A :
C     - BERECHNEN DER SPEZIFISCHEN WAERMEKAPAZITAET
C          ALS POLYNOM 5. ORDNUNG IN ABHAENGIGKEIT
C          VON DER TEMPERATUR
C     - BERECHNEN DES ISENTROPENEXPONENTEN AUS DER
C          SPEZIFISCHEN WAERMEKAPAZITAET
C
C  AUFRUFENDE PROGRAMME :
C     MITTEL, ROTOR, STATOR
C
C****************************************************
C
      REAL A0,A1,A2,A3,A4,A5,CAP,CP,R,T
C
      R  = 287.05
      A0 = 993.5565
      A1 = 0.16540021
      A2 = -1.19011520E-3
      A3 = 3.41404410E-6
      A4 = -3.42837900E-9
      A5 = 1.18926110E-12
C
      CP = A0+A1*T+A2*T**2+A3*T**3+A4*T**4+A5*T**5
      CAP= CP/(CP-R)

      END

      SUBROUTINE FKAPPA(CAP,CAPP,CAPM,CAPIS)
C
C*****************************************************
C
C  AUFGABE DES UNTERPROGRAMMS  F K A P P A :
C     BERECHNEN VON HAEUFIG BENUTZTEN FUNKTIONEN VON
C     KAPPA
C
C  AUFRUFENDE PROGRAMME :
C     MITTEL, ROTOR, STATOR, VLUSTE, OMPROF, OMSTOS
C
C*****************************************************
C
      REAL CAP,CAPP,CAPM,CAPIS
C
      CAPP  = CAP+1.
      CAPM  = CAP-1.
      CAPIS = CAP/CAPM
      END

      SUBROUTINE GEO(LACAX,LAC,BLG,BLN,F,FGEO,RG,RGGEO,RM,
     #           RMGEO,RN,RNGEO,PI,R,M,CAP,CAPP,CAPM,TT,PT)
C
C************************************************************
C
C  AUFGABE DES UNTERPROGRAMMS  G E O :
C     BERECHNEN VON RINGRAUMGROESSEN ( EFFEKTIVE UND
C     GEOMETRISCHE RADIEN, DURCHSTROEMTE FLAECHE )
C     MIT HILFE DER KONTIGLEICHUNG, WENN CAX UND RM
C     GEGEBEN SIND
C
C  AUFRUFENDE PROGRAMME :
C     MITTEL, ROTOR, STATOR
C
C************************************************************
C
      REAL  BLG,BLN,CAP,CAP1,CAP2,CAPM,CAPP,F,FBL,FGEO,LAC,
     #      LACAX,M,MRED,PI,PT,R,RG,RGGEO,RM,RMGEO,RN,RNGEO,TT
C
      CAP1  = SQRT(2.*CAP/(CAPP*R))
      CAP2  = CAPM/CAPP
      MRED  = CAP1*LACAX*(1.-CAP2*LAC**2)**(1./CAPM)
      F     = M*SQRT(TT)/(PT*MRED)
      RG    = SQRT(RM**2+F/(2.*PI))
      RN    = SQRT(RM**2-F/(2.*PI))
      FBL   = 1.-BLN-BLG
      RGGEO = SQRT(((1.-BLN)*RG**2-BLG*RN**2)/FBL)
      RNGEO = SQRT(((1.-BLG)*RN**2-BLN*RG**2)/FBL)
      RMGEO = SQRT((RNGEO**2+RGGEO**2)/2.)
      FGEO  = PI*(RGGEO**2-RNGEO**2)
      RETURN
      END

      SUBROUTINE CAXIT(KALF,TT,PT,M,F,PI,R,CAP,CAPP,CAPM,
     #           AS,ALF,ALFZ,LAMB,CU,CAX,CR,C,LACAX,LAC)
C
C*********************************************************
C
C  AUFGABE DES UNTERPROGRAMMS  C A X I T :
C     ITERATION DER AXIALGESCHWINDIGKEIT MIT HILFE
C     DER KONTIGLEICHUNG UND BERECHNUNG DER ABSOLUT-
C     GESCHWINDIGKEIT UND IHRER KOMPONENTEN
C
C  AUFRUFENDE PROGRAMME :
C     MITTEL, ROTOR, STATOR
C
C*********************************************************
C
      INTEGER KALF
      REAL    ALF,ALFZ,AS,C,CAP,CAP1,CAP2,CAP3,CAPM,CAPP,

     #        CAX,CR,CU,CZ,F,LAC,LACAX,LACAX1,LACR,LACU,
     #        LAMB,M,MRED,PI,PT,R,TT
C
C
C  BESETZEN VON KONSTANTEN
C
      MRED   = M*SQRT(TT)/(PT*F)
      CAP1   = SQRT(CAPP*R/(2.*CAP))
      CAP2   = CAPM/CAPP
      CAP3   = 1./CAPM
C---------------------------------------------------------
C  BEGINN DER ITERATION AUF LACAX
C---------------------------------------------------------
      LACAX1 = 0.6
      IF(KALF.NE.1) LACU = CU/AS
  10  IF(KALF.EQ.1) THEN
         IF(ABS(ABS(ALFZ)-PI/2.).LE.0.0001) LACU = 0.
         IF(ABS(ABS(ALFZ)-PI/2.).GT.0.0001) LACU = LACAX1/TAN(ALFZ)
      END IF
      LACR   = LACAX1*TAN(LAMB)
      LAC    = SQRT(LACU**2+LACAX1**2+LACR**2)
      IF((CAP2*LAC**2).GE.0.99) GOTO 25
      LACAX  = MRED*CAP1/(1.-CAP2*LAC**2)**CAP3
      IF(ABS(LACAX1-LACAX).LT.0.0001) GOTO 20
      LACAX1 = LACAX
      GOTO 10
C---------------------------------------------------------
C  BERECHNUNG DER ABSOLUTGESCHWINDIGKEIT UND IHRER
C  KOMPONENTEN
C---------------------------------------------------------
   25 LACAX=0.99
      WRITE(2,30) CAX,LACAX,M,F
   20 CONTINUE
      LACR   = LACAX*TAN(LAMB)
      LAC    = SQRT(LACU**2+LACAX**2+LACR**2)
      CR     = LACR*AS
      C      = LAC*AS
      CAX    = LACAX*AS
      CZ     = SQRT(C**2-CR**2)
      IF(KALF.EQ.1) THEN
         CU  = LACU*AS
      ELSE
         ALFZ= ACOS(CU/CZ)
      END IF
      ALF    = ACOS(CU/C)
      RETURN
   30 FORMAT(1X,'DURCHSATZ ZU GROSS (CAX,LACAX,M,F)',4F10.5)
      END

      SUBROUTINE WREL(U,CU,CAX,CR,TTREL,PI,R,CAPREL,WU,W,LAW,
     #           BET,BETZ)
C
C************************************************************
C
C  AUFGABE DES UNTERPROGRAMMS  W R E L :
C     BERECHNEN DER RELATIVGESCHWINDIGKEIT W UND IHRER
C     KOMPONENTEN
C
C  AUFRUFENDES PROGRAMM :
C     ROTOR
C
C************************************************************
C
      REAL  ASREL,BET,BETZ,CAPREL,CAX,CR,CU,LAW,PI,R,TTREL,U,
     #      W,WU,WZ
C
      WU    = U-CU
      WZ    = SQRT(CAX**2+WU**2)
      W     = SQRT(WZ**2+CR**2)
      BET   = PI-ACOS(WU/W)
      BETZ  = PI-ACOS(WU/WZ)
      ASREL = SQRT(2.*CAPREL*R*TTREL/(CAPREL+1.))
      LAW   = W/ASREL
      END

      SUBROUTINE BLOCK(KMAX,JMAX,J1,KALF,KGIT,BLGE,BLGA,BLNE,
     #           BLNA,BLG,BLN)
C
C************************************************************
C
C  AUFGABE DES UNTERPROGRAMMS  B L O C K :
C     BERECHNEN DER BLOCKAGE-FAKTOREN AN NABE UND GEHAEUSE
C     UNTER FOLGENDEN ANNAHMEN :
C     -  STUFENWEISE LINEARE AUFTEILUNG
C     -  INNERHALB DER STUFE: AENDERUNG NUR UEBER DEN STATOR
C
C  AUFRUFENDES PROGRAMM :
C     MITTEL
C
C************************************************************
C
      INTEGER I1,J,J1,J2,J3,J5,JMAX,KALF(20),KGIT(20),KMAX
      REAL    BLG(20),BLGA,BLGE,BLN(20),BLNA,BLNE,DELBLG,DELBLN
C
C
C  BESTIMMUNG DER ERSTEN ROTOREINTRITTSEBENE J2 UND DER
C  LETZTEN ROTOREINTRITTSEBENE J5
C
      I1 = 0
      DO 10 J=1,J1
         IF(KGIT(J).EQ.1) J5 = J
         IF(I1.EQ.1) GOTO 10
         IF(KGIT(J).EQ.1) THEN
            J2 = J
            I1 = 1
         END IF
  10  CONTINUE
C
C  BERECHNUNG DER BLOCKAGEFAKTOR-AENDERUNG PRO STUFE
C
      IF (KMAX.GT.1) THEN
         DELBLG = (BLGA-BLGE)/(KMAX-1.)
         DELBLN = (BLNA-BLNE)/(KMAX-1.)
      ENDIF
C
C  BESETZEN DER BLOCKAGE-FAKTOREN BIS EBENE J2 MIT DEN
C  EINTRITTSWERTEN
C
      DO 30 J=1,J2
         BLG(J) = BLGE
         BLN(J) = BLNE
  30  CONTINUE
C
C  BERECHNEN DER BLOCKAGE-FAKTOREN VON EBENE J2 BIS J3
C  GEMAESS VORAUSGESETZTEM VERLAUF
C
      J3 = J5-1
      DO 40 J=J2,J3
         IF(KALF(J).EQ.1.OR.KGIT(J).EQ.1) THEN
            BLG(J+1) = BLG(J)
            BLN(J+1) = BLN(J)
         ELSE
            BLG(J+1) = BLG(J)+DELBLG
            BLN(J+1) = BLN(J)+DELBLN
         END IF
  40  CONTINUE
C
C  BESETZEN DER BLOCKAGE-FAKTOREN AB EBENE J5 MIT DEN
C  AUSTRITTSWERTEN
C
      DO 50 J=J5,JMAX
         BLG(J) = BLGA
         BLN(J) = BLNA
  50  CONTINUE
      END

      SUBROUTINE VLUSTE(KGIT,PI,RM1,RG1,RN1,RGGEO1,RGGEO2,RNGEO1,
     #           RNGEO2,C1,C2,CAX1,CAX2,CR1,CR2,CU,LA1,MA1,U1,
     #           BET1,BET2,BETZ1,BETZ2,LAMB,R,CAP,TT1,TT2,T1,T2,P1,P2,
     #           KSEC,KSPA,EPSEB,EPSRA,EPSWA,BAX,DZL,HZL,TZL,XL,
     #           SSP,KRAUH,LAMWA,D,OM,L,RE,OPIK,OPIKK,OPKO,OPKOK,
     #           OWA,OWAK,OSEC,OSECK,OSPA,OSPAK,OSTOS,OGES,OGESK,ZETA,
     #           PIVERL)
C
C*********************************************************************
C
C  AUFGABE DES UNTERPROGRAMMS  V L U S T E :
C     BERECHNUNG DER VERLUSTBEIWERTE OMEGA UND ZETA SOWIE
C     VON PIVERL
C
C  VERWENDETE UNTERPROGRAMME :
C     FKAPPA, OMPROF, OMSKSP, OMSTOS, OMWAND, REKORR, REYNOZ
C
C  AUFRUFENDE PROGRAMME :
C     ROTOR, STATOR
C
C*********************************************************************
C
      INTEGER KGIT
      REAL    BAX,BETS,BET1,BET2,BETZ1,BETZ2,BT1,BT2,BTZ1,BTZ2,C1,C2,
     #        CAP,CAPIS,CAPM,CAPP,CAX1,CAX2,CR,CR1,CR2,CU,CU1,CU2,CUN,
     #        CUNZ,D,DCU,DZL,EPSEB,EPSRA,EPSWA,FLA1,H,HZL,KRAUH,KSEC,
     #        KSPA,L,LA1,LAMB,LAMWA,LZ,MA1,OGES,OGESK,OGESKO,OM,OPIK,
     #        OPIKK,OPKO,OPKOK,OSEC,OSECK,OSPA,OSPAK,OSTOS,OWA,OWAK,P1,
     #        P2,PI,PIVERL,R,RE,REZRES,RHO1,RHO2,RG1,RGGEO1,
     #        RGGEO2,RM1,RN1,RNGEO1,RNGEO2,SSP,T1,T2,TT1,TT2,TZL,
     #        U1,X1,X2,XL,Y1,Y2,ZETA,ZETAO,ZETSTO
C
C  WINKELUMRECHNUNG FUER DAS ROTORGESCHWINDIGKEITS-DREIECK
C
      IF (KGIT.EQ.1) THEN
          BT1   = PI - BET1
          BT2   = PI - BET2
          BTZ1  = PI - BETZ1
          BTZ2  = PI - BETZ2
      ELSE IF (KGIT.EQ.2)   THEN
          BT1   =  BET1
          BT2   =  BET2
          BTZ1  =  BETZ1
          BTZ2  =  BETZ2
      END  IF
C
C   S.18    z.15  AB HIER VON ANDREAS ASCHERL ERSTELLT
C
C    BERECHNUNG VON SCHAUFEL - ABMESSUNGEN
C
         H     =  0.5*(RGGEO1 + RGGEO2 - RNGEO1 - RNGEO2)
         BETS  =  0.5*(BTZ1 + BTZ2 + 0.10472)
         LZ    =  BAX * XL/SIN(BETS)
         L     =  LZ/COS(LAMB)
         HZL   =  H/LZ
C
C    BERECHNUNG VON DELTA - CU,  C - UNENDLICH UND DER DICHTE
C
             IF (BTZ1.GE.(PI/2.))    CU1  =  0.
             IF (BTZ1.LT.(PI/2.))    CU1  =  CAX1/TAN(BTZ1)
             IF (BTZ2.GE.(PI/2.))    CU2  =  0.
             IF (BTZ2.LT.(PI/2.))    CU2  =  CAX2/TAN(BTZ2)
             DCU   =  ABS(CU2 - CU1)
             CUNZ  =  0.5 * SQRT((CAX1 + CAX2)**2 + (CU1 + CU2)**2)
             CR    =  0.5* (CR1 + CR2)
             CUN   =  SQRT (CUNZ**2 + CR**2)
             RHO1  =  P1/(R*T1)
             RHO2  =  P2/(R*T2)
C---------------------------------------------------------------------
C    BERECHNEN DER UNKORRIGIERTEN OMEGA-VERLUSTBEIWERTE IN 
C    UNTERPROGRAMMEN
C---------------------------------------------------------------------
            CALL OMPROF (BT1,BT2,C1,C2,DCU,CAX1,CAX2,LA1,MA1,RHO1,
     #                  RHO2,TT1,TT2,CAP,TZL,DZL,D,OM,OPIK,OPKO,PI)
           CALL OMWAND(LAMWA,CUN,C1,L,H,OWA)
           CALL OMSKSP(KSEC,KSPA,CAX1,CAX2,DCU,CUN,C2,SSP,H,OSEC,OSPA)
            IF (KGIT.EQ.1)  CALL OMSTOS(CAP,RN1,RM1,RG1,U1,CAX1,CU,
     #      TT1,OSTOS)
            IF (KGIT.EQ.2)      OSTOS  =  0.
            IF (OPKO.GE.OSTOS)  OSTOS  =  0.
            IF (OPKO.LT.OSTOS)  OSTOS  =  OSTOS - OPKO
C---------------------------------------------------------------------
C    REYNOLDSZAHL-KORREKTUR DER OMEGA-VERLUST-BEIWERTE UND 
C    BERECHNUNG VON OMEGA-GESAMT
C---------------------------------------------------------------------
            CALL  REYNOZ(C1,L,RHO1,T1,KRAUH,RE,REZRES)
            CALL  REKORR(REZRES,OPIK,OPIKK,OPKO,OPKOK,EPSEB,OWA,OWAK,
     #                             EPSWA,OSEC,OSECK,OSPA,OSPAK,EPSRA)
C
             OGES   =  OPIK + OPKO + OWA + OSEC + OSPA + OSTOS
             OGESK  =  OPIKK + OPKOK + OWAK + OSECK + OSPAK + OSTOS
             OGESKO =  OGESK - OSTOS
C
C   BERECHNUNG DES ZETA-VERLUSTBEIWERTES UND VON PIVERL
C
            CALL  FKAPPA(CAP,CAPP,CAPM,CAPIS)
            FLA1   =  1. - CAPM/CAPP*LA1**2
            X1     =  1. - ((TT1/TT2)**CAPIS)*(1.-FLA1**CAPIS)*OGESKO
            X2     =  (FLA1*TT1/TT2)**CAPIS
            ZETAO  =  ALOG(X1)/ALOG(X2)
C
            Y1  =  1.-(1.-FLA1**CAPIS)*OSTOS
            Y2  =  FLA1**CAPIS
            IF (OSTOS.LE.0.)   ZETSTO  =  0.
            IF (OSTOS.GT.0.)   ZETSTO  =  ALOG(Y1)/ALOG(Y2)
C
            ZETA    =  ZETAO + ZETSTO
            PIVERL  =  ((1.-CAPM/CAPP*LA1**2)*TT1/TT2)**(CAPIS*ZETA)
            END

C---------------------------------------------------------------------
         SUBROUTINE OMPROF(BT1,BT2,C1,C2,DCU,CAX1,CAX2,LA1,MA1,RHO1,
     #                    RHO2,TT1,TT2,CAP,TZL,DZL,D,OM,OPIK,OPKO,PI)
C
C---------------------------------------------------------------------
C
C    AUFGABE DES UNTERPROGRAMMS   O M P R O F  :
C           BERECHNEN DES STROMDICHTEVERHAELTNISSES  OM, DER
C           DIFFUSIONSZAHL  D  UND DER UNKORRIGIERTEN KOMPRESSIBLEN
C           UND INKOMPRESSIBLEN PROFILVERLUSTE
C
C    VERWENDETES UNTERPROGRAMM  :
C           FKAPPA
C
C    AUFRUFENDES PROGRAMM  :
C           VLUSTE
C
C---------------------------------------------------------------------
C
       REAL       BT1,BT2,CAP,CAPIS,CAPM,CAPP,CAX1,CAX2,CMZC1,C1,C2,
     #            D,DB,DCU,DZL,FLA1,K,K10,K12,LA1,MA1,MA1K,MA1X,OM,
     #            OPIK,OPKO,PI,RHO1,RHO2,THETZL,TT1,TT2,TZL
C
      CALL  FKAPPA(CAP,CAPP,CAPM,CAPIS)
      FLA1  =  1.-CAPM/CAPP*LA1**2
C
C     BERECHNUNG DES STROMDICHTE-VERHAELTNISSES
C
            OM  =  (CAX2*RHO2)/(CAX1*RHO1)
            IF (OM.GT.1.2)  OM  =  1.2          
            IF (OM.LT.1.0)  OM  =  1.0
C---------------------------------------------------------------------        
C     BERECHNUNG DER INKOMPRESSIBLEN PROFIL-VERLUSTE
C---------------------------------------------------------------------
      IF(BT2-BT1)   10,20,30
C
C     FUER UMLENKUNG  <  0  :
C 
  10    OPIK   =  ((TT2/TT1)**CAPIS*(1.-(FLA1*TT1/TT2)**(0.01*CAPIS)))/
     #                      (1.-(FLA1**CAPIS))
      OPKO   =  0.
      D      =  0.
      RETURN
C
C     FUER UMLENKUNG  =  0   :
C
   20 OPIK  =  0.
      D     =  0.
      RETURN
C
C     FUER UMLENKUNG  >  0  
C
   30       CMZC1   =  1.03+(0.4+DZL)*TZL*DCU/C1+0.7*DZL
      D             =  CMZC1-C2/C1
      THETZL =(6.6*DZL+0.34)*(0.0088+0.0107*D-0.052*D**2+0.116*D**3)
      OPIK      =  2.*THETZL/(TZL*SIN(BT2))*(SIN(BT1)/SIN(BT2))**2
C---------------------------------------------------------------------
C     BERECHNUNG   DER KOMPRESSIBLEN PROFIL-VERLUSTE
C---------------------------------------------------------------------
      MA1K  =  SQRT(2./CAPM*((CMZC1**2/((2./CAPP)**CAPIS+CMZC1**2
     #                    -1.))**(CAPM/CAP)-1.))
      IF (MA1.LE.MA1K)  THEN
            OPKO  =  0.
            RETURN
      END IF
      DB    =  (BT2-BT1)*180./PI
      IF(MA1.GE.1.)   MA1X   =  1.
      IF(MA1.LT.1.)   MA1X   =  MA1
      IF(DB.LE.3.)   THEN
            K  =  0.1
      ELSE  IF (DB.GE.45.)  THEN
            K  =  2.4
      ELSE
      IF(DB.GE.32.)  K10  =  2.4
      IF(DB.LT.32.)  K10  =  2.51371-3.18602*SQRT(DB)+1.15161*DB
     #                           -0.02938*DB**2+0.00034*DB**3
      IF(DB.GE.26.)  K12  =  0.26842+0.04737*DB       
      IF(DB.LT.26.)  K12  =  -0.86528+0.91708*SQRT(DB)-0.23039*DB
     #                           +0.00784*DB**2-0.00009*DB**3
            K   =  (K10-K12)/(1.-1.2)*(OM-1.2)+K12
      END IF
      OPKO  =  K*(MA1X-MA1K)**2
      END

C
            SUBROUTINE   OMWAND (LAMWA,CUN,C1,L,H,OWA)
C
C---------------------------------------------------------------------
C
C     AUFGABE DES UNTERPROGRAMMS   O M W A N D  :
C           BERECHNEN DER UNKORRIGIERTEN SEITENWAND--
C           REIBUNGSVERLUSTE
C
C     AUFRUFENDES PROGRAMM  :
C           VLUSTE
C
C---------------------------------------------------------------------
C
            REAL  CUN,C1,H,L,LAMWA,OWA                      
C
            OWA   =  0.5*LAMWA*L/H*(CUN/C1)**2
            END
C
C
C
C
      SUBROUTINE   OMSKSP (KSEC,KSPA,CAX1,CAX2,DCU,CUN,C2,SSP,
     #                            H,OSEC,OSPA)
C
C---------------------------------------------------------------------
C
C     AUFGABE DES UNTERPROGRAMMS   O M S K S P  :
C           BERECHNEN DER UNKORRIGIERTEN SEKUNDAER--
C           UND SPALT--VERLUSTE
C
C     AUFRUFENDES PROGRAMM  :
C           VLUSTE
C
C---------------------------------------------------------------------
C
            REAL  CAX1,CAX2,CUN,C2,DCU,H,KSEC,KSPA,OSEC,OSPA,
     #                  SSP
C
            OSEC  =  (4.*KSEC*DCU*(CUN/C2)**2)/(CAX1+CAX2)
            OSPA  =  (4.*KSPA*DCU*SSP*(CUN/C2)**2)/((CAX1+CAX2)*H)
            END
C
C
C
C
      SUBROUTINE  OMSTOS (CAP,RN,RM,RG,UM,CAXM,CU1,TTRELM,OSTOS)
C
C---------------------------------------------------------------------
C
C     AUFGABE DES UNTERPROGRAMMS  O M O S T O S  :
C           BERECHNEN DER STOSSVERLUSTE EINES ROTORS DURCH
C           INTEGRATION UEBER 5 RADIALE SCHNITTE
C
C     VERWENDETES UNTERPROGRAMM  :
C           FKAPPA
C
C     AUFRUFENDES PROGRAMM  :
C           VLUSTE
C
C---------------------------------------------------------------------
C
            INTEGER     I
            REAL  ASREL,CAP,CAPIS,CAPM,CAPP,CAXM,CUM,CU1,DR,
     #                  FLA1(5),FLA2(5),LAW(5),OMSTO(5),OSTOS,R(5),RG,
     #                  RM,RN,RS,TTRELM,UM,W(5),X1,X2
C
            CALL  FKAPPA (CAP,CAPP,CAPM,CAPIS)
C
C     BERECHNUNG DES RADIUS  RS,  IN DEM MA1  =  1  GILT
C
            ASREL     =  SQRT(2.*CAP*287.05*TTRELM/CAPP)
            CUM       =  ABS(CU1)
            X1        =   ASREL**2+2.*UM*CUM-CAXM**2
            X2        =   X1/(2.*UM**2)
            RS        =    RM*SQRT(X2+SQRT(X2**2-(CUM/UM)**2))
C
C     KEINE STOSSVERLUSTE ,  WENN   RS  >  RG
C
            IF(RS.GT.(RG-0.005))   THEN
                  OSTOS  =  0.
                  RETURN
            END   IF
C
C     BERECHNUNG DER STOSSVERLUSTE IN 5 RADIALEN SCHNITTEN
C
      IF(RS.LE.RN)  RS  =   RN
            OSTOS     =  0.
            DR        =  (RG-RS)/4.
            DO  10  I =  1,5
            R(I)      =  RS+(I-1)*DR
            W(I)      =  SQRT(CAXM**2+(UM*R(I)/RM-CUM*RM/R(I))**2)
            LAW(I)    =  W(I)/ASREL
            FLA1(I)   =  1.-CAPM/CAPP*LAW(I)**2
            FLA2(I)   =  1.-CAPM/CAPP/LAW(I)**2
         OMSTO(I)  =  (1.-LAW(I)**2*(FLA1(I)/FLA2(I))**(1./CAPM))/
     #                             (1.-FLA1(I)**CAPIS)
      IF  (I.EQ.1)   GOTO  10
            OSTOS  =  OSTOS+0.5*(OMSTO(I)+OMSTO(I-1))
   10 CONTINUE
C
C     VERTEILEN DER STOSSVERLUSTE UEBER DIE GANZE KANALHOEHE
C
            OSTOS  =  OSTOS*DR/(RG-RN)
            END
C
C
C
C
      SUBROUTINE  REYNOZ (C1,L,RHO1,T1,KRAUH,RE,REZRES)
C
C---------------------------------------------------------------------
C
C     AUFGABE DES UNTERPROGRAMMS  R E Y N O Z  :
C           -  BERECHNUNG DER REYNOLDSZAHL DER GITTERSTROEMUNG
C              MIT DER DYNAMISCHEN VISKOSITAET NACH SUTHERLAND
C           -  BERECHNUNG DES ZUR VERLUSTKORREKTUR ZU VERWENDENDEN
C              REYNOLDSZAHL--VERHAELTNISSES     
C
C     AUFRUFENDES PROGRAMM  :
C           VLUSTE
C
C---------------------------------------------------------------------
C
            REAL  C1,KRAUH,L,MUEO,MUE,RE,REK,REKORR,RES,REZRES,
     #                                           RHO1,T0,T1,TC
C
            MUEO       =  1.677E-5
            TC         =   123.6
            T0         =  273.
            MUE        =   MUEO*SQRT(T1/T0)*(1.+TC/T0)/(1.+TC/T1)
C
            RE         =  C1*L*RHO1/MUE
            RES        =  3.3E5
            REK        =  RE*KRAUH/L
        IF (REK.LT.90) THEN
                REZRES = RE/RES
        ELSE
            IF(KRAUH.LT.1.E-8)   REKORR  =  3.E8
            IF(KRAUH.GE.1.E-8)   REKORR  =  90.*L/KRAUH
            REZRES     =  REKORR/RES
      END  IF 
      END
C
C
C
      SUBROUTINE  REKORR (REZRES ,OPIK,OPIKK,OPKO,OPKOK,EPSEB,
     #                  OWA,OWAk,EPSWA,OSEC,OSECK,OSPA,OSPAK,EPSRA)
C
C---------------------------------------------------------------------
C
C     AUFGABE DES UNTERPROGRAMMS  R E K O R R   :
C           KORREKTUR DER UNKORRIGIERTEN OMEGA--VERLUSTBEIWERTE      
C           ANHAND DER REYNOLDSZAHL
C
C     AUFRUFENDES PROGRAMM  :
C           VLUSTE
C
C---------------------------------------------------------------------
C
      REAL  EPSEB,EPSRA,EPSWA,OPIK,OPIKK,OPKO,OPKOK,OSEC,
     #      OSECK,OSPA,OSPAK,OWA,OWAK,REZRES
C
      IF (EPSEB.GT.0.)  THEN
            OPIKK  =  OPIK*REZRES**(-EPSEB)
            OPKOK  =  OPKO*REZRES**(-EPSEB)
      ELSE
            OPIKK  =  OPIK
            OPKOK  =  OPKO
      END  IF
      IF  (EPSWA.GT.0.)  OWAK  =  OWA*REZRES**(-EPSWA)
      IF  (EPSWA.LE.0.)  OWAK  =  OWA
      IF  (EPSRA.GT.0.)  THEN
            OSECK  =  OSEC*REZRES**(-EPSRA)
            OSPAK  =  OSPA*REZRES**(-EPSRA)
      ELSE
            OSECK  =  OSEC
            OSPAK  =  OSPA
      END  IF 
      END
C
C
C
C
      SUBROUTINE  DRALL (RM,RN,RG,F,TTM,PTM,R,PI,CUM,KGIT,CAXM,UM,
     #            JMAX,CAP,DZL,TZLM,TM,PM,BAX,M1,M2,KABBL,KRAD,KAUS)
C
C---------------------------------------------------------------------
C
C    AUFGABEN DES UNTERPROGRAMMS   D R A L L   :
C     -  ABSCHAETZEN DER GITTERBELASTUNG IN 5 RADIALEN
C        SCHNITTEN FUER LJ 5 VERSCHIEDENE DRALL-- UND TOTAL--
C        TEMPERATUR--VERTEILUNGEN MIT DER GLEICHUNG DES
C        EINFACHEN RADIALEN GLEICHGEWICHTS
C     -  BESTIMMUNG DER DRALL-- UND TOTALTEMPERATUR--VERTEILUNG,
C        FUER DIE SICH DIE GERINGSTE GITTERBELASTUNG
C       ( DIFFUSIONSZAHL ) ERGIBT
C
C    AUFRUFENDES PROGRAMM  :
C           MITTEL
C
C---------------------------------------------------------------------
C
      INTEGER     EXP,I,I1,I2,IQ,IQMIN,IT,ITMIN,J,J1,JJ,JMAX,KABBL,
     #            KAUS,KGIT(20),KRAD
      REAL  ALF(5,20),BAX(20),BET(5,20),CAP(20),CAPIS,CAXM(20),
     #            CAX(5,20),CMZC1,CR(5,20),C(5,20),CUM(20),CU(5,20),
     #            CU1,CU2,C2Z1(5,20),DALF(5,20),DBET(5,20),DCAX,
     #            DCU,DELH(5,20),DMAX(5,5,20),DMIN,D(5,20),DWU,DZL(20),
     #            F(20),FAX,FPI,LAMB(5,20),LAMBA(5,20),M,M1,M2,
     #            MIST(20),PM(20),PHI(5,20),PI,PTM(20),PT(5,20),Q,R,
     #            REA(5,20),RG(20),RHO(20),RM(20),RN(20),RS(5,20),
     #            TM(20),TAU,TTM(20),TT(5,20),TZLM(20),TZL,UM(20),
     #            U(5,20),WMZW1,W(5,20),WU(5,20),WU1,WU2,W2Z1(5,20)
C
      J1  =  JMAX-1
      M  =  M1
C
C     BERECHNUNG DER AUF RM BEZOGENEN RADIEN DER 5  SCHNITTE
C
      DO  100  J  =  1, JMAX
            RS(1,J)  =  RN(J)/RM(J)
            RS(2,J)  =  SQRT(RN(J)**2+F(J)/(4.*PI))/RM(J)
            RS(3,J)  =  1.
            RS(4,J)  =  SQRT(RG(J)**2-F(J)/(4.*PI))/RM(J)
            RS(5,J)  =  RG(J)/RM(J)
  100    CONTINUE
C
C     BERECHNUNG DER STROMLINIEN--NEIGUNGSWINKEL IN
C     DEN SCHNITTEN
C
      DO  110  J  =  1,  JMAX
            DO  120   I  =  1 , 5
                  IF  (J.EQ.JMAX)   THEN
                        LAMB( I,J )  =  0.
                  ELSE  IF(KRAD.NE.1)  THEN
                        LAMB( I,J )  =  0.
                  ELSE  IF(KRAD.EQ.1)  THEN
                  LAMB( I,J )  =  ATAN((RS(I,J+1)*RM(J+1)-RS(I,J)
     #                              *RM(J))/BAX(J))
                  IF (ABS(LAMB(I,J)).LT.1.E-5)   LAMB(I,J)  =  0.
                  END  IF
                  LAMBA(I,J)  =  LAMB(I,J)*180./PI
  120             CONTINUE
  110 CONTINUE
C
C---------------------------------------------------------------------
C     SCHLEIFE FUER 5  VERSCHIEDENE DRALLGESETZ--EXPONENTEN  Q
C---------------------------------------------------------------------
C
      DO  200  IQ  = 1,5
            Q  =  -1.0 +(IQ-1)*0.5
            IF (KAUS.EQ.2)   THEN
                  WRITE(2,19)
                  WRITE(2,20)  Q
            END IF
C---------------------------------------------------------------------
C     SCHLEIFE FUER 5  VERSCHIEDENE  TOTALTEMPERATURVERTEILUNGEN
C---------------------------------------------------------------------
            DO  210  IT  = 1,5
                  IF(IT.EQ.1)   THEN
                        EXP  =  0
                        TAU  =  0.
                  ELSE  IF(IT.EQ.2)   THEN
                        EXP  =  1
                        TAU  =  2.
                  ELSE  IF(IT.EQ.3)   THEN
                        EXP  =  1
                        TAU  =  -2.
                  ELSE  IF(IT.EQ.4)   THEN
                        EXP  =  2
                        TAU  =  2.
                  ELSE  IF(IT.EQ.5)   THEN
                        EXP  =  2
                        TAU  =  -2.
                  END IF
                  IF  (KAUS.EQ.2)  WRITE(2,21)   EXP, TAU
C
C---------------------------------------------------------------------
C     EBENENWEISE BERECHNUNG DER ZUSTANDS-- UND STROEMUNGS--
C     GROESSEN IN 5  SCHRITTEN
C---------------------------------------------------------------------
            DO 130  J = 1,JMAX
                  IF (J.EQ.KABBL)  M  =  M2
                  CAPIS  =  CAP(J)/(CAP(J)-1.)
                  RHO(J) =  PM(J)/(R*TM(J))
                  JJ     =  J - 1
                  I1     =  1
C
  150       DO  140  I  = 1,5
                  IF (I1.EQ.2)  GOTO  170
C
C     BERECHNUNG VON GESAMTTEMPERATUR UND GESAMTDRUCK
C     IN EINEM SCHNITT
C
      IF(J.EQ.1)  THEN
            TT(I,J)  =  TTM(J)
      ELSE   IF (EXP.EQ.2)  THEN
      IF (I.LE.3)   TT(I,J)  =  TTM(J)*(1.+TAU/100.-3.*TAU/100.*
     #                   ((RS(I,J)-1.)/(RS(1,J)-1.))**2)
      IF (I.GT.3)   TT(I,J)  =  TTM(J)*(1.+TAU/100.-3.*TAU/100.*
     #                   ((RS(I,J)-1.)/(RS(5,J)-1.))**2)
      ELSE  IF (EXP.EQ.1)  THEN
      TT(I,J)  =  TTM(J)*(1.+TAU/100.*(RS(I,J)-1.)/(RS(5,J)-1.))
      ELSE  IF (EXP.EQ.0)  THEN
            TT(I,J)  =  TTM(J)
      END  IF
            PT (I,J)  =  PTM(J)*TT(I,J)/TTM(J)
C
C     BERECHNUNG DES GESCHWINDIGKEITSDREIECKS IN EINEM SCHNITT
C
            CU(I,J)  =  CUM(J)*RS(I,J)**Q
            IF  (Q.EQ.0.)   THEN
                  FAX  =  2./RHO(J)*(PT(I,J)-PTM(J))-
     #                  CUM(J)**2*LOG(RS(I,J)**2)
            ELSE
                  FAX  =  2./RHO(J)*(PT(I,J)-PTM(J))-
     #                  (Q+1.)/Q*(CU(I,J)**2-CUM(J)**2)
            END IF
            IF ((CAXM(J)**2+FAX).LE.0.) THEN
                  CAX(I,J) = 0.5*CAX(I-1, J)
            ELSE
                  CAX(I,J) = SQRT(CAXM(J)**2+FAX)
            END IF
C
  170       CR(I,J)     =  CAX(I,J)*TAN(LAMB(I,J))
            C(I,J)      =  SQRT(CAX(I,J)**2+CU(I,J)**2+CR(I,J)**2)
            ALF(I,J)    =  ACOS(CU(I,J)/C(I,J))
            U(I,J)      =  UM(J)*RS(I,J)
            PHI(I,J)    =  CAX(I,J)/U(I,J)
C
      IF  (J.EQ.1.AND.KGIT(1).EQ.2)    THEN
            WU(I,J)        =  0.
            W(I,J)         =  0.
            BET(I,J)       =  0.
      ELSE  IF (J.NE.JMAX)   THEN
            WU(I,J)      =  U(I,J)-CU(I,J)
            W(I,J)       =  SQRT(CAX(I,J)**2+WU(I,J)**2+CR(I,J)**2)
            BET(I,J)     =  PI-ACOS(WU(I,J)/W(I,J))
      ELSE
            WU(I,J)       =  0.
            W(I,J)        =  0.
            BET(I,J)      =  0.
            DALF(I,J)     =  0.
            DBET(I,J)     =  0.
            C2Z1(I,J)     =  0.
            W2Z1(I,J)     =  0.
            DELH(I,J)     =  0.
            REA(I,J)      =  0.
            D(I,J)        =  0.
      END  IF
C
C     BERECHNUNG DER DIFFUSIONSZAHL EINES SCHNITTES
C
      IF  (J.EQ.1)   GOTO  140
      IF  (KGIT(JJ).EQ.1)   THEN
            DALF(I,JJ)   =  0.
            C2Z1(I,JJ)   =  0.
            DELH(I,JJ)   =  CAPIS*R*(TT(I,J)-TT(I,JJ))
            REA(I,JJ)    =  1.-(CU(I,JJ)+DELH(I,JJ)/(U(I,JJ)+
     #                         U(I,J)))/U(I,J)  
            DBET(I,JJ)   =  BET(I,JJ)-BET(I,J)
            W2Z1(I,JJ)   =  W(I,J)/W(I,JJ)
            IF  (BET(I,J).LE.0.)   D(I,JJ)  =  0.
            IF  (BET(I,J).GT.0.)   THEN
                  IF  (BET(I,JJ).LE.(PI/2.))  WU1   =  0.
                  IF  (BET(I,JJ).GT.(PI/2.))  WU1   =  WU(I,JJ)
                  IF  (BET(I,J).LE.(PI/2.))   WU2   =  0.
                  IF  (BET(I,J).GT.(PI/2.))   WU2   =  WU(I,J)
                  DWU     =  ABS(WU2-WU1)
                  TZL     =  TZLM(JJ)*RS(I,JJ)
                  WMZW1   =  1.03+(0.4+DZL(JJ))*TZL*DWU/W(I,JJ)+
     #                         0.7*DZL(JJ)
                  D(I,JJ)      =  WMZW1-W(I,J)/W(I,JJ)
            END  IF
      ELSE  IF(KGIT(JJ).EQ.2)   THEN
                  W2Z1 (I,JJ)     =  0.
                  DBET (I,JJ)     =  0.
                  REA (I,JJ)      =  0.
                  DELH (I,JJ)     =  0.
                  DALF (I,JJ)     =  ALF(I,J)-ALF(I,JJ)
                  C2Z1 (I,JJ)     =  C(I,J)/C(I,JJ)
            IF (DALF(I,JJ).LE.0.)  D(I,JJ)  =  0.
            IF (DALF(I,JJ).GT.0.)   THEN
                  IF (ALF(I,JJ).GE.(PI/2.))    CU1  =  0.
                  IF (ALF(I,JJ).LT.(PI/2.))    CU1  =  CU(I,JJ)
                  IF (ALF(I,J).GE.(PI/2.))     CU2  =  0.
                  IF (ALF(I,J).LT.(PI/2.))     CU2  =  CU(I,J)
                  DCU     =  ABS(CU2-CU1)
                  TZL     =  TZLM(JJ)*RS(I,JJ)
                  CMZC1   =  1.03+(0.4+DZL(JJ))*TZL*DCU/C(I,JJ)+
     #                          0.7*DZL(JJ)
                  D(I,JJ)     =   CMZC1-C(I,J)/C(I,JJ)
            END  IF
      END  IF
      IF (D(I,JJ).LT.0.)   D(I,JJ)   =  0.
C
C     BESTIMMEN DER MAXIMALEN DIFFUSIONSZAHL EINER EBENE
C
      IF (I.EQ.1)   DMAX(IQ,IT,JJ)  =  D(I,JJ)
      IF (I.GT.1.AND.D(I,JJ).GT.DMAX(IQ,IT,JJ))   DMAX(IQ,IT,JJ)  =
     #                        D(I,JJ)
  140       CONTINUE
C
C     ITERATION AUF DEN GEGEBENEN MASSENSTROM
C
            MIST(J)   =  RHO(J)*F(J)/8.*(CAX(1,J)+2.*CAX(2,J)+    
     #                           2.*CAX(3,J)+2.*CAX(4,J)+CAX(5,J))
            IF (I1.EQ.1)  THEN
                  DCAX   =  (M-MIST(J))/(F(J)*RHO(J))
                  DO  160  I  = 1,5
                        CAX(I,J)  =  CAX(I,J) +DCAX
  160             CONTINUE
                  I1     =  2
                  GOTO  150
            END  IF
  130 CONTINUE
C---------------------------------------------------------------------
C     ENDE DER EBENENWEISE BERECHNUNG
C---------------------------------------------------------------------
C
C     UMRECHNUNG DER BERECHNETEN WINKEL INS GRADMASS
C
      FPI  =  180./PI
      I2   =  0
      DO  180  J  =  1,JMAX
            DO  190  I = 1,5
                  ALF(I,J)  = ALF(I,J)*FPI
                  IF (KGIT(J).EQ.2)  DALF(I,J)  =  DALF(I,J)*FPI
                  IF (KGIT(J).EQ.1)   THEN
                        DBET(I,J)  =  DBET(I,J)*FPI
                        BET(I,J)   =  BET(I,J)*FPI
                        BET(I,J+1) =  BET(I,J+1)*FPI
                  END  IF
  190 CONTINUE
C---------------------------------------------------------------------
C     AUSGABE IN ABHAENGIGKEIT VON KAUS
C---------------------------------------------------------------------
      IF (KAUS.EQ.2)   THEN
            IF (J.LT.JMAX)  WRITE(2,22)  J,(D(I,J),I=1,5)
            GOTO  180
      END  IF
      IF (I2.EQ.0)  WRITE(2,10)  J,EXP,TAU,Q
      IF (I2.EQ.1)  WRITE(2,18)  J,EXP,TAU,Q
      WRITE(2,14)  MIST(J)
      WRITE(2,11)
        WRITE(2,12) RS(1,J),RS(2,J),RS(3,J),RS(4,J),RS(5,J),
     #            TT(1,J),TT(2,J),TT(3,J),TT(4,J),TT(5,J),
     #            PT(1,J),PT(2,J),PT(3,J),PT(4,J),PT(5,J),
     #            CU(1,J),CU(2,J),CU(3,J),CU(4,J),CU(5,J),
     #            CAX(1,J),CAX(2,J),CAX(3,J),CAX(4,J),CAX(5,J),
     #            CR(1,J),CR(2,J),CR(3,J),CR(4,J),CR(5,J),
     #            C(1,J),C(2,J),C(3,J),C(4,J),C(5,J),
     #            ALF(1,J),ALF(2,J),ALF(3,J),ALF(4,J),ALF(5,J),
     #            LAMBA(1,J),LAMBA(2,J),LAMBA(3,J),LAMBA(4,J),
     #            LAMBA(5,J),
     #            WU(1,J),WU(2,J),WU(3,J),WU(4,J),WU(5,J),
     #            W(1,J),W(2,J),W(3,J),W(4,J),W(5,J)
        WRITE(2,13) BET(1,J),BET(2,J),BET(3,J),BET(4,J),BET(5,J),
     #            DALF(1,J),DALF(2,J),DALF(3,J),DALF(4,J),DALF(5,J),
     #            DBET(1,J),DBET(2,J),DBET(3,J),DBET(4,J),DBET(5,J),
     #            C2Z1(1,J),C2Z1(2,J),C2Z1(3,J),C2Z1(4,J),C2Z1(5,J),
     #            W2Z1(1,J),W2Z1(2,J),W2Z1(3,J),W2Z1(4,J),W2Z1(5,J),
     #            PHI(1,J),PHI(2,J),PHI(3,J),PHI(4,J),PHI(5,J),
     #            DELH(1,J),DELH(2,J),DELH(3,J),DELH(4,J),DELH(4,J),
     #            REA(1,J),REA(2,J),REA(3,J),REA(4,J),REA(5,J),
     #            D(1,J),D(2,J),D(3,J),D(4,J),D(5,J)
      IF (I2.EQ.0)   THEN
            I2  = 1
      ELSE
            I2  =  0
      END IF
  180   CONTINUE  
  210   CONTINUE  
  200   CONTINUE  
C---------------------------------------------------------------------
C     ENDE DER TEMPERATURVERTEILUNGS-- UND DER DRALL--
C     VERTEILUNGSSCHLEIFE
C---------------------------------------------------------------------
C     BESTIMMEN UND AUSDRUCKEN DES MINIMALEN DMAX JEDER EBENE
C     UND DER ZUGEHOERIGEN TEMPERATUR-- UND DRALLVERTEILUNG
C---------------------------------------------------------------------
      WRITE(2,23)
      DO  220  J  = 1,J1
            WRITE(2,15)  J
            DMIN  =  DMAX(1,1,J)
            ITMIN  = 1
            IQMIN  = 1
            DO  230  IQ  = 1,5
                  DO  240  IT  = 1,5
                  IF (DMAX(IQ,IT,J).LT.DMIN)  THEN
                        DMIN   =  DMAX(IQ,IT,J)
                        ITMIN  =  IT
                        IQMIN  =  IQ
                  END IF
 240  CONTINUE
            WRITE(2,16)  IQ,(DMAX(IQ,IT,J), IT = 1,5)
  230  CONTINUE
            WRITE(2,17)  DMIN,ITMIN,IQMIN
  220   CONTINUE
C
C     AUSGABEFORMATE
C
   10 FORMAT  ('1',4X,I2,'. EBENE',//,5X,'EXP = ',I2,5X,
     #            'TAU = ',F5.2,' %',5X,'Q = ',F5.2)
   11 FORMAT  (/,5X,'SCHNITT',9X,'N',11X,'NM',10X,'M',11X,
     #            'MG',10X,'G')
  12  FORMAT  (/,5X,'RS      ',5E12.5E1,/,5X,'TT     ',5E12.5E1,
     #         /,5X,'PT      ',5E12.5E1,
     #         /,5X,'CU      ',5E12.5E1,/,5X,'CAX    ',5E12.5E1,
     #         /,5X,'CR      ',5E12.5E1,/,5X,'C      ',5E12.5E1,
     #         /,5X,'ALF     ',5E12.5E1,/,5X,'LAMB   ',5E12.5E1,
     #         /,5X,'WU      ',5E12.5E1,/,5X,'W      ',5E12.5E1)
  13  FORMAT  (5X,'BET ',5E12.5E1,/,5X,'DALF     ',5E12.5E1,
     #         /,5X,'DBET     ',5E12.5E1,/,5X,'C2/C1    ',5E12.5E1,
     #         /,5X,'W2/W1    ',5E12.5E1,/,5X,'PHI      ',5E12.5E1,
     #         /,5X,'DELH     ',5E12.5E1,/,5X,'REA      ',5E12.5E1,
     #         /,5X,'D        ',5E12.5E1)
  14  FORMAT (/,5X,'MASSENSTROM   ',E10.5E1)
C
  15  FORMAT (///,5X,'DMAX--WERTE FUER GITTER  ',I2,
     #                 //,8X,'IT',4X'1',9X,'3',9X,'4',9X,'5',     
     #                 / ,5X,'IQ')
  16  FORMAT (5X,I2,5F10.5)
  17  FORMAT (//,5X,'DMIN  = ',F7.5,/,5X,'ITMIN  = ',I7 ,
     #             /,5X,'IQMIN  = ',I7)
  18  FORMAT (///,5X,I2,' . EBENE ',//5X,'EXP  = ',I2,5X,
     #                  'TAU    = ' ,F5.2, ' % ',5X, ' Q  = ' ,F5.2)
C
  19  FORMAT ( '1',4X,'DIFFUSIONSZAHL NACH FOTTNER ' )
  20  FORMAT (//,5X, ' Q   = ',F5.2)
  21  FORMAT (//,5X, 'EXP  = ',I2,5X, ' TAU  = ' ,F5.2,
     #         //,5X, 'SCHNITT' ,5X, '1',9X,'2',9X,'3',9X,'4',9X,'5',
     #         / ,5X, ' GITTER ')
  22  FORMAT (5X,I3,2X,5F10.5)
  23  FORMAT ( ' 1 ' )
      END
